/* Autogenerated: 'src/ExtractionOCaml/word_by_word_montgomery' --inline --static --use-value-barrier 25519_scalar 32 '2^252 + 27742317777372353535851937790883648493' mul square add sub opp from_montgomery to_montgomery nonzero selectznz to_bytes from_bytes one msat divstep divstep_precomp */
/* curve description: 25519_scalar */
/* machine_wordsize = 32 (from "32") */
/* requested operations: mul, square, add, sub, opp, from_montgomery, to_montgomery, nonzero, selectznz, to_bytes, from_bytes, one, msat, divstep, divstep_precomp */
/* m = 0x1000000000000000000000000000000014def9dea2f79cd65812631a5cf5d3ed (from "2^252 + 27742317777372353535851937790883648493") */
/*                                                                    */
/* NOTE: In addition to the bounds specified above each function, all */
/*   functions synthesized for this Montgomery arithmetic require the */
/*   input to be strictly less than the prime modulus (m), and also   */
/*   require the input to be in the unique saturated representation.  */
/*   All functions also ensure that these two properties are true of  */
/*   return values.                                                   */
/*  */
/* Computed values: */
/*   eval z = z[0] + (z[1] << 32) + (z[2] << 64) + (z[3] << 96) + (z[4] << 128) + (z[5] << 160) + (z[6] << 192) + (z[7] << 224) */
/*   bytes_eval z = z[0] + (z[1] << 8) + (z[2] << 16) + (z[3] << 24) + (z[4] << 32) + (z[5] << 40) + (z[6] << 48) + (z[7] << 56) + (z[8] << 64) + (z[9] << 72) + (z[10] << 80) + (z[11] << 88) + (z[12] << 96) + (z[13] << 104) + (z[14] << 112) + (z[15] << 120) + (z[16] << 128) + (z[17] << 136) + (z[18] << 144) + (z[19] << 152) + (z[20] << 160) + (z[21] << 168) + (z[22] << 176) + (z[23] << 184) + (z[24] << 192) + (z[25] << 200) + (z[26] << 208) + (z[27] << 216) + (z[28] << 224) + (z[29] << 232) + (z[30] << 240) + (z[31] << 248) */
/*   twos_complement_eval z = let x1 := z[0] + (z[1] << 32) + (z[2] << 64) + (z[3] << 96) + (z[4] << 128) + (z[5] << 160) + (z[6] << 192) + (z[7] << 224) in */
/*                            if x1 & (2^256-1) < 2^255 then x1 & (2^256-1) else (x1 & (2^256-1)) - 2^256 */

#include <stdint.h>
typedef unsigned char fiat_25519_scalar_uint1;
typedef signed char fiat_25519_scalar_int1;
#if defined(__GNUC__) || defined(__clang__)
#  define FIAT_25519_SCALAR_FIAT_INLINE __inline__
#else
#  define FIAT_25519_SCALAR_FIAT_INLINE
#endif

/* The type fiat_25519_scalar_montgomery_domain_field_element is a field element in the Montgomery domain. */
/* Bounds: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]] */
typedef uint32_t fiat_25519_scalar_montgomery_domain_field_element[8];

/* The type fiat_25519_scalar_non_montgomery_domain_field_element is a field element NOT in the Montgomery domain. */
/* Bounds: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]] */
typedef uint32_t fiat_25519_scalar_non_montgomery_domain_field_element[8];

#if (-1 & 3) != 3
#error "This code only works on a two's complement system"
#endif

#if !defined(FIAT_25519_SCALAR_NO_ASM) && (defined(__GNUC__) || defined(__clang__))
static __inline__ uint32_t fiat_25519_scalar_value_barrier_u32(uint32_t a) {
  __asm__("" : "+r"(a) : /* no inputs */);
  return a;
}
#else
#  define fiat_25519_scalar_value_barrier_u32(x) (x)
#endif


/*
 * The function fiat_25519_scalar_addcarryx_u32 is an addition with carry.
 *
 * Postconditions:
 *   out1 = (arg1 + arg2 + arg3) mod 2^32
 *   out2 = ⌊(arg1 + arg2 + arg3) / 2^32⌋
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [0x0 ~> 0xffffffff]
 *   arg3: [0x0 ~> 0xffffffff]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffff]
 *   out2: [0x0 ~> 0x1]
 */
static FIAT_25519_SCALAR_FIAT_INLINE void fiat_25519_scalar_addcarryx_u32(uint32_t* out1, fiat_25519_scalar_uint1* out2, fiat_25519_scalar_uint1 arg1, uint32_t arg2, uint32_t arg3) {
  uint64_t x1;
  uint32_t x2;
  fiat_25519_scalar_uint1 x3;
  x1 = ((arg1 + (uint64_t)arg2) + arg3);
  x2 = (uint32_t)(x1 & UINT32_C(0xffffffff));
  x3 = (fiat_25519_scalar_uint1)(x1 >> 32);
  *out1 = x2;
  *out2 = x3;
}

/*
 * The function fiat_25519_scalar_subborrowx_u32 is a subtraction with borrow.
 *
 * Postconditions:
 *   out1 = (-arg1 + arg2 + -arg3) mod 2^32
 *   out2 = -⌊(-arg1 + arg2 + -arg3) / 2^32⌋
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [0x0 ~> 0xffffffff]
 *   arg3: [0x0 ~> 0xffffffff]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffff]
 *   out2: [0x0 ~> 0x1]
 */
static FIAT_25519_SCALAR_FIAT_INLINE void fiat_25519_scalar_subborrowx_u32(uint32_t* out1, fiat_25519_scalar_uint1* out2, fiat_25519_scalar_uint1 arg1, uint32_t arg2, uint32_t arg3) {
  int64_t x1;
  fiat_25519_scalar_int1 x2;
  uint32_t x3;
  x1 = ((arg2 - (int64_t)arg1) - arg3);
  x2 = (fiat_25519_scalar_int1)(x1 >> 32);
  x3 = (uint32_t)(x1 & UINT32_C(0xffffffff));
  *out1 = x3;
  *out2 = (fiat_25519_scalar_uint1)(0x0 - x2);
}

/*
 * The function fiat_25519_scalar_mulx_u32 is a multiplication, returning the full double-width result.
 *
 * Postconditions:
 *   out1 = (arg1 * arg2) mod 2^32
 *   out2 = ⌊arg1 * arg2 / 2^32⌋
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0xffffffff]
 *   arg2: [0x0 ~> 0xffffffff]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffff]
 *   out2: [0x0 ~> 0xffffffff]
 */
static FIAT_25519_SCALAR_FIAT_INLINE void fiat_25519_scalar_mulx_u32(uint32_t* out1, uint32_t* out2, uint32_t arg1, uint32_t arg2) {
  uint64_t x1;
  uint32_t x2;
  uint32_t x3;
  x1 = ((uint64_t)arg1 * arg2);
  x2 = (uint32_t)(x1 & UINT32_C(0xffffffff));
  x3 = (uint32_t)(x1 >> 32);
  *out1 = x2;
  *out2 = x3;
}

/*
 * The function fiat_25519_scalar_cmovznz_u32 is a single-word conditional move.
 *
 * Postconditions:
 *   out1 = (if arg1 = 0 then arg2 else arg3)
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [0x0 ~> 0xffffffff]
 *   arg3: [0x0 ~> 0xffffffff]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffff]
 */
static FIAT_25519_SCALAR_FIAT_INLINE void fiat_25519_scalar_cmovznz_u32(uint32_t* out1, fiat_25519_scalar_uint1 arg1, uint32_t arg2, uint32_t arg3) {
  fiat_25519_scalar_uint1 x1;
  uint32_t x2;
  uint32_t x3;
  x1 = (!(!arg1));
  x2 = ((fiat_25519_scalar_int1)(0x0 - x1) & UINT32_C(0xffffffff));
  x3 = ((fiat_25519_scalar_value_barrier_u32(x2) & arg3) | (fiat_25519_scalar_value_barrier_u32((~x2)) & arg2));
  *out1 = x3;
}

/*
 * The function fiat_25519_scalar_mul multiplies two field elements in the Montgomery domain.
 *
 * Preconditions:
 *   0 ≤ eval arg1 < m
 *   0 ≤ eval arg2 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) * eval (from_montgomery arg2)) mod m
 *   0 ≤ eval out1 < m
 *
 */
static FIAT_25519_SCALAR_FIAT_INLINE void fiat_25519_scalar_mul(fiat_25519_scalar_montgomery_domain_field_element out1, const fiat_25519_scalar_montgomery_domain_field_element arg1, const fiat_25519_scalar_montgomery_domain_field_element arg2) {
  uint32_t x1;
  uint32_t x2;
  uint32_t x3;
  uint32_t x4;
  uint32_t x5;
  uint32_t x6;
  uint32_t x7;
  uint32_t x8;
  uint32_t x9;
  uint32_t x10;
  uint32_t x11;
  uint32_t x12;
  uint32_t x13;
  uint32_t x14;
  uint32_t x15;
  uint32_t x16;
  uint32_t x17;
  uint32_t x18;
  uint32_t x19;
  uint32_t x20;
  uint32_t x21;
  uint32_t x22;
  uint32_t x23;
  uint32_t x24;
  uint32_t x25;
  fiat_25519_scalar_uint1 x26;
  uint32_t x27;
  fiat_25519_scalar_uint1 x28;
  uint32_t x29;
  fiat_25519_scalar_uint1 x30;
  uint32_t x31;
  fiat_25519_scalar_uint1 x32;
  uint32_t x33;
  fiat_25519_scalar_uint1 x34;
  uint32_t x35;
  fiat_25519_scalar_uint1 x36;
  uint32_t x37;
  fiat_25519_scalar_uint1 x38;
  uint32_t x39;
  uint32_t x40;
  uint32_t x41;
  uint32_t x42;
  uint32_t x43;
  uint32_t x44;
  uint32_t x45;
  uint32_t x46;
  uint32_t x47;
  uint32_t x48;
  uint32_t x49;
  uint32_t x50;
  uint32_t x51;
  uint32_t x52;
  fiat_25519_scalar_uint1 x53;
  uint32_t x54;
  fiat_25519_scalar_uint1 x55;
  uint32_t x56;
  fiat_25519_scalar_uint1 x57;
  uint32_t x58;
  uint32_t x59;
  fiat_25519_scalar_uint1 x60;
  uint32_t x61;
  fiat_25519_scalar_uint1 x62;
  uint32_t x63;
  fiat_25519_scalar_uint1 x64;
  uint32_t x65;
  fiat_25519_scalar_uint1 x66;
  uint32_t x67;
  fiat_25519_scalar_uint1 x68;
  uint32_t x69;
  fiat_25519_scalar_uint1 x70;
  uint32_t x71;
  fiat_25519_scalar_uint1 x72;
  uint32_t x73;
  fiat_25519_scalar_uint1 x74;
  uint32_t x75;
  fiat_25519_scalar_uint1 x76;
  uint32_t x77;
  uint32_t x78;
  uint32_t x79;
  uint32_t x80;
  uint32_t x81;
  uint32_t x82;
  uint32_t x83;
  uint32_t x84;
  uint32_t x85;
  uint32_t x86;
  uint32_t x87;
  uint32_t x88;
  uint32_t x89;
  uint32_t x90;
  uint32_t x91;
  uint32_t x92;
  uint32_t x93;
  fiat_25519_scalar_uint1 x94;
  uint32_t x95;
  fiat_25519_scalar_uint1 x96;
  uint32_t x97;
  fiat_25519_scalar_uint1 x98;
  uint32_t x99;
  fiat_25519_scalar_uint1 x100;
  uint32_t x101;
  fiat_25519_scalar_uint1 x102;
  uint32_t x103;
  fiat_25519_scalar_uint1 x104;
  uint32_t x105;
  fiat_25519_scalar_uint1 x106;
  uint32_t x107;
  uint32_t x108;
  fiat_25519_scalar_uint1 x109;
  uint32_t x110;
  fiat_25519_scalar_uint1 x111;
  uint32_t x112;
  fiat_25519_scalar_uint1 x113;
  uint32_t x114;
  fiat_25519_scalar_uint1 x115;
  uint32_t x116;
  fiat_25519_scalar_uint1 x117;
  uint32_t x118;
  fiat_25519_scalar_uint1 x119;
  uint32_t x120;
  fiat_25519_scalar_uint1 x121;
  uint32_t x122;
  fiat_25519_scalar_uint1 x123;
  uint32_t x124;
  fiat_25519_scalar_uint1 x125;
  uint32_t x126;
  uint32_t x127;
  uint32_t x128;
  uint32_t x129;
  uint32_t x130;
  uint32_t x131;
  uint32_t x132;
  uint32_t x133;
  uint32_t x134;
  uint32_t x135;
  uint32_t x136;
  uint32_t x137;
  uint32_t x138;
  fiat_25519_scalar_uint1 x139;
  uint32_t x140;
  fiat_25519_scalar_uint1 x141;
  uint32_t x142;
  fiat_25519_scalar_uint1 x143;
  uint32_t x144;
  uint32_t x145;
  fiat_25519_scalar_uint1 x146;
  uint32_t x147;
  fiat_25519_scalar_uint1 x148;
  uint32_t x149;
  fiat_25519_scalar_uint1 x150;
  uint32_t x151;
  fiat_25519_scalar_uint1 x152;
  uint32_t x153;
  fiat_25519_scalar_uint1 x154;
  uint32_t x155;
  fiat_25519_scalar_uint1 x156;
  uint32_t x157;
  fiat_25519_scalar_uint1 x158;
  uint32_t x159;
  fiat_25519_scalar_uint1 x160;
  uint32_t x161;
  fiat_25519_scalar_uint1 x162;
  uint32_t x163;
  uint32_t x164;
  uint32_t x165;
  uint32_t x166;
  uint32_t x167;
  uint32_t x168;
  uint32_t x169;
  uint32_t x170;
  uint32_t x171;
  uint32_t x172;
  uint32_t x173;
  uint32_t x174;
  uint32_t x175;
  uint32_t x176;
  uint32_t x177;
  uint32_t x178;
  uint32_t x179;
  uint32_t x180;
  fiat_25519_scalar_uint1 x181;
  uint32_t x182;
  fiat_25519_scalar_uint1 x183;
  uint32_t x184;
  fiat_25519_scalar_uint1 x185;
  uint32_t x186;
  fiat_25519_scalar_uint1 x187;
  uint32_t x188;
  fiat_25519_scalar_uint1 x189;
  uint32_t x190;
  fiat_25519_scalar_uint1 x191;
  uint32_t x192;
  fiat_25519_scalar_uint1 x193;
  uint32_t x194;
  uint32_t x195;
  fiat_25519_scalar_uint1 x196;
  uint32_t x197;
  fiat_25519_scalar_uint1 x198;
  uint32_t x199;
  fiat_25519_scalar_uint1 x200;
  uint32_t x201;
  fiat_25519_scalar_uint1 x202;
  uint32_t x203;
  fiat_25519_scalar_uint1 x204;
  uint32_t x205;
  fiat_25519_scalar_uint1 x206;
  uint32_t x207;
  fiat_25519_scalar_uint1 x208;
  uint32_t x209;
  fiat_25519_scalar_uint1 x210;
  uint32_t x211;
  fiat_25519_scalar_uint1 x212;
  uint32_t x213;
  uint32_t x214;
  uint32_t x215;
  uint32_t x216;
  uint32_t x217;
  uint32_t x218;
  uint32_t x219;
  uint32_t x220;
  uint32_t x221;
  uint32_t x222;
  uint32_t x223;
  uint32_t x224;
  uint32_t x225;
  fiat_25519_scalar_uint1 x226;
  uint32_t x227;
  fiat_25519_scalar_uint1 x228;
  uint32_t x229;
  fiat_25519_scalar_uint1 x230;
  uint32_t x231;
  uint32_t x232;
  fiat_25519_scalar_uint1 x233;
  uint32_t x234;
  fiat_25519_scalar_uint1 x235;
  uint32_t x236;
  fiat_25519_scalar_uint1 x237;
  uint32_t x238;
  fiat_25519_scalar_uint1 x239;
  uint32_t x240;
  fiat_25519_scalar_uint1 x241;
  uint32_t x242;
  fiat_25519_scalar_uint1 x243;
  uint32_t x244;
  fiat_25519_scalar_uint1 x245;
  uint32_t x246;
  fiat_25519_scalar_uint1 x247;
  uint32_t x248;
  fiat_25519_scalar_uint1 x249;
  uint32_t x250;
  uint32_t x251;
  uint32_t x252;
  uint32_t x253;
  uint32_t x254;
  uint32_t x255;
  uint32_t x256;
  uint32_t x257;
  uint32_t x258;
  uint32_t x259;
  uint32_t x260;
  uint32_t x261;
  uint32_t x262;
  uint32_t x263;
  uint32_t x264;
  uint32_t x265;
  uint32_t x266;
  uint32_t x267;
  fiat_25519_scalar_uint1 x268;
  uint32_t x269;
  fiat_25519_scalar_uint1 x270;
  uint32_t x271;
  fiat_25519_scalar_uint1 x272;
  uint32_t x273;
  fiat_25519_scalar_uint1 x274;
  uint32_t x275;
  fiat_25519_scalar_uint1 x276;
  uint32_t x277;
  fiat_25519_scalar_uint1 x278;
  uint32_t x279;
  fiat_25519_scalar_uint1 x280;
  uint32_t x281;
  uint32_t x282;
  fiat_25519_scalar_uint1 x283;
  uint32_t x284;
  fiat_25519_scalar_uint1 x285;
  uint32_t x286;
  fiat_25519_scalar_uint1 x287;
  uint32_t x288;
  fiat_25519_scalar_uint1 x289;
  uint32_t x290;
  fiat_25519_scalar_uint1 x291;
  uint32_t x292;
  fiat_25519_scalar_uint1 x293;
  uint32_t x294;
  fiat_25519_scalar_uint1 x295;
  uint32_t x296;
  fiat_25519_scalar_uint1 x297;
  uint32_t x298;
  fiat_25519_scalar_uint1 x299;
  uint32_t x300;
  uint32_t x301;
  uint32_t x302;
  uint32_t x303;
  uint32_t x304;
  uint32_t x305;
  uint32_t x306;
  uint32_t x307;
  uint32_t x308;
  uint32_t x309;
  uint32_t x310;
  uint32_t x311;
  uint32_t x312;
  fiat_25519_scalar_uint1 x313;
  uint32_t x314;
  fiat_25519_scalar_uint1 x315;
  uint32_t x316;
  fiat_25519_scalar_uint1 x317;
  uint32_t x318;
  uint32_t x319;
  fiat_25519_scalar_uint1 x320;
  uint32_t x321;
  fiat_25519_scalar_uint1 x322;
  uint32_t x323;
  fiat_25519_scalar_uint1 x324;
  uint32_t x325;
  fiat_25519_scalar_uint1 x326;
  uint32_t x327;
  fiat_25519_scalar_uint1 x328;
  uint32_t x329;
  fiat_25519_scalar_uint1 x330;
  uint32_t x331;
  fiat_25519_scalar_uint1 x332;
  uint32_t x333;
  fiat_25519_scalar_uint1 x334;
  uint32_t x335;
  fiat_25519_scalar_uint1 x336;
  uint32_t x337;
  uint32_t x338;
  uint32_t x339;
  uint32_t x340;
  uint32_t x341;
  uint32_t x342;
  uint32_t x343;
  uint32_t x344;
  uint32_t x345;
  uint32_t x346;
  uint32_t x347;
  uint32_t x348;
  uint32_t x349;
  uint32_t x350;
  uint32_t x351;
  uint32_t x352;
  uint32_t x353;
  uint32_t x354;
  fiat_25519_scalar_uint1 x355;
  uint32_t x356;
  fiat_25519_scalar_uint1 x357;
  uint32_t x358;
  fiat_25519_scalar_uint1 x359;
  uint32_t x360;
  fiat_25519_scalar_uint1 x361;
  uint32_t x362;
  fiat_25519_scalar_uint1 x363;
  uint32_t x364;
  fiat_25519_scalar_uint1 x365;
  uint32_t x366;
  fiat_25519_scalar_uint1 x367;
  uint32_t x368;
  uint32_t x369;
  fiat_25519_scalar_uint1 x370;
  uint32_t x371;
  fiat_25519_scalar_uint1 x372;
  uint32_t x373;
  fiat_25519_scalar_uint1 x374;
  uint32_t x375;
  fiat_25519_scalar_uint1 x376;
  uint32_t x377;
  fiat_25519_scalar_uint1 x378;
  uint32_t x379;
  fiat_25519_scalar_uint1 x380;
  uint32_t x381;
  fiat_25519_scalar_uint1 x382;
  uint32_t x383;
  fiat_25519_scalar_uint1 x384;
  uint32_t x385;
  fiat_25519_scalar_uint1 x386;
  uint32_t x387;
  uint32_t x388;
  uint32_t x389;
  uint32_t x390;
  uint32_t x391;
  uint32_t x392;
  uint32_t x393;
  uint32_t x394;
  uint32_t x395;
  uint32_t x396;
  uint32_t x397;
  uint32_t x398;
  uint32_t x399;
  fiat_25519_scalar_uint1 x400;
  uint32_t x401;
  fiat_25519_scalar_uint1 x402;
  uint32_t x403;
  fiat_25519_scalar_uint1 x404;
  uint32_t x405;
  uint32_t x406;
  fiat_25519_scalar_uint1 x407;
  uint32_t x408;
  fiat_25519_scalar_uint1 x409;
  uint32_t x410;
  fiat_25519_scalar_uint1 x411;
  uint32_t x412;
  fiat_25519_scalar_uint1 x413;
  uint32_t x414;
  fiat_25519_scalar_uint1 x415;
  uint32_t x416;
  fiat_25519_scalar_uint1 x417;
  uint32_t x418;
  fiat_25519_scalar_uint1 x419;
  uint32_t x420;
  fiat_25519_scalar_uint1 x421;
  uint32_t x422;
  fiat_25519_scalar_uint1 x423;
  uint32_t x424;
  uint32_t x425;
  uint32_t x426;
  uint32_t x427;
  uint32_t x428;
  uint32_t x429;
  uint32_t x430;
  uint32_t x431;
  uint32_t x432;
  uint32_t x433;
  uint32_t x434;
  uint32_t x435;
  uint32_t x436;
  uint32_t x437;
  uint32_t x438;
  uint32_t x439;
  uint32_t x440;
  uint32_t x441;
  fiat_25519_scalar_uint1 x442;
  uint32_t x443;
  fiat_25519_scalar_uint1 x444;
  uint32_t x445;
  fiat_25519_scalar_uint1 x446;
  uint32_t x447;
  fiat_25519_scalar_uint1 x448;
  uint32_t x449;
  fiat_25519_scalar_uint1 x450;
  uint32_t x451;
  fiat_25519_scalar_uint1 x452;
  uint32_t x453;
  fiat_25519_scalar_uint1 x454;
  uint32_t x455;
  uint32_t x456;
  fiat_25519_scalar_uint1 x457;
  uint32_t x458;
  fiat_25519_scalar_uint1 x459;
  uint32_t x460;
  fiat_25519_scalar_uint1 x461;
  uint32_t x462;
  fiat_25519_scalar_uint1 x463;
  uint32_t x464;
  fiat_25519_scalar_uint1 x465;
  uint32_t x466;
  fiat_25519_scalar_uint1 x467;
  uint32_t x468;
  fiat_25519_scalar_uint1 x469;
  uint32_t x470;
  fiat_25519_scalar_uint1 x471;
  uint32_t x472;
  fiat_25519_scalar_uint1 x473;
  uint32_t x474;
  uint32_t x475;
  uint32_t x476;
  uint32_t x477;
  uint32_t x478;
  uint32_t x479;
  uint32_t x480;
  uint32_t x481;
  uint32_t x482;
  uint32_t x483;
  uint32_t x484;
  uint32_t x485;
  uint32_t x486;
  fiat_25519_scalar_uint1 x487;
  uint32_t x488;
  fiat_25519_scalar_uint1 x489;
  uint32_t x490;
  fiat_25519_scalar_uint1 x491;
  uint32_t x492;
  uint32_t x493;
  fiat_25519_scalar_uint1 x494;
  uint32_t x495;
  fiat_25519_scalar_uint1 x496;
  uint32_t x497;
  fiat_25519_scalar_uint1 x498;
  uint32_t x499;
  fiat_25519_scalar_uint1 x500;
  uint32_t x501;
  fiat_25519_scalar_uint1 x502;
  uint32_t x503;
  fiat_25519_scalar_uint1 x504;
  uint32_t x505;
  fiat_25519_scalar_uint1 x506;
  uint32_t x507;
  fiat_25519_scalar_uint1 x508;
  uint32_t x509;
  fiat_25519_scalar_uint1 x510;
  uint32_t x511;
  uint32_t x512;
  uint32_t x513;
  uint32_t x514;
  uint32_t x515;
  uint32_t x516;
  uint32_t x517;
  uint32_t x518;
  uint32_t x519;
  uint32_t x520;
  uint32_t x521;
  uint32_t x522;
  uint32_t x523;
  uint32_t x524;
  uint32_t x525;
  uint32_t x526;
  uint32_t x527;
  uint32_t x528;
  fiat_25519_scalar_uint1 x529;
  uint32_t x530;
  fiat_25519_scalar_uint1 x531;
  uint32_t x532;
  fiat_25519_scalar_uint1 x533;
  uint32_t x534;
  fiat_25519_scalar_uint1 x535;
  uint32_t x536;
  fiat_25519_scalar_uint1 x537;
  uint32_t x538;
  fiat_25519_scalar_uint1 x539;
  uint32_t x540;
  fiat_25519_scalar_uint1 x541;
  uint32_t x542;
  uint32_t x543;
  fiat_25519_scalar_uint1 x544;
  uint32_t x545;
  fiat_25519_scalar_uint1 x546;
  uint32_t x547;
  fiat_25519_scalar_uint1 x548;
  uint32_t x549;
  fiat_25519_scalar_uint1 x550;
  uint32_t x551;
  fiat_25519_scalar_uint1 x552;
  uint32_t x553;
  fiat_25519_scalar_uint1 x554;
  uint32_t x555;
  fiat_25519_scalar_uint1 x556;
  uint32_t x557;
  fiat_25519_scalar_uint1 x558;
  uint32_t x559;
  fiat_25519_scalar_uint1 x560;
  uint32_t x561;
  uint32_t x562;
  uint32_t x563;
  uint32_t x564;
  uint32_t x565;
  uint32_t x566;
  uint32_t x567;
  uint32_t x568;
  uint32_t x569;
  uint32_t x570;
  uint32_t x571;
  uint32_t x572;
  uint32_t x573;
  fiat_25519_scalar_uint1 x574;
  uint32_t x575;
  fiat_25519_scalar_uint1 x576;
  uint32_t x577;
  fiat_25519_scalar_uint1 x578;
  uint32_t x579;
  uint32_t x580;
  fiat_25519_scalar_uint1 x581;
  uint32_t x582;
  fiat_25519_scalar_uint1 x583;
  uint32_t x584;
  fiat_25519_scalar_uint1 x585;
  uint32_t x586;
  fiat_25519_scalar_uint1 x587;
  uint32_t x588;
  fiat_25519_scalar_uint1 x589;
  uint32_t x590;
  fiat_25519_scalar_uint1 x591;
  uint32_t x592;
  fiat_25519_scalar_uint1 x593;
  uint32_t x594;
  fiat_25519_scalar_uint1 x595;
  uint32_t x596;
  fiat_25519_scalar_uint1 x597;
  uint32_t x598;
  uint32_t x599;
  uint32_t x600;
  uint32_t x601;
  uint32_t x602;
  uint32_t x603;
  uint32_t x604;
  uint32_t x605;
  uint32_t x606;
  uint32_t x607;
  uint32_t x608;
  uint32_t x609;
  uint32_t x610;
  uint32_t x611;
  uint32_t x612;
  uint32_t x613;
  uint32_t x614;
  uint32_t x615;
  fiat_25519_scalar_uint1 x616;
  uint32_t x617;
  fiat_25519_scalar_uint1 x618;
  uint32_t x619;
  fiat_25519_scalar_uint1 x620;
  uint32_t x621;
  fiat_25519_scalar_uint1 x622;
  uint32_t x623;
  fiat_25519_scalar_uint1 x624;
  uint32_t x625;
  fiat_25519_scalar_uint1 x626;
  uint32_t x627;
  fiat_25519_scalar_uint1 x628;
  uint32_t x629;
  uint32_t x630;
  fiat_25519_scalar_uint1 x631;
  uint32_t x632;
  fiat_25519_scalar_uint1 x633;
  uint32_t x634;
  fiat_25519_scalar_uint1 x635;
  uint32_t x636;
  fiat_25519_scalar_uint1 x637;
  uint32_t x638;
  fiat_25519_scalar_uint1 x639;
  uint32_t x640;
  fiat_25519_scalar_uint1 x641;
  uint32_t x642;
  fiat_25519_scalar_uint1 x643;
  uint32_t x644;
  fiat_25519_scalar_uint1 x645;
  uint32_t x646;
  fiat_25519_scalar_uint1 x647;
  uint32_t x648;
  uint32_t x649;
  uint32_t x650;
  uint32_t x651;
  uint32_t x652;
  uint32_t x653;
  uint32_t x654;
  uint32_t x655;
  uint32_t x656;
  uint32_t x657;
  uint32_t x658;
  uint32_t x659;
  uint32_t x660;
  fiat_25519_scalar_uint1 x661;
  uint32_t x662;
  fiat_25519_scalar_uint1 x663;
  uint32_t x664;
  fiat_25519_scalar_uint1 x665;
  uint32_t x666;
  uint32_t x667;
  fiat_25519_scalar_uint1 x668;
  uint32_t x669;
  fiat_25519_scalar_uint1 x670;
  uint32_t x671;
  fiat_25519_scalar_uint1 x672;
  uint32_t x673;
  fiat_25519_scalar_uint1 x674;
  uint32_t x675;
  fiat_25519_scalar_uint1 x676;
  uint32_t x677;
  fiat_25519_scalar_uint1 x678;
  uint32_t x679;
  fiat_25519_scalar_uint1 x680;
  uint32_t x681;
  fiat_25519_scalar_uint1 x682;
  uint32_t x683;
  fiat_25519_scalar_uint1 x684;
  uint32_t x685;
  uint32_t x686;
  fiat_25519_scalar_uint1 x687;
  uint32_t x688;
  fiat_25519_scalar_uint1 x689;
  uint32_t x690;
  fiat_25519_scalar_uint1 x691;
  uint32_t x692;
  fiat_25519_scalar_uint1 x693;
  uint32_t x694;
  fiat_25519_scalar_uint1 x695;
  uint32_t x696;
  fiat_25519_scalar_uint1 x697;
  uint32_t x698;
  fiat_25519_scalar_uint1 x699;
  uint32_t x700;
  fiat_25519_scalar_uint1 x701;
  uint32_t x702;
  fiat_25519_scalar_uint1 x703;
  uint32_t x704;
  uint32_t x705;
  uint32_t x706;
  uint32_t x707;
  uint32_t x708;
  uint32_t x709;
  uint32_t x710;
  uint32_t x711;
  x1 = (arg1[1]);
  x2 = (arg1[2]);
  x3 = (arg1[3]);
  x4 = (arg1[4]);
  x5 = (arg1[5]);
  x6 = (arg1[6]);
  x7 = (arg1[7]);
  x8 = (arg1[0]);
  fiat_25519_scalar_mulx_u32(&x9, &x10, x8, (arg2[7]));
  fiat_25519_scalar_mulx_u32(&x11, &x12, x8, (arg2[6]));
  fiat_25519_scalar_mulx_u32(&x13, &x14, x8, (arg2[5]));
  fiat_25519_scalar_mulx_u32(&x15, &x16, x8, (arg2[4]));
  fiat_25519_scalar_mulx_u32(&x17, &x18, x8, (arg2[3]));
  fiat_25519_scalar_mulx_u32(&x19, &x20, x8, (arg2[2]));
  fiat_25519_scalar_mulx_u32(&x21, &x22, x8, (arg2[1]));
  fiat_25519_scalar_mulx_u32(&x23, &x24, x8, (arg2[0]));
  fiat_25519_scalar_addcarryx_u32(&x25, &x26, 0x0, x24, x21);
  fiat_25519_scalar_addcarryx_u32(&x27, &x28, x26, x22, x19);
  fiat_25519_scalar_addcarryx_u32(&x29, &x30, x28, x20, x17);
  fiat_25519_scalar_addcarryx_u32(&x31, &x32, x30, x18, x15);
  fiat_25519_scalar_addcarryx_u32(&x33, &x34, x32, x16, x13);
  fiat_25519_scalar_addcarryx_u32(&x35, &x36, x34, x14, x11);
  fiat_25519_scalar_addcarryx_u32(&x37, &x38, x36, x12, x9);
  x39 = (x38 + x10);
  fiat_25519_scalar_mulx_u32(&x40, &x41, x23, UINT32_C(0x12547e1b));
  fiat_25519_scalar_mulx_u32(&x42, &x43, x40, UINT32_C(0x10000000));
  fiat_25519_scalar_mulx_u32(&x44, &x45, x40, UINT32_C(0x14def9de));
  fiat_25519_scalar_mulx_u32(&x46, &x47, x40, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_mulx_u32(&x48, &x49, x40, UINT32_C(0x5812631a));
  fiat_25519_scalar_mulx_u32(&x50, &x51, x40, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_addcarryx_u32(&x52, &x53, 0x0, x51, x48);
  fiat_25519_scalar_addcarryx_u32(&x54, &x55, x53, x49, x46);
  fiat_25519_scalar_addcarryx_u32(&x56, &x57, x55, x47, x44);
  x58 = (x57 + x45);
  fiat_25519_scalar_addcarryx_u32(&x59, &x60, 0x0, x23, x50);
  fiat_25519_scalar_addcarryx_u32(&x61, &x62, x60, x25, x52);
  fiat_25519_scalar_addcarryx_u32(&x63, &x64, x62, x27, x54);
  fiat_25519_scalar_addcarryx_u32(&x65, &x66, x64, x29, x56);
  fiat_25519_scalar_addcarryx_u32(&x67, &x68, x66, x31, x58);
  fiat_25519_scalar_addcarryx_u32(&x69, &x70, x68, x33, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x71, &x72, x70, x35, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x73, &x74, x72, x37, x42);
  fiat_25519_scalar_addcarryx_u32(&x75, &x76, x74, x39, x43);
  fiat_25519_scalar_mulx_u32(&x77, &x78, x1, (arg2[7]));
  fiat_25519_scalar_mulx_u32(&x79, &x80, x1, (arg2[6]));
  fiat_25519_scalar_mulx_u32(&x81, &x82, x1, (arg2[5]));
  fiat_25519_scalar_mulx_u32(&x83, &x84, x1, (arg2[4]));
  fiat_25519_scalar_mulx_u32(&x85, &x86, x1, (arg2[3]));
  fiat_25519_scalar_mulx_u32(&x87, &x88, x1, (arg2[2]));
  fiat_25519_scalar_mulx_u32(&x89, &x90, x1, (arg2[1]));
  fiat_25519_scalar_mulx_u32(&x91, &x92, x1, (arg2[0]));
  fiat_25519_scalar_addcarryx_u32(&x93, &x94, 0x0, x92, x89);
  fiat_25519_scalar_addcarryx_u32(&x95, &x96, x94, x90, x87);
  fiat_25519_scalar_addcarryx_u32(&x97, &x98, x96, x88, x85);
  fiat_25519_scalar_addcarryx_u32(&x99, &x100, x98, x86, x83);
  fiat_25519_scalar_addcarryx_u32(&x101, &x102, x100, x84, x81);
  fiat_25519_scalar_addcarryx_u32(&x103, &x104, x102, x82, x79);
  fiat_25519_scalar_addcarryx_u32(&x105, &x106, x104, x80, x77);
  x107 = (x106 + x78);
  fiat_25519_scalar_addcarryx_u32(&x108, &x109, 0x0, x61, x91);
  fiat_25519_scalar_addcarryx_u32(&x110, &x111, x109, x63, x93);
  fiat_25519_scalar_addcarryx_u32(&x112, &x113, x111, x65, x95);
  fiat_25519_scalar_addcarryx_u32(&x114, &x115, x113, x67, x97);
  fiat_25519_scalar_addcarryx_u32(&x116, &x117, x115, x69, x99);
  fiat_25519_scalar_addcarryx_u32(&x118, &x119, x117, x71, x101);
  fiat_25519_scalar_addcarryx_u32(&x120, &x121, x119, x73, x103);
  fiat_25519_scalar_addcarryx_u32(&x122, &x123, x121, x75, x105);
  fiat_25519_scalar_addcarryx_u32(&x124, &x125, x123, x76, x107);
  fiat_25519_scalar_mulx_u32(&x126, &x127, x108, UINT32_C(0x12547e1b));
  fiat_25519_scalar_mulx_u32(&x128, &x129, x126, UINT32_C(0x10000000));
  fiat_25519_scalar_mulx_u32(&x130, &x131, x126, UINT32_C(0x14def9de));
  fiat_25519_scalar_mulx_u32(&x132, &x133, x126, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_mulx_u32(&x134, &x135, x126, UINT32_C(0x5812631a));
  fiat_25519_scalar_mulx_u32(&x136, &x137, x126, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_addcarryx_u32(&x138, &x139, 0x0, x137, x134);
  fiat_25519_scalar_addcarryx_u32(&x140, &x141, x139, x135, x132);
  fiat_25519_scalar_addcarryx_u32(&x142, &x143, x141, x133, x130);
  x144 = (x143 + x131);
  fiat_25519_scalar_addcarryx_u32(&x145, &x146, 0x0, x108, x136);
  fiat_25519_scalar_addcarryx_u32(&x147, &x148, x146, x110, x138);
  fiat_25519_scalar_addcarryx_u32(&x149, &x150, x148, x112, x140);
  fiat_25519_scalar_addcarryx_u32(&x151, &x152, x150, x114, x142);
  fiat_25519_scalar_addcarryx_u32(&x153, &x154, x152, x116, x144);
  fiat_25519_scalar_addcarryx_u32(&x155, &x156, x154, x118, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x157, &x158, x156, x120, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x159, &x160, x158, x122, x128);
  fiat_25519_scalar_addcarryx_u32(&x161, &x162, x160, x124, x129);
  x163 = ((uint32_t)x162 + x125);
  fiat_25519_scalar_mulx_u32(&x164, &x165, x2, (arg2[7]));
  fiat_25519_scalar_mulx_u32(&x166, &x167, x2, (arg2[6]));
  fiat_25519_scalar_mulx_u32(&x168, &x169, x2, (arg2[5]));
  fiat_25519_scalar_mulx_u32(&x170, &x171, x2, (arg2[4]));
  fiat_25519_scalar_mulx_u32(&x172, &x173, x2, (arg2[3]));
  fiat_25519_scalar_mulx_u32(&x174, &x175, x2, (arg2[2]));
  fiat_25519_scalar_mulx_u32(&x176, &x177, x2, (arg2[1]));
  fiat_25519_scalar_mulx_u32(&x178, &x179, x2, (arg2[0]));
  fiat_25519_scalar_addcarryx_u32(&x180, &x181, 0x0, x179, x176);
  fiat_25519_scalar_addcarryx_u32(&x182, &x183, x181, x177, x174);
  fiat_25519_scalar_addcarryx_u32(&x184, &x185, x183, x175, x172);
  fiat_25519_scalar_addcarryx_u32(&x186, &x187, x185, x173, x170);
  fiat_25519_scalar_addcarryx_u32(&x188, &x189, x187, x171, x168);
  fiat_25519_scalar_addcarryx_u32(&x190, &x191, x189, x169, x166);
  fiat_25519_scalar_addcarryx_u32(&x192, &x193, x191, x167, x164);
  x194 = (x193 + x165);
  fiat_25519_scalar_addcarryx_u32(&x195, &x196, 0x0, x147, x178);
  fiat_25519_scalar_addcarryx_u32(&x197, &x198, x196, x149, x180);
  fiat_25519_scalar_addcarryx_u32(&x199, &x200, x198, x151, x182);
  fiat_25519_scalar_addcarryx_u32(&x201, &x202, x200, x153, x184);
  fiat_25519_scalar_addcarryx_u32(&x203, &x204, x202, x155, x186);
  fiat_25519_scalar_addcarryx_u32(&x205, &x206, x204, x157, x188);
  fiat_25519_scalar_addcarryx_u32(&x207, &x208, x206, x159, x190);
  fiat_25519_scalar_addcarryx_u32(&x209, &x210, x208, x161, x192);
  fiat_25519_scalar_addcarryx_u32(&x211, &x212, x210, x163, x194);
  fiat_25519_scalar_mulx_u32(&x213, &x214, x195, UINT32_C(0x12547e1b));
  fiat_25519_scalar_mulx_u32(&x215, &x216, x213, UINT32_C(0x10000000));
  fiat_25519_scalar_mulx_u32(&x217, &x218, x213, UINT32_C(0x14def9de));
  fiat_25519_scalar_mulx_u32(&x219, &x220, x213, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_mulx_u32(&x221, &x222, x213, UINT32_C(0x5812631a));
  fiat_25519_scalar_mulx_u32(&x223, &x224, x213, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_addcarryx_u32(&x225, &x226, 0x0, x224, x221);
  fiat_25519_scalar_addcarryx_u32(&x227, &x228, x226, x222, x219);
  fiat_25519_scalar_addcarryx_u32(&x229, &x230, x228, x220, x217);
  x231 = (x230 + x218);
  fiat_25519_scalar_addcarryx_u32(&x232, &x233, 0x0, x195, x223);
  fiat_25519_scalar_addcarryx_u32(&x234, &x235, x233, x197, x225);
  fiat_25519_scalar_addcarryx_u32(&x236, &x237, x235, x199, x227);
  fiat_25519_scalar_addcarryx_u32(&x238, &x239, x237, x201, x229);
  fiat_25519_scalar_addcarryx_u32(&x240, &x241, x239, x203, x231);
  fiat_25519_scalar_addcarryx_u32(&x242, &x243, x241, x205, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x244, &x245, x243, x207, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x246, &x247, x245, x209, x215);
  fiat_25519_scalar_addcarryx_u32(&x248, &x249, x247, x211, x216);
  x250 = ((uint32_t)x249 + x212);
  fiat_25519_scalar_mulx_u32(&x251, &x252, x3, (arg2[7]));
  fiat_25519_scalar_mulx_u32(&x253, &x254, x3, (arg2[6]));
  fiat_25519_scalar_mulx_u32(&x255, &x256, x3, (arg2[5]));
  fiat_25519_scalar_mulx_u32(&x257, &x258, x3, (arg2[4]));
  fiat_25519_scalar_mulx_u32(&x259, &x260, x3, (arg2[3]));
  fiat_25519_scalar_mulx_u32(&x261, &x262, x3, (arg2[2]));
  fiat_25519_scalar_mulx_u32(&x263, &x264, x3, (arg2[1]));
  fiat_25519_scalar_mulx_u32(&x265, &x266, x3, (arg2[0]));
  fiat_25519_scalar_addcarryx_u32(&x267, &x268, 0x0, x266, x263);
  fiat_25519_scalar_addcarryx_u32(&x269, &x270, x268, x264, x261);
  fiat_25519_scalar_addcarryx_u32(&x271, &x272, x270, x262, x259);
  fiat_25519_scalar_addcarryx_u32(&x273, &x274, x272, x260, x257);
  fiat_25519_scalar_addcarryx_u32(&x275, &x276, x274, x258, x255);
  fiat_25519_scalar_addcarryx_u32(&x277, &x278, x276, x256, x253);
  fiat_25519_scalar_addcarryx_u32(&x279, &x280, x278, x254, x251);
  x281 = (x280 + x252);
  fiat_25519_scalar_addcarryx_u32(&x282, &x283, 0x0, x234, x265);
  fiat_25519_scalar_addcarryx_u32(&x284, &x285, x283, x236, x267);
  fiat_25519_scalar_addcarryx_u32(&x286, &x287, x285, x238, x269);
  fiat_25519_scalar_addcarryx_u32(&x288, &x289, x287, x240, x271);
  fiat_25519_scalar_addcarryx_u32(&x290, &x291, x289, x242, x273);
  fiat_25519_scalar_addcarryx_u32(&x292, &x293, x291, x244, x275);
  fiat_25519_scalar_addcarryx_u32(&x294, &x295, x293, x246, x277);
  fiat_25519_scalar_addcarryx_u32(&x296, &x297, x295, x248, x279);
  fiat_25519_scalar_addcarryx_u32(&x298, &x299, x297, x250, x281);
  fiat_25519_scalar_mulx_u32(&x300, &x301, x282, UINT32_C(0x12547e1b));
  fiat_25519_scalar_mulx_u32(&x302, &x303, x300, UINT32_C(0x10000000));
  fiat_25519_scalar_mulx_u32(&x304, &x305, x300, UINT32_C(0x14def9de));
  fiat_25519_scalar_mulx_u32(&x306, &x307, x300, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_mulx_u32(&x308, &x309, x300, UINT32_C(0x5812631a));
  fiat_25519_scalar_mulx_u32(&x310, &x311, x300, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_addcarryx_u32(&x312, &x313, 0x0, x311, x308);
  fiat_25519_scalar_addcarryx_u32(&x314, &x315, x313, x309, x306);
  fiat_25519_scalar_addcarryx_u32(&x316, &x317, x315, x307, x304);
  x318 = (x317 + x305);
  fiat_25519_scalar_addcarryx_u32(&x319, &x320, 0x0, x282, x310);
  fiat_25519_scalar_addcarryx_u32(&x321, &x322, x320, x284, x312);
  fiat_25519_scalar_addcarryx_u32(&x323, &x324, x322, x286, x314);
  fiat_25519_scalar_addcarryx_u32(&x325, &x326, x324, x288, x316);
  fiat_25519_scalar_addcarryx_u32(&x327, &x328, x326, x290, x318);
  fiat_25519_scalar_addcarryx_u32(&x329, &x330, x328, x292, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x331, &x332, x330, x294, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x333, &x334, x332, x296, x302);
  fiat_25519_scalar_addcarryx_u32(&x335, &x336, x334, x298, x303);
  x337 = ((uint32_t)x336 + x299);
  fiat_25519_scalar_mulx_u32(&x338, &x339, x4, (arg2[7]));
  fiat_25519_scalar_mulx_u32(&x340, &x341, x4, (arg2[6]));
  fiat_25519_scalar_mulx_u32(&x342, &x343, x4, (arg2[5]));
  fiat_25519_scalar_mulx_u32(&x344, &x345, x4, (arg2[4]));
  fiat_25519_scalar_mulx_u32(&x346, &x347, x4, (arg2[3]));
  fiat_25519_scalar_mulx_u32(&x348, &x349, x4, (arg2[2]));
  fiat_25519_scalar_mulx_u32(&x350, &x351, x4, (arg2[1]));
  fiat_25519_scalar_mulx_u32(&x352, &x353, x4, (arg2[0]));
  fiat_25519_scalar_addcarryx_u32(&x354, &x355, 0x0, x353, x350);
  fiat_25519_scalar_addcarryx_u32(&x356, &x357, x355, x351, x348);
  fiat_25519_scalar_addcarryx_u32(&x358, &x359, x357, x349, x346);
  fiat_25519_scalar_addcarryx_u32(&x360, &x361, x359, x347, x344);
  fiat_25519_scalar_addcarryx_u32(&x362, &x363, x361, x345, x342);
  fiat_25519_scalar_addcarryx_u32(&x364, &x365, x363, x343, x340);
  fiat_25519_scalar_addcarryx_u32(&x366, &x367, x365, x341, x338);
  x368 = (x367 + x339);
  fiat_25519_scalar_addcarryx_u32(&x369, &x370, 0x0, x321, x352);
  fiat_25519_scalar_addcarryx_u32(&x371, &x372, x370, x323, x354);
  fiat_25519_scalar_addcarryx_u32(&x373, &x374, x372, x325, x356);
  fiat_25519_scalar_addcarryx_u32(&x375, &x376, x374, x327, x358);
  fiat_25519_scalar_addcarryx_u32(&x377, &x378, x376, x329, x360);
  fiat_25519_scalar_addcarryx_u32(&x379, &x380, x378, x331, x362);
  fiat_25519_scalar_addcarryx_u32(&x381, &x382, x380, x333, x364);
  fiat_25519_scalar_addcarryx_u32(&x383, &x384, x382, x335, x366);
  fiat_25519_scalar_addcarryx_u32(&x385, &x386, x384, x337, x368);
  fiat_25519_scalar_mulx_u32(&x387, &x388, x369, UINT32_C(0x12547e1b));
  fiat_25519_scalar_mulx_u32(&x389, &x390, x387, UINT32_C(0x10000000));
  fiat_25519_scalar_mulx_u32(&x391, &x392, x387, UINT32_C(0x14def9de));
  fiat_25519_scalar_mulx_u32(&x393, &x394, x387, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_mulx_u32(&x395, &x396, x387, UINT32_C(0x5812631a));
  fiat_25519_scalar_mulx_u32(&x397, &x398, x387, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_addcarryx_u32(&x399, &x400, 0x0, x398, x395);
  fiat_25519_scalar_addcarryx_u32(&x401, &x402, x400, x396, x393);
  fiat_25519_scalar_addcarryx_u32(&x403, &x404, x402, x394, x391);
  x405 = (x404 + x392);
  fiat_25519_scalar_addcarryx_u32(&x406, &x407, 0x0, x369, x397);
  fiat_25519_scalar_addcarryx_u32(&x408, &x409, x407, x371, x399);
  fiat_25519_scalar_addcarryx_u32(&x410, &x411, x409, x373, x401);
  fiat_25519_scalar_addcarryx_u32(&x412, &x413, x411, x375, x403);
  fiat_25519_scalar_addcarryx_u32(&x414, &x415, x413, x377, x405);
  fiat_25519_scalar_addcarryx_u32(&x416, &x417, x415, x379, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x418, &x419, x417, x381, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x420, &x421, x419, x383, x389);
  fiat_25519_scalar_addcarryx_u32(&x422, &x423, x421, x385, x390);
  x424 = ((uint32_t)x423 + x386);
  fiat_25519_scalar_mulx_u32(&x425, &x426, x5, (arg2[7]));
  fiat_25519_scalar_mulx_u32(&x427, &x428, x5, (arg2[6]));
  fiat_25519_scalar_mulx_u32(&x429, &x430, x5, (arg2[5]));
  fiat_25519_scalar_mulx_u32(&x431, &x432, x5, (arg2[4]));
  fiat_25519_scalar_mulx_u32(&x433, &x434, x5, (arg2[3]));
  fiat_25519_scalar_mulx_u32(&x435, &x436, x5, (arg2[2]));
  fiat_25519_scalar_mulx_u32(&x437, &x438, x5, (arg2[1]));
  fiat_25519_scalar_mulx_u32(&x439, &x440, x5, (arg2[0]));
  fiat_25519_scalar_addcarryx_u32(&x441, &x442, 0x0, x440, x437);
  fiat_25519_scalar_addcarryx_u32(&x443, &x444, x442, x438, x435);
  fiat_25519_scalar_addcarryx_u32(&x445, &x446, x444, x436, x433);
  fiat_25519_scalar_addcarryx_u32(&x447, &x448, x446, x434, x431);
  fiat_25519_scalar_addcarryx_u32(&x449, &x450, x448, x432, x429);
  fiat_25519_scalar_addcarryx_u32(&x451, &x452, x450, x430, x427);
  fiat_25519_scalar_addcarryx_u32(&x453, &x454, x452, x428, x425);
  x455 = (x454 + x426);
  fiat_25519_scalar_addcarryx_u32(&x456, &x457, 0x0, x408, x439);
  fiat_25519_scalar_addcarryx_u32(&x458, &x459, x457, x410, x441);
  fiat_25519_scalar_addcarryx_u32(&x460, &x461, x459, x412, x443);
  fiat_25519_scalar_addcarryx_u32(&x462, &x463, x461, x414, x445);
  fiat_25519_scalar_addcarryx_u32(&x464, &x465, x463, x416, x447);
  fiat_25519_scalar_addcarryx_u32(&x466, &x467, x465, x418, x449);
  fiat_25519_scalar_addcarryx_u32(&x468, &x469, x467, x420, x451);
  fiat_25519_scalar_addcarryx_u32(&x470, &x471, x469, x422, x453);
  fiat_25519_scalar_addcarryx_u32(&x472, &x473, x471, x424, x455);
  fiat_25519_scalar_mulx_u32(&x474, &x475, x456, UINT32_C(0x12547e1b));
  fiat_25519_scalar_mulx_u32(&x476, &x477, x474, UINT32_C(0x10000000));
  fiat_25519_scalar_mulx_u32(&x478, &x479, x474, UINT32_C(0x14def9de));
  fiat_25519_scalar_mulx_u32(&x480, &x481, x474, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_mulx_u32(&x482, &x483, x474, UINT32_C(0x5812631a));
  fiat_25519_scalar_mulx_u32(&x484, &x485, x474, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_addcarryx_u32(&x486, &x487, 0x0, x485, x482);
  fiat_25519_scalar_addcarryx_u32(&x488, &x489, x487, x483, x480);
  fiat_25519_scalar_addcarryx_u32(&x490, &x491, x489, x481, x478);
  x492 = (x491 + x479);
  fiat_25519_scalar_addcarryx_u32(&x493, &x494, 0x0, x456, x484);
  fiat_25519_scalar_addcarryx_u32(&x495, &x496, x494, x458, x486);
  fiat_25519_scalar_addcarryx_u32(&x497, &x498, x496, x460, x488);
  fiat_25519_scalar_addcarryx_u32(&x499, &x500, x498, x462, x490);
  fiat_25519_scalar_addcarryx_u32(&x501, &x502, x500, x464, x492);
  fiat_25519_scalar_addcarryx_u32(&x503, &x504, x502, x466, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x505, &x506, x504, x468, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x507, &x508, x506, x470, x476);
  fiat_25519_scalar_addcarryx_u32(&x509, &x510, x508, x472, x477);
  x511 = ((uint32_t)x510 + x473);
  fiat_25519_scalar_mulx_u32(&x512, &x513, x6, (arg2[7]));
  fiat_25519_scalar_mulx_u32(&x514, &x515, x6, (arg2[6]));
  fiat_25519_scalar_mulx_u32(&x516, &x517, x6, (arg2[5]));
  fiat_25519_scalar_mulx_u32(&x518, &x519, x6, (arg2[4]));
  fiat_25519_scalar_mulx_u32(&x520, &x521, x6, (arg2[3]));
  fiat_25519_scalar_mulx_u32(&x522, &x523, x6, (arg2[2]));
  fiat_25519_scalar_mulx_u32(&x524, &x525, x6, (arg2[1]));
  fiat_25519_scalar_mulx_u32(&x526, &x527, x6, (arg2[0]));
  fiat_25519_scalar_addcarryx_u32(&x528, &x529, 0x0, x527, x524);
  fiat_25519_scalar_addcarryx_u32(&x530, &x531, x529, x525, x522);
  fiat_25519_scalar_addcarryx_u32(&x532, &x533, x531, x523, x520);
  fiat_25519_scalar_addcarryx_u32(&x534, &x535, x533, x521, x518);
  fiat_25519_scalar_addcarryx_u32(&x536, &x537, x535, x519, x516);
  fiat_25519_scalar_addcarryx_u32(&x538, &x539, x537, x517, x514);
  fiat_25519_scalar_addcarryx_u32(&x540, &x541, x539, x515, x512);
  x542 = (x541 + x513);
  fiat_25519_scalar_addcarryx_u32(&x543, &x544, 0x0, x495, x526);
  fiat_25519_scalar_addcarryx_u32(&x545, &x546, x544, x497, x528);
  fiat_25519_scalar_addcarryx_u32(&x547, &x548, x546, x499, x530);
  fiat_25519_scalar_addcarryx_u32(&x549, &x550, x548, x501, x532);
  fiat_25519_scalar_addcarryx_u32(&x551, &x552, x550, x503, x534);
  fiat_25519_scalar_addcarryx_u32(&x553, &x554, x552, x505, x536);
  fiat_25519_scalar_addcarryx_u32(&x555, &x556, x554, x507, x538);
  fiat_25519_scalar_addcarryx_u32(&x557, &x558, x556, x509, x540);
  fiat_25519_scalar_addcarryx_u32(&x559, &x560, x558, x511, x542);
  fiat_25519_scalar_mulx_u32(&x561, &x562, x543, UINT32_C(0x12547e1b));
  fiat_25519_scalar_mulx_u32(&x563, &x564, x561, UINT32_C(0x10000000));
  fiat_25519_scalar_mulx_u32(&x565, &x566, x561, UINT32_C(0x14def9de));
  fiat_25519_scalar_mulx_u32(&x567, &x568, x561, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_mulx_u32(&x569, &x570, x561, UINT32_C(0x5812631a));
  fiat_25519_scalar_mulx_u32(&x571, &x572, x561, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_addcarryx_u32(&x573, &x574, 0x0, x572, x569);
  fiat_25519_scalar_addcarryx_u32(&x575, &x576, x574, x570, x567);
  fiat_25519_scalar_addcarryx_u32(&x577, &x578, x576, x568, x565);
  x579 = (x578 + x566);
  fiat_25519_scalar_addcarryx_u32(&x580, &x581, 0x0, x543, x571);
  fiat_25519_scalar_addcarryx_u32(&x582, &x583, x581, x545, x573);
  fiat_25519_scalar_addcarryx_u32(&x584, &x585, x583, x547, x575);
  fiat_25519_scalar_addcarryx_u32(&x586, &x587, x585, x549, x577);
  fiat_25519_scalar_addcarryx_u32(&x588, &x589, x587, x551, x579);
  fiat_25519_scalar_addcarryx_u32(&x590, &x591, x589, x553, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x592, &x593, x591, x555, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x594, &x595, x593, x557, x563);
  fiat_25519_scalar_addcarryx_u32(&x596, &x597, x595, x559, x564);
  x598 = ((uint32_t)x597 + x560);
  fiat_25519_scalar_mulx_u32(&x599, &x600, x7, (arg2[7]));
  fiat_25519_scalar_mulx_u32(&x601, &x602, x7, (arg2[6]));
  fiat_25519_scalar_mulx_u32(&x603, &x604, x7, (arg2[5]));
  fiat_25519_scalar_mulx_u32(&x605, &x606, x7, (arg2[4]));
  fiat_25519_scalar_mulx_u32(&x607, &x608, x7, (arg2[3]));
  fiat_25519_scalar_mulx_u32(&x609, &x610, x7, (arg2[2]));
  fiat_25519_scalar_mulx_u32(&x611, &x612, x7, (arg2[1]));
  fiat_25519_scalar_mulx_u32(&x613, &x614, x7, (arg2[0]));
  fiat_25519_scalar_addcarryx_u32(&x615, &x616, 0x0, x614, x611);
  fiat_25519_scalar_addcarryx_u32(&x617, &x618, x616, x612, x609);
  fiat_25519_scalar_addcarryx_u32(&x619, &x620, x618, x610, x607);
  fiat_25519_scalar_addcarryx_u32(&x621, &x622, x620, x608, x605);
  fiat_25519_scalar_addcarryx_u32(&x623, &x624, x622, x606, x603);
  fiat_25519_scalar_addcarryx_u32(&x625, &x626, x624, x604, x601);
  fiat_25519_scalar_addcarryx_u32(&x627, &x628, x626, x602, x599);
  x629 = (x628 + x600);
  fiat_25519_scalar_addcarryx_u32(&x630, &x631, 0x0, x582, x613);
  fiat_25519_scalar_addcarryx_u32(&x632, &x633, x631, x584, x615);
  fiat_25519_scalar_addcarryx_u32(&x634, &x635, x633, x586, x617);
  fiat_25519_scalar_addcarryx_u32(&x636, &x637, x635, x588, x619);
  fiat_25519_scalar_addcarryx_u32(&x638, &x639, x637, x590, x621);
  fiat_25519_scalar_addcarryx_u32(&x640, &x641, x639, x592, x623);
  fiat_25519_scalar_addcarryx_u32(&x642, &x643, x641, x594, x625);
  fiat_25519_scalar_addcarryx_u32(&x644, &x645, x643, x596, x627);
  fiat_25519_scalar_addcarryx_u32(&x646, &x647, x645, x598, x629);
  fiat_25519_scalar_mulx_u32(&x648, &x649, x630, UINT32_C(0x12547e1b));
  fiat_25519_scalar_mulx_u32(&x650, &x651, x648, UINT32_C(0x10000000));
  fiat_25519_scalar_mulx_u32(&x652, &x653, x648, UINT32_C(0x14def9de));
  fiat_25519_scalar_mulx_u32(&x654, &x655, x648, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_mulx_u32(&x656, &x657, x648, UINT32_C(0x5812631a));
  fiat_25519_scalar_mulx_u32(&x658, &x659, x648, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_addcarryx_u32(&x660, &x661, 0x0, x659, x656);
  fiat_25519_scalar_addcarryx_u32(&x662, &x663, x661, x657, x654);
  fiat_25519_scalar_addcarryx_u32(&x664, &x665, x663, x655, x652);
  x666 = (x665 + x653);
  fiat_25519_scalar_addcarryx_u32(&x667, &x668, 0x0, x630, x658);
  fiat_25519_scalar_addcarryx_u32(&x669, &x670, x668, x632, x660);
  fiat_25519_scalar_addcarryx_u32(&x671, &x672, x670, x634, x662);
  fiat_25519_scalar_addcarryx_u32(&x673, &x674, x672, x636, x664);
  fiat_25519_scalar_addcarryx_u32(&x675, &x676, x674, x638, x666);
  fiat_25519_scalar_addcarryx_u32(&x677, &x678, x676, x640, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x679, &x680, x678, x642, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x681, &x682, x680, x644, x650);
  fiat_25519_scalar_addcarryx_u32(&x683, &x684, x682, x646, x651);
  x685 = ((uint32_t)x684 + x647);
  fiat_25519_scalar_subborrowx_u32(&x686, &x687, 0x0, x669, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_subborrowx_u32(&x688, &x689, x687, x671, UINT32_C(0x5812631a));
  fiat_25519_scalar_subborrowx_u32(&x690, &x691, x689, x673, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_subborrowx_u32(&x692, &x693, x691, x675, UINT32_C(0x14def9de));
  fiat_25519_scalar_subborrowx_u32(&x694, &x695, x693, x677, 0x0);
  fiat_25519_scalar_subborrowx_u32(&x696, &x697, x695, x679, 0x0);
  fiat_25519_scalar_subborrowx_u32(&x698, &x699, x697, x681, 0x0);
  fiat_25519_scalar_subborrowx_u32(&x700, &x701, x699, x683, UINT32_C(0x10000000));
  fiat_25519_scalar_subborrowx_u32(&x702, &x703, x701, x685, 0x0);
  fiat_25519_scalar_cmovznz_u32(&x704, x703, x686, x669);
  fiat_25519_scalar_cmovznz_u32(&x705, x703, x688, x671);
  fiat_25519_scalar_cmovznz_u32(&x706, x703, x690, x673);
  fiat_25519_scalar_cmovznz_u32(&x707, x703, x692, x675);
  fiat_25519_scalar_cmovznz_u32(&x708, x703, x694, x677);
  fiat_25519_scalar_cmovznz_u32(&x709, x703, x696, x679);
  fiat_25519_scalar_cmovznz_u32(&x710, x703, x698, x681);
  fiat_25519_scalar_cmovznz_u32(&x711, x703, x700, x683);
  out1[0] = x704;
  out1[1] = x705;
  out1[2] = x706;
  out1[3] = x707;
  out1[4] = x708;
  out1[5] = x709;
  out1[6] = x710;
  out1[7] = x711;
}

/*
 * The function fiat_25519_scalar_square squares a field element in the Montgomery domain.
 *
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) * eval (from_montgomery arg1)) mod m
 *   0 ≤ eval out1 < m
 *
 */
static FIAT_25519_SCALAR_FIAT_INLINE void fiat_25519_scalar_square(fiat_25519_scalar_montgomery_domain_field_element out1, const fiat_25519_scalar_montgomery_domain_field_element arg1) {
  uint32_t x1;
  uint32_t x2;
  uint32_t x3;
  uint32_t x4;
  uint32_t x5;
  uint32_t x6;
  uint32_t x7;
  uint32_t x8;
  uint32_t x9;
  uint32_t x10;
  uint32_t x11;
  uint32_t x12;
  uint32_t x13;
  uint32_t x14;
  uint32_t x15;
  uint32_t x16;
  uint32_t x17;
  uint32_t x18;
  uint32_t x19;
  uint32_t x20;
  uint32_t x21;
  uint32_t x22;
  uint32_t x23;
  uint32_t x24;
  uint32_t x25;
  fiat_25519_scalar_uint1 x26;
  uint32_t x27;
  fiat_25519_scalar_uint1 x28;
  uint32_t x29;
  fiat_25519_scalar_uint1 x30;
  uint32_t x31;
  fiat_25519_scalar_uint1 x32;
  uint32_t x33;
  fiat_25519_scalar_uint1 x34;
  uint32_t x35;
  fiat_25519_scalar_uint1 x36;
  uint32_t x37;
  fiat_25519_scalar_uint1 x38;
  uint32_t x39;
  uint32_t x40;
  uint32_t x41;
  uint32_t x42;
  uint32_t x43;
  uint32_t x44;
  uint32_t x45;
  uint32_t x46;
  uint32_t x47;
  uint32_t x48;
  uint32_t x49;
  uint32_t x50;
  uint32_t x51;
  uint32_t x52;
  fiat_25519_scalar_uint1 x53;
  uint32_t x54;
  fiat_25519_scalar_uint1 x55;
  uint32_t x56;
  fiat_25519_scalar_uint1 x57;
  uint32_t x58;
  uint32_t x59;
  fiat_25519_scalar_uint1 x60;
  uint32_t x61;
  fiat_25519_scalar_uint1 x62;
  uint32_t x63;
  fiat_25519_scalar_uint1 x64;
  uint32_t x65;
  fiat_25519_scalar_uint1 x66;
  uint32_t x67;
  fiat_25519_scalar_uint1 x68;
  uint32_t x69;
  fiat_25519_scalar_uint1 x70;
  uint32_t x71;
  fiat_25519_scalar_uint1 x72;
  uint32_t x73;
  fiat_25519_scalar_uint1 x74;
  uint32_t x75;
  fiat_25519_scalar_uint1 x76;
  uint32_t x77;
  uint32_t x78;
  uint32_t x79;
  uint32_t x80;
  uint32_t x81;
  uint32_t x82;
  uint32_t x83;
  uint32_t x84;
  uint32_t x85;
  uint32_t x86;
  uint32_t x87;
  uint32_t x88;
  uint32_t x89;
  uint32_t x90;
  uint32_t x91;
  uint32_t x92;
  uint32_t x93;
  fiat_25519_scalar_uint1 x94;
  uint32_t x95;
  fiat_25519_scalar_uint1 x96;
  uint32_t x97;
  fiat_25519_scalar_uint1 x98;
  uint32_t x99;
  fiat_25519_scalar_uint1 x100;
  uint32_t x101;
  fiat_25519_scalar_uint1 x102;
  uint32_t x103;
  fiat_25519_scalar_uint1 x104;
  uint32_t x105;
  fiat_25519_scalar_uint1 x106;
  uint32_t x107;
  uint32_t x108;
  fiat_25519_scalar_uint1 x109;
  uint32_t x110;
  fiat_25519_scalar_uint1 x111;
  uint32_t x112;
  fiat_25519_scalar_uint1 x113;
  uint32_t x114;
  fiat_25519_scalar_uint1 x115;
  uint32_t x116;
  fiat_25519_scalar_uint1 x117;
  uint32_t x118;
  fiat_25519_scalar_uint1 x119;
  uint32_t x120;
  fiat_25519_scalar_uint1 x121;
  uint32_t x122;
  fiat_25519_scalar_uint1 x123;
  uint32_t x124;
  fiat_25519_scalar_uint1 x125;
  uint32_t x126;
  uint32_t x127;
  uint32_t x128;
  uint32_t x129;
  uint32_t x130;
  uint32_t x131;
  uint32_t x132;
  uint32_t x133;
  uint32_t x134;
  uint32_t x135;
  uint32_t x136;
  uint32_t x137;
  uint32_t x138;
  fiat_25519_scalar_uint1 x139;
  uint32_t x140;
  fiat_25519_scalar_uint1 x141;
  uint32_t x142;
  fiat_25519_scalar_uint1 x143;
  uint32_t x144;
  uint32_t x145;
  fiat_25519_scalar_uint1 x146;
  uint32_t x147;
  fiat_25519_scalar_uint1 x148;
  uint32_t x149;
  fiat_25519_scalar_uint1 x150;
  uint32_t x151;
  fiat_25519_scalar_uint1 x152;
  uint32_t x153;
  fiat_25519_scalar_uint1 x154;
  uint32_t x155;
  fiat_25519_scalar_uint1 x156;
  uint32_t x157;
  fiat_25519_scalar_uint1 x158;
  uint32_t x159;
  fiat_25519_scalar_uint1 x160;
  uint32_t x161;
  fiat_25519_scalar_uint1 x162;
  uint32_t x163;
  uint32_t x164;
  uint32_t x165;
  uint32_t x166;
  uint32_t x167;
  uint32_t x168;
  uint32_t x169;
  uint32_t x170;
  uint32_t x171;
  uint32_t x172;
  uint32_t x173;
  uint32_t x174;
  uint32_t x175;
  uint32_t x176;
  uint32_t x177;
  uint32_t x178;
  uint32_t x179;
  uint32_t x180;
  fiat_25519_scalar_uint1 x181;
  uint32_t x182;
  fiat_25519_scalar_uint1 x183;
  uint32_t x184;
  fiat_25519_scalar_uint1 x185;
  uint32_t x186;
  fiat_25519_scalar_uint1 x187;
  uint32_t x188;
  fiat_25519_scalar_uint1 x189;
  uint32_t x190;
  fiat_25519_scalar_uint1 x191;
  uint32_t x192;
  fiat_25519_scalar_uint1 x193;
  uint32_t x194;
  uint32_t x195;
  fiat_25519_scalar_uint1 x196;
  uint32_t x197;
  fiat_25519_scalar_uint1 x198;
  uint32_t x199;
  fiat_25519_scalar_uint1 x200;
  uint32_t x201;
  fiat_25519_scalar_uint1 x202;
  uint32_t x203;
  fiat_25519_scalar_uint1 x204;
  uint32_t x205;
  fiat_25519_scalar_uint1 x206;
  uint32_t x207;
  fiat_25519_scalar_uint1 x208;
  uint32_t x209;
  fiat_25519_scalar_uint1 x210;
  uint32_t x211;
  fiat_25519_scalar_uint1 x212;
  uint32_t x213;
  uint32_t x214;
  uint32_t x215;
  uint32_t x216;
  uint32_t x217;
  uint32_t x218;
  uint32_t x219;
  uint32_t x220;
  uint32_t x221;
  uint32_t x222;
  uint32_t x223;
  uint32_t x224;
  uint32_t x225;
  fiat_25519_scalar_uint1 x226;
  uint32_t x227;
  fiat_25519_scalar_uint1 x228;
  uint32_t x229;
  fiat_25519_scalar_uint1 x230;
  uint32_t x231;
  uint32_t x232;
  fiat_25519_scalar_uint1 x233;
  uint32_t x234;
  fiat_25519_scalar_uint1 x235;
  uint32_t x236;
  fiat_25519_scalar_uint1 x237;
  uint32_t x238;
  fiat_25519_scalar_uint1 x239;
  uint32_t x240;
  fiat_25519_scalar_uint1 x241;
  uint32_t x242;
  fiat_25519_scalar_uint1 x243;
  uint32_t x244;
  fiat_25519_scalar_uint1 x245;
  uint32_t x246;
  fiat_25519_scalar_uint1 x247;
  uint32_t x248;
  fiat_25519_scalar_uint1 x249;
  uint32_t x250;
  uint32_t x251;
  uint32_t x252;
  uint32_t x253;
  uint32_t x254;
  uint32_t x255;
  uint32_t x256;
  uint32_t x257;
  uint32_t x258;
  uint32_t x259;
  uint32_t x260;
  uint32_t x261;
  uint32_t x262;
  uint32_t x263;
  uint32_t x264;
  uint32_t x265;
  uint32_t x266;
  uint32_t x267;
  fiat_25519_scalar_uint1 x268;
  uint32_t x269;
  fiat_25519_scalar_uint1 x270;
  uint32_t x271;
  fiat_25519_scalar_uint1 x272;
  uint32_t x273;
  fiat_25519_scalar_uint1 x274;
  uint32_t x275;
  fiat_25519_scalar_uint1 x276;
  uint32_t x277;
  fiat_25519_scalar_uint1 x278;
  uint32_t x279;
  fiat_25519_scalar_uint1 x280;
  uint32_t x281;
  uint32_t x282;
  fiat_25519_scalar_uint1 x283;
  uint32_t x284;
  fiat_25519_scalar_uint1 x285;
  uint32_t x286;
  fiat_25519_scalar_uint1 x287;
  uint32_t x288;
  fiat_25519_scalar_uint1 x289;
  uint32_t x290;
  fiat_25519_scalar_uint1 x291;
  uint32_t x292;
  fiat_25519_scalar_uint1 x293;
  uint32_t x294;
  fiat_25519_scalar_uint1 x295;
  uint32_t x296;
  fiat_25519_scalar_uint1 x297;
  uint32_t x298;
  fiat_25519_scalar_uint1 x299;
  uint32_t x300;
  uint32_t x301;
  uint32_t x302;
  uint32_t x303;
  uint32_t x304;
  uint32_t x305;
  uint32_t x306;
  uint32_t x307;
  uint32_t x308;
  uint32_t x309;
  uint32_t x310;
  uint32_t x311;
  uint32_t x312;
  fiat_25519_scalar_uint1 x313;
  uint32_t x314;
  fiat_25519_scalar_uint1 x315;
  uint32_t x316;
  fiat_25519_scalar_uint1 x317;
  uint32_t x318;
  uint32_t x319;
  fiat_25519_scalar_uint1 x320;
  uint32_t x321;
  fiat_25519_scalar_uint1 x322;
  uint32_t x323;
  fiat_25519_scalar_uint1 x324;
  uint32_t x325;
  fiat_25519_scalar_uint1 x326;
  uint32_t x327;
  fiat_25519_scalar_uint1 x328;
  uint32_t x329;
  fiat_25519_scalar_uint1 x330;
  uint32_t x331;
  fiat_25519_scalar_uint1 x332;
  uint32_t x333;
  fiat_25519_scalar_uint1 x334;
  uint32_t x335;
  fiat_25519_scalar_uint1 x336;
  uint32_t x337;
  uint32_t x338;
  uint32_t x339;
  uint32_t x340;
  uint32_t x341;
  uint32_t x342;
  uint32_t x343;
  uint32_t x344;
  uint32_t x345;
  uint32_t x346;
  uint32_t x347;
  uint32_t x348;
  uint32_t x349;
  uint32_t x350;
  uint32_t x351;
  uint32_t x352;
  uint32_t x353;
  uint32_t x354;
  fiat_25519_scalar_uint1 x355;
  uint32_t x356;
  fiat_25519_scalar_uint1 x357;
  uint32_t x358;
  fiat_25519_scalar_uint1 x359;
  uint32_t x360;
  fiat_25519_scalar_uint1 x361;
  uint32_t x362;
  fiat_25519_scalar_uint1 x363;
  uint32_t x364;
  fiat_25519_scalar_uint1 x365;
  uint32_t x366;
  fiat_25519_scalar_uint1 x367;
  uint32_t x368;
  uint32_t x369;
  fiat_25519_scalar_uint1 x370;
  uint32_t x371;
  fiat_25519_scalar_uint1 x372;
  uint32_t x373;
  fiat_25519_scalar_uint1 x374;
  uint32_t x375;
  fiat_25519_scalar_uint1 x376;
  uint32_t x377;
  fiat_25519_scalar_uint1 x378;
  uint32_t x379;
  fiat_25519_scalar_uint1 x380;
  uint32_t x381;
  fiat_25519_scalar_uint1 x382;
  uint32_t x383;
  fiat_25519_scalar_uint1 x384;
  uint32_t x385;
  fiat_25519_scalar_uint1 x386;
  uint32_t x387;
  uint32_t x388;
  uint32_t x389;
  uint32_t x390;
  uint32_t x391;
  uint32_t x392;
  uint32_t x393;
  uint32_t x394;
  uint32_t x395;
  uint32_t x396;
  uint32_t x397;
  uint32_t x398;
  uint32_t x399;
  fiat_25519_scalar_uint1 x400;
  uint32_t x401;
  fiat_25519_scalar_uint1 x402;
  uint32_t x403;
  fiat_25519_scalar_uint1 x404;
  uint32_t x405;
  uint32_t x406;
  fiat_25519_scalar_uint1 x407;
  uint32_t x408;
  fiat_25519_scalar_uint1 x409;
  uint32_t x410;
  fiat_25519_scalar_uint1 x411;
  uint32_t x412;
  fiat_25519_scalar_uint1 x413;
  uint32_t x414;
  fiat_25519_scalar_uint1 x415;
  uint32_t x416;
  fiat_25519_scalar_uint1 x417;
  uint32_t x418;
  fiat_25519_scalar_uint1 x419;
  uint32_t x420;
  fiat_25519_scalar_uint1 x421;
  uint32_t x422;
  fiat_25519_scalar_uint1 x423;
  uint32_t x424;
  uint32_t x425;
  uint32_t x426;
  uint32_t x427;
  uint32_t x428;
  uint32_t x429;
  uint32_t x430;
  uint32_t x431;
  uint32_t x432;
  uint32_t x433;
  uint32_t x434;
  uint32_t x435;
  uint32_t x436;
  uint32_t x437;
  uint32_t x438;
  uint32_t x439;
  uint32_t x440;
  uint32_t x441;
  fiat_25519_scalar_uint1 x442;
  uint32_t x443;
  fiat_25519_scalar_uint1 x444;
  uint32_t x445;
  fiat_25519_scalar_uint1 x446;
  uint32_t x447;
  fiat_25519_scalar_uint1 x448;
  uint32_t x449;
  fiat_25519_scalar_uint1 x450;
  uint32_t x451;
  fiat_25519_scalar_uint1 x452;
  uint32_t x453;
  fiat_25519_scalar_uint1 x454;
  uint32_t x455;
  uint32_t x456;
  fiat_25519_scalar_uint1 x457;
  uint32_t x458;
  fiat_25519_scalar_uint1 x459;
  uint32_t x460;
  fiat_25519_scalar_uint1 x461;
  uint32_t x462;
  fiat_25519_scalar_uint1 x463;
  uint32_t x464;
  fiat_25519_scalar_uint1 x465;
  uint32_t x466;
  fiat_25519_scalar_uint1 x467;
  uint32_t x468;
  fiat_25519_scalar_uint1 x469;
  uint32_t x470;
  fiat_25519_scalar_uint1 x471;
  uint32_t x472;
  fiat_25519_scalar_uint1 x473;
  uint32_t x474;
  uint32_t x475;
  uint32_t x476;
  uint32_t x477;
  uint32_t x478;
  uint32_t x479;
  uint32_t x480;
  uint32_t x481;
  uint32_t x482;
  uint32_t x483;
  uint32_t x484;
  uint32_t x485;
  uint32_t x486;
  fiat_25519_scalar_uint1 x487;
  uint32_t x488;
  fiat_25519_scalar_uint1 x489;
  uint32_t x490;
  fiat_25519_scalar_uint1 x491;
  uint32_t x492;
  uint32_t x493;
  fiat_25519_scalar_uint1 x494;
  uint32_t x495;
  fiat_25519_scalar_uint1 x496;
  uint32_t x497;
  fiat_25519_scalar_uint1 x498;
  uint32_t x499;
  fiat_25519_scalar_uint1 x500;
  uint32_t x501;
  fiat_25519_scalar_uint1 x502;
  uint32_t x503;
  fiat_25519_scalar_uint1 x504;
  uint32_t x505;
  fiat_25519_scalar_uint1 x506;
  uint32_t x507;
  fiat_25519_scalar_uint1 x508;
  uint32_t x509;
  fiat_25519_scalar_uint1 x510;
  uint32_t x511;
  uint32_t x512;
  uint32_t x513;
  uint32_t x514;
  uint32_t x515;
  uint32_t x516;
  uint32_t x517;
  uint32_t x518;
  uint32_t x519;
  uint32_t x520;
  uint32_t x521;
  uint32_t x522;
  uint32_t x523;
  uint32_t x524;
  uint32_t x525;
  uint32_t x526;
  uint32_t x527;
  uint32_t x528;
  fiat_25519_scalar_uint1 x529;
  uint32_t x530;
  fiat_25519_scalar_uint1 x531;
  uint32_t x532;
  fiat_25519_scalar_uint1 x533;
  uint32_t x534;
  fiat_25519_scalar_uint1 x535;
  uint32_t x536;
  fiat_25519_scalar_uint1 x537;
  uint32_t x538;
  fiat_25519_scalar_uint1 x539;
  uint32_t x540;
  fiat_25519_scalar_uint1 x541;
  uint32_t x542;
  uint32_t x543;
  fiat_25519_scalar_uint1 x544;
  uint32_t x545;
  fiat_25519_scalar_uint1 x546;
  uint32_t x547;
  fiat_25519_scalar_uint1 x548;
  uint32_t x549;
  fiat_25519_scalar_uint1 x550;
  uint32_t x551;
  fiat_25519_scalar_uint1 x552;
  uint32_t x553;
  fiat_25519_scalar_uint1 x554;
  uint32_t x555;
  fiat_25519_scalar_uint1 x556;
  uint32_t x557;
  fiat_25519_scalar_uint1 x558;
  uint32_t x559;
  fiat_25519_scalar_uint1 x560;
  uint32_t x561;
  uint32_t x562;
  uint32_t x563;
  uint32_t x564;
  uint32_t x565;
  uint32_t x566;
  uint32_t x567;
  uint32_t x568;
  uint32_t x569;
  uint32_t x570;
  uint32_t x571;
  uint32_t x572;
  uint32_t x573;
  fiat_25519_scalar_uint1 x574;
  uint32_t x575;
  fiat_25519_scalar_uint1 x576;
  uint32_t x577;
  fiat_25519_scalar_uint1 x578;
  uint32_t x579;
  uint32_t x580;
  fiat_25519_scalar_uint1 x581;
  uint32_t x582;
  fiat_25519_scalar_uint1 x583;
  uint32_t x584;
  fiat_25519_scalar_uint1 x585;
  uint32_t x586;
  fiat_25519_scalar_uint1 x587;
  uint32_t x588;
  fiat_25519_scalar_uint1 x589;
  uint32_t x590;
  fiat_25519_scalar_uint1 x591;
  uint32_t x592;
  fiat_25519_scalar_uint1 x593;
  uint32_t x594;
  fiat_25519_scalar_uint1 x595;
  uint32_t x596;
  fiat_25519_scalar_uint1 x597;
  uint32_t x598;
  uint32_t x599;
  uint32_t x600;
  uint32_t x601;
  uint32_t x602;
  uint32_t x603;
  uint32_t x604;
  uint32_t x605;
  uint32_t x606;
  uint32_t x607;
  uint32_t x608;
  uint32_t x609;
  uint32_t x610;
  uint32_t x611;
  uint32_t x612;
  uint32_t x613;
  uint32_t x614;
  uint32_t x615;
  fiat_25519_scalar_uint1 x616;
  uint32_t x617;
  fiat_25519_scalar_uint1 x618;
  uint32_t x619;
  fiat_25519_scalar_uint1 x620;
  uint32_t x621;
  fiat_25519_scalar_uint1 x622;
  uint32_t x623;
  fiat_25519_scalar_uint1 x624;
  uint32_t x625;
  fiat_25519_scalar_uint1 x626;
  uint32_t x627;
  fiat_25519_scalar_uint1 x628;
  uint32_t x629;
  uint32_t x630;
  fiat_25519_scalar_uint1 x631;
  uint32_t x632;
  fiat_25519_scalar_uint1 x633;
  uint32_t x634;
  fiat_25519_scalar_uint1 x635;
  uint32_t x636;
  fiat_25519_scalar_uint1 x637;
  uint32_t x638;
  fiat_25519_scalar_uint1 x639;
  uint32_t x640;
  fiat_25519_scalar_uint1 x641;
  uint32_t x642;
  fiat_25519_scalar_uint1 x643;
  uint32_t x644;
  fiat_25519_scalar_uint1 x645;
  uint32_t x646;
  fiat_25519_scalar_uint1 x647;
  uint32_t x648;
  uint32_t x649;
  uint32_t x650;
  uint32_t x651;
  uint32_t x652;
  uint32_t x653;
  uint32_t x654;
  uint32_t x655;
  uint32_t x656;
  uint32_t x657;
  uint32_t x658;
  uint32_t x659;
  uint32_t x660;
  fiat_25519_scalar_uint1 x661;
  uint32_t x662;
  fiat_25519_scalar_uint1 x663;
  uint32_t x664;
  fiat_25519_scalar_uint1 x665;
  uint32_t x666;
  uint32_t x667;
  fiat_25519_scalar_uint1 x668;
  uint32_t x669;
  fiat_25519_scalar_uint1 x670;
  uint32_t x671;
  fiat_25519_scalar_uint1 x672;
  uint32_t x673;
  fiat_25519_scalar_uint1 x674;
  uint32_t x675;
  fiat_25519_scalar_uint1 x676;
  uint32_t x677;
  fiat_25519_scalar_uint1 x678;
  uint32_t x679;
  fiat_25519_scalar_uint1 x680;
  uint32_t x681;
  fiat_25519_scalar_uint1 x682;
  uint32_t x683;
  fiat_25519_scalar_uint1 x684;
  uint32_t x685;
  uint32_t x686;
  fiat_25519_scalar_uint1 x687;
  uint32_t x688;
  fiat_25519_scalar_uint1 x689;
  uint32_t x690;
  fiat_25519_scalar_uint1 x691;
  uint32_t x692;
  fiat_25519_scalar_uint1 x693;
  uint32_t x694;
  fiat_25519_scalar_uint1 x695;
  uint32_t x696;
  fiat_25519_scalar_uint1 x697;
  uint32_t x698;
  fiat_25519_scalar_uint1 x699;
  uint32_t x700;
  fiat_25519_scalar_uint1 x701;
  uint32_t x702;
  fiat_25519_scalar_uint1 x703;
  uint32_t x704;
  uint32_t x705;
  uint32_t x706;
  uint32_t x707;
  uint32_t x708;
  uint32_t x709;
  uint32_t x710;
  uint32_t x711;
  x1 = (arg1[1]);
  x2 = (arg1[2]);
  x3 = (arg1[3]);
  x4 = (arg1[4]);
  x5 = (arg1[5]);
  x6 = (arg1[6]);
  x7 = (arg1[7]);
  x8 = (arg1[0]);
  fiat_25519_scalar_mulx_u32(&x9, &x10, x8, (arg1[7]));
  fiat_25519_scalar_mulx_u32(&x11, &x12, x8, (arg1[6]));
  fiat_25519_scalar_mulx_u32(&x13, &x14, x8, (arg1[5]));
  fiat_25519_scalar_mulx_u32(&x15, &x16, x8, (arg1[4]));
  fiat_25519_scalar_mulx_u32(&x17, &x18, x8, (arg1[3]));
  fiat_25519_scalar_mulx_u32(&x19, &x20, x8, (arg1[2]));
  fiat_25519_scalar_mulx_u32(&x21, &x22, x8, (arg1[1]));
  fiat_25519_scalar_mulx_u32(&x23, &x24, x8, (arg1[0]));
  fiat_25519_scalar_addcarryx_u32(&x25, &x26, 0x0, x24, x21);
  fiat_25519_scalar_addcarryx_u32(&x27, &x28, x26, x22, x19);
  fiat_25519_scalar_addcarryx_u32(&x29, &x30, x28, x20, x17);
  fiat_25519_scalar_addcarryx_u32(&x31, &x32, x30, x18, x15);
  fiat_25519_scalar_addcarryx_u32(&x33, &x34, x32, x16, x13);
  fiat_25519_scalar_addcarryx_u32(&x35, &x36, x34, x14, x11);
  fiat_25519_scalar_addcarryx_u32(&x37, &x38, x36, x12, x9);
  x39 = (x38 + x10);
  fiat_25519_scalar_mulx_u32(&x40, &x41, x23, UINT32_C(0x12547e1b));
  fiat_25519_scalar_mulx_u32(&x42, &x43, x40, UINT32_C(0x10000000));
  fiat_25519_scalar_mulx_u32(&x44, &x45, x40, UINT32_C(0x14def9de));
  fiat_25519_scalar_mulx_u32(&x46, &x47, x40, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_mulx_u32(&x48, &x49, x40, UINT32_C(0x5812631a));
  fiat_25519_scalar_mulx_u32(&x50, &x51, x40, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_addcarryx_u32(&x52, &x53, 0x0, x51, x48);
  fiat_25519_scalar_addcarryx_u32(&x54, &x55, x53, x49, x46);
  fiat_25519_scalar_addcarryx_u32(&x56, &x57, x55, x47, x44);
  x58 = (x57 + x45);
  fiat_25519_scalar_addcarryx_u32(&x59, &x60, 0x0, x23, x50);
  fiat_25519_scalar_addcarryx_u32(&x61, &x62, x60, x25, x52);
  fiat_25519_scalar_addcarryx_u32(&x63, &x64, x62, x27, x54);
  fiat_25519_scalar_addcarryx_u32(&x65, &x66, x64, x29, x56);
  fiat_25519_scalar_addcarryx_u32(&x67, &x68, x66, x31, x58);
  fiat_25519_scalar_addcarryx_u32(&x69, &x70, x68, x33, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x71, &x72, x70, x35, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x73, &x74, x72, x37, x42);
  fiat_25519_scalar_addcarryx_u32(&x75, &x76, x74, x39, x43);
  fiat_25519_scalar_mulx_u32(&x77, &x78, x1, (arg1[7]));
  fiat_25519_scalar_mulx_u32(&x79, &x80, x1, (arg1[6]));
  fiat_25519_scalar_mulx_u32(&x81, &x82, x1, (arg1[5]));
  fiat_25519_scalar_mulx_u32(&x83, &x84, x1, (arg1[4]));
  fiat_25519_scalar_mulx_u32(&x85, &x86, x1, (arg1[3]));
  fiat_25519_scalar_mulx_u32(&x87, &x88, x1, (arg1[2]));
  fiat_25519_scalar_mulx_u32(&x89, &x90, x1, (arg1[1]));
  fiat_25519_scalar_mulx_u32(&x91, &x92, x1, (arg1[0]));
  fiat_25519_scalar_addcarryx_u32(&x93, &x94, 0x0, x92, x89);
  fiat_25519_scalar_addcarryx_u32(&x95, &x96, x94, x90, x87);
  fiat_25519_scalar_addcarryx_u32(&x97, &x98, x96, x88, x85);
  fiat_25519_scalar_addcarryx_u32(&x99, &x100, x98, x86, x83);
  fiat_25519_scalar_addcarryx_u32(&x101, &x102, x100, x84, x81);
  fiat_25519_scalar_addcarryx_u32(&x103, &x104, x102, x82, x79);
  fiat_25519_scalar_addcarryx_u32(&x105, &x106, x104, x80, x77);
  x107 = (x106 + x78);
  fiat_25519_scalar_addcarryx_u32(&x108, &x109, 0x0, x61, x91);
  fiat_25519_scalar_addcarryx_u32(&x110, &x111, x109, x63, x93);
  fiat_25519_scalar_addcarryx_u32(&x112, &x113, x111, x65, x95);
  fiat_25519_scalar_addcarryx_u32(&x114, &x115, x113, x67, x97);
  fiat_25519_scalar_addcarryx_u32(&x116, &x117, x115, x69, x99);
  fiat_25519_scalar_addcarryx_u32(&x118, &x119, x117, x71, x101);
  fiat_25519_scalar_addcarryx_u32(&x120, &x121, x119, x73, x103);
  fiat_25519_scalar_addcarryx_u32(&x122, &x123, x121, x75, x105);
  fiat_25519_scalar_addcarryx_u32(&x124, &x125, x123, x76, x107);
  fiat_25519_scalar_mulx_u32(&x126, &x127, x108, UINT32_C(0x12547e1b));
  fiat_25519_scalar_mulx_u32(&x128, &x129, x126, UINT32_C(0x10000000));
  fiat_25519_scalar_mulx_u32(&x130, &x131, x126, UINT32_C(0x14def9de));
  fiat_25519_scalar_mulx_u32(&x132, &x133, x126, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_mulx_u32(&x134, &x135, x126, UINT32_C(0x5812631a));
  fiat_25519_scalar_mulx_u32(&x136, &x137, x126, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_addcarryx_u32(&x138, &x139, 0x0, x137, x134);
  fiat_25519_scalar_addcarryx_u32(&x140, &x141, x139, x135, x132);
  fiat_25519_scalar_addcarryx_u32(&x142, &x143, x141, x133, x130);
  x144 = (x143 + x131);
  fiat_25519_scalar_addcarryx_u32(&x145, &x146, 0x0, x108, x136);
  fiat_25519_scalar_addcarryx_u32(&x147, &x148, x146, x110, x138);
  fiat_25519_scalar_addcarryx_u32(&x149, &x150, x148, x112, x140);
  fiat_25519_scalar_addcarryx_u32(&x151, &x152, x150, x114, x142);
  fiat_25519_scalar_addcarryx_u32(&x153, &x154, x152, x116, x144);
  fiat_25519_scalar_addcarryx_u32(&x155, &x156, x154, x118, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x157, &x158, x156, x120, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x159, &x160, x158, x122, x128);
  fiat_25519_scalar_addcarryx_u32(&x161, &x162, x160, x124, x129);
  x163 = ((uint32_t)x162 + x125);
  fiat_25519_scalar_mulx_u32(&x164, &x165, x2, (arg1[7]));
  fiat_25519_scalar_mulx_u32(&x166, &x167, x2, (arg1[6]));
  fiat_25519_scalar_mulx_u32(&x168, &x169, x2, (arg1[5]));
  fiat_25519_scalar_mulx_u32(&x170, &x171, x2, (arg1[4]));
  fiat_25519_scalar_mulx_u32(&x172, &x173, x2, (arg1[3]));
  fiat_25519_scalar_mulx_u32(&x174, &x175, x2, (arg1[2]));
  fiat_25519_scalar_mulx_u32(&x176, &x177, x2, (arg1[1]));
  fiat_25519_scalar_mulx_u32(&x178, &x179, x2, (arg1[0]));
  fiat_25519_scalar_addcarryx_u32(&x180, &x181, 0x0, x179, x176);
  fiat_25519_scalar_addcarryx_u32(&x182, &x183, x181, x177, x174);
  fiat_25519_scalar_addcarryx_u32(&x184, &x185, x183, x175, x172);
  fiat_25519_scalar_addcarryx_u32(&x186, &x187, x185, x173, x170);
  fiat_25519_scalar_addcarryx_u32(&x188, &x189, x187, x171, x168);
  fiat_25519_scalar_addcarryx_u32(&x190, &x191, x189, x169, x166);
  fiat_25519_scalar_addcarryx_u32(&x192, &x193, x191, x167, x164);
  x194 = (x193 + x165);
  fiat_25519_scalar_addcarryx_u32(&x195, &x196, 0x0, x147, x178);
  fiat_25519_scalar_addcarryx_u32(&x197, &x198, x196, x149, x180);
  fiat_25519_scalar_addcarryx_u32(&x199, &x200, x198, x151, x182);
  fiat_25519_scalar_addcarryx_u32(&x201, &x202, x200, x153, x184);
  fiat_25519_scalar_addcarryx_u32(&x203, &x204, x202, x155, x186);
  fiat_25519_scalar_addcarryx_u32(&x205, &x206, x204, x157, x188);
  fiat_25519_scalar_addcarryx_u32(&x207, &x208, x206, x159, x190);
  fiat_25519_scalar_addcarryx_u32(&x209, &x210, x208, x161, x192);
  fiat_25519_scalar_addcarryx_u32(&x211, &x212, x210, x163, x194);
  fiat_25519_scalar_mulx_u32(&x213, &x214, x195, UINT32_C(0x12547e1b));
  fiat_25519_scalar_mulx_u32(&x215, &x216, x213, UINT32_C(0x10000000));
  fiat_25519_scalar_mulx_u32(&x217, &x218, x213, UINT32_C(0x14def9de));
  fiat_25519_scalar_mulx_u32(&x219, &x220, x213, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_mulx_u32(&x221, &x222, x213, UINT32_C(0x5812631a));
  fiat_25519_scalar_mulx_u32(&x223, &x224, x213, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_addcarryx_u32(&x225, &x226, 0x0, x224, x221);
  fiat_25519_scalar_addcarryx_u32(&x227, &x228, x226, x222, x219);
  fiat_25519_scalar_addcarryx_u32(&x229, &x230, x228, x220, x217);
  x231 = (x230 + x218);
  fiat_25519_scalar_addcarryx_u32(&x232, &x233, 0x0, x195, x223);
  fiat_25519_scalar_addcarryx_u32(&x234, &x235, x233, x197, x225);
  fiat_25519_scalar_addcarryx_u32(&x236, &x237, x235, x199, x227);
  fiat_25519_scalar_addcarryx_u32(&x238, &x239, x237, x201, x229);
  fiat_25519_scalar_addcarryx_u32(&x240, &x241, x239, x203, x231);
  fiat_25519_scalar_addcarryx_u32(&x242, &x243, x241, x205, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x244, &x245, x243, x207, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x246, &x247, x245, x209, x215);
  fiat_25519_scalar_addcarryx_u32(&x248, &x249, x247, x211, x216);
  x250 = ((uint32_t)x249 + x212);
  fiat_25519_scalar_mulx_u32(&x251, &x252, x3, (arg1[7]));
  fiat_25519_scalar_mulx_u32(&x253, &x254, x3, (arg1[6]));
  fiat_25519_scalar_mulx_u32(&x255, &x256, x3, (arg1[5]));
  fiat_25519_scalar_mulx_u32(&x257, &x258, x3, (arg1[4]));
  fiat_25519_scalar_mulx_u32(&x259, &x260, x3, (arg1[3]));
  fiat_25519_scalar_mulx_u32(&x261, &x262, x3, (arg1[2]));
  fiat_25519_scalar_mulx_u32(&x263, &x264, x3, (arg1[1]));
  fiat_25519_scalar_mulx_u32(&x265, &x266, x3, (arg1[0]));
  fiat_25519_scalar_addcarryx_u32(&x267, &x268, 0x0, x266, x263);
  fiat_25519_scalar_addcarryx_u32(&x269, &x270, x268, x264, x261);
  fiat_25519_scalar_addcarryx_u32(&x271, &x272, x270, x262, x259);
  fiat_25519_scalar_addcarryx_u32(&x273, &x274, x272, x260, x257);
  fiat_25519_scalar_addcarryx_u32(&x275, &x276, x274, x258, x255);
  fiat_25519_scalar_addcarryx_u32(&x277, &x278, x276, x256, x253);
  fiat_25519_scalar_addcarryx_u32(&x279, &x280, x278, x254, x251);
  x281 = (x280 + x252);
  fiat_25519_scalar_addcarryx_u32(&x282, &x283, 0x0, x234, x265);
  fiat_25519_scalar_addcarryx_u32(&x284, &x285, x283, x236, x267);
  fiat_25519_scalar_addcarryx_u32(&x286, &x287, x285, x238, x269);
  fiat_25519_scalar_addcarryx_u32(&x288, &x289, x287, x240, x271);
  fiat_25519_scalar_addcarryx_u32(&x290, &x291, x289, x242, x273);
  fiat_25519_scalar_addcarryx_u32(&x292, &x293, x291, x244, x275);
  fiat_25519_scalar_addcarryx_u32(&x294, &x295, x293, x246, x277);
  fiat_25519_scalar_addcarryx_u32(&x296, &x297, x295, x248, x279);
  fiat_25519_scalar_addcarryx_u32(&x298, &x299, x297, x250, x281);
  fiat_25519_scalar_mulx_u32(&x300, &x301, x282, UINT32_C(0x12547e1b));
  fiat_25519_scalar_mulx_u32(&x302, &x303, x300, UINT32_C(0x10000000));
  fiat_25519_scalar_mulx_u32(&x304, &x305, x300, UINT32_C(0x14def9de));
  fiat_25519_scalar_mulx_u32(&x306, &x307, x300, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_mulx_u32(&x308, &x309, x300, UINT32_C(0x5812631a));
  fiat_25519_scalar_mulx_u32(&x310, &x311, x300, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_addcarryx_u32(&x312, &x313, 0x0, x311, x308);
  fiat_25519_scalar_addcarryx_u32(&x314, &x315, x313, x309, x306);
  fiat_25519_scalar_addcarryx_u32(&x316, &x317, x315, x307, x304);
  x318 = (x317 + x305);
  fiat_25519_scalar_addcarryx_u32(&x319, &x320, 0x0, x282, x310);
  fiat_25519_scalar_addcarryx_u32(&x321, &x322, x320, x284, x312);
  fiat_25519_scalar_addcarryx_u32(&x323, &x324, x322, x286, x314);
  fiat_25519_scalar_addcarryx_u32(&x325, &x326, x324, x288, x316);
  fiat_25519_scalar_addcarryx_u32(&x327, &x328, x326, x290, x318);
  fiat_25519_scalar_addcarryx_u32(&x329, &x330, x328, x292, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x331, &x332, x330, x294, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x333, &x334, x332, x296, x302);
  fiat_25519_scalar_addcarryx_u32(&x335, &x336, x334, x298, x303);
  x337 = ((uint32_t)x336 + x299);
  fiat_25519_scalar_mulx_u32(&x338, &x339, x4, (arg1[7]));
  fiat_25519_scalar_mulx_u32(&x340, &x341, x4, (arg1[6]));
  fiat_25519_scalar_mulx_u32(&x342, &x343, x4, (arg1[5]));
  fiat_25519_scalar_mulx_u32(&x344, &x345, x4, (arg1[4]));
  fiat_25519_scalar_mulx_u32(&x346, &x347, x4, (arg1[3]));
  fiat_25519_scalar_mulx_u32(&x348, &x349, x4, (arg1[2]));
  fiat_25519_scalar_mulx_u32(&x350, &x351, x4, (arg1[1]));
  fiat_25519_scalar_mulx_u32(&x352, &x353, x4, (arg1[0]));
  fiat_25519_scalar_addcarryx_u32(&x354, &x355, 0x0, x353, x350);
  fiat_25519_scalar_addcarryx_u32(&x356, &x357, x355, x351, x348);
  fiat_25519_scalar_addcarryx_u32(&x358, &x359, x357, x349, x346);
  fiat_25519_scalar_addcarryx_u32(&x360, &x361, x359, x347, x344);
  fiat_25519_scalar_addcarryx_u32(&x362, &x363, x361, x345, x342);
  fiat_25519_scalar_addcarryx_u32(&x364, &x365, x363, x343, x340);
  fiat_25519_scalar_addcarryx_u32(&x366, &x367, x365, x341, x338);
  x368 = (x367 + x339);
  fiat_25519_scalar_addcarryx_u32(&x369, &x370, 0x0, x321, x352);
  fiat_25519_scalar_addcarryx_u32(&x371, &x372, x370, x323, x354);
  fiat_25519_scalar_addcarryx_u32(&x373, &x374, x372, x325, x356);
  fiat_25519_scalar_addcarryx_u32(&x375, &x376, x374, x327, x358);
  fiat_25519_scalar_addcarryx_u32(&x377, &x378, x376, x329, x360);
  fiat_25519_scalar_addcarryx_u32(&x379, &x380, x378, x331, x362);
  fiat_25519_scalar_addcarryx_u32(&x381, &x382, x380, x333, x364);
  fiat_25519_scalar_addcarryx_u32(&x383, &x384, x382, x335, x366);
  fiat_25519_scalar_addcarryx_u32(&x385, &x386, x384, x337, x368);
  fiat_25519_scalar_mulx_u32(&x387, &x388, x369, UINT32_C(0x12547e1b));
  fiat_25519_scalar_mulx_u32(&x389, &x390, x387, UINT32_C(0x10000000));
  fiat_25519_scalar_mulx_u32(&x391, &x392, x387, UINT32_C(0x14def9de));
  fiat_25519_scalar_mulx_u32(&x393, &x394, x387, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_mulx_u32(&x395, &x396, x387, UINT32_C(0x5812631a));
  fiat_25519_scalar_mulx_u32(&x397, &x398, x387, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_addcarryx_u32(&x399, &x400, 0x0, x398, x395);
  fiat_25519_scalar_addcarryx_u32(&x401, &x402, x400, x396, x393);
  fiat_25519_scalar_addcarryx_u32(&x403, &x404, x402, x394, x391);
  x405 = (x404 + x392);
  fiat_25519_scalar_addcarryx_u32(&x406, &x407, 0x0, x369, x397);
  fiat_25519_scalar_addcarryx_u32(&x408, &x409, x407, x371, x399);
  fiat_25519_scalar_addcarryx_u32(&x410, &x411, x409, x373, x401);
  fiat_25519_scalar_addcarryx_u32(&x412, &x413, x411, x375, x403);
  fiat_25519_scalar_addcarryx_u32(&x414, &x415, x413, x377, x405);
  fiat_25519_scalar_addcarryx_u32(&x416, &x417, x415, x379, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x418, &x419, x417, x381, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x420, &x421, x419, x383, x389);
  fiat_25519_scalar_addcarryx_u32(&x422, &x423, x421, x385, x390);
  x424 = ((uint32_t)x423 + x386);
  fiat_25519_scalar_mulx_u32(&x425, &x426, x5, (arg1[7]));
  fiat_25519_scalar_mulx_u32(&x427, &x428, x5, (arg1[6]));
  fiat_25519_scalar_mulx_u32(&x429, &x430, x5, (arg1[5]));
  fiat_25519_scalar_mulx_u32(&x431, &x432, x5, (arg1[4]));
  fiat_25519_scalar_mulx_u32(&x433, &x434, x5, (arg1[3]));
  fiat_25519_scalar_mulx_u32(&x435, &x436, x5, (arg1[2]));
  fiat_25519_scalar_mulx_u32(&x437, &x438, x5, (arg1[1]));
  fiat_25519_scalar_mulx_u32(&x439, &x440, x5, (arg1[0]));
  fiat_25519_scalar_addcarryx_u32(&x441, &x442, 0x0, x440, x437);
  fiat_25519_scalar_addcarryx_u32(&x443, &x444, x442, x438, x435);
  fiat_25519_scalar_addcarryx_u32(&x445, &x446, x444, x436, x433);
  fiat_25519_scalar_addcarryx_u32(&x447, &x448, x446, x434, x431);
  fiat_25519_scalar_addcarryx_u32(&x449, &x450, x448, x432, x429);
  fiat_25519_scalar_addcarryx_u32(&x451, &x452, x450, x430, x427);
  fiat_25519_scalar_addcarryx_u32(&x453, &x454, x452, x428, x425);
  x455 = (x454 + x426);
  fiat_25519_scalar_addcarryx_u32(&x456, &x457, 0x0, x408, x439);
  fiat_25519_scalar_addcarryx_u32(&x458, &x459, x457, x410, x441);
  fiat_25519_scalar_addcarryx_u32(&x460, &x461, x459, x412, x443);
  fiat_25519_scalar_addcarryx_u32(&x462, &x463, x461, x414, x445);
  fiat_25519_scalar_addcarryx_u32(&x464, &x465, x463, x416, x447);
  fiat_25519_scalar_addcarryx_u32(&x466, &x467, x465, x418, x449);
  fiat_25519_scalar_addcarryx_u32(&x468, &x469, x467, x420, x451);
  fiat_25519_scalar_addcarryx_u32(&x470, &x471, x469, x422, x453);
  fiat_25519_scalar_addcarryx_u32(&x472, &x473, x471, x424, x455);
  fiat_25519_scalar_mulx_u32(&x474, &x475, x456, UINT32_C(0x12547e1b));
  fiat_25519_scalar_mulx_u32(&x476, &x477, x474, UINT32_C(0x10000000));
  fiat_25519_scalar_mulx_u32(&x478, &x479, x474, UINT32_C(0x14def9de));
  fiat_25519_scalar_mulx_u32(&x480, &x481, x474, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_mulx_u32(&x482, &x483, x474, UINT32_C(0x5812631a));
  fiat_25519_scalar_mulx_u32(&x484, &x485, x474, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_addcarryx_u32(&x486, &x487, 0x0, x485, x482);
  fiat_25519_scalar_addcarryx_u32(&x488, &x489, x487, x483, x480);
  fiat_25519_scalar_addcarryx_u32(&x490, &x491, x489, x481, x478);
  x492 = (x491 + x479);
  fiat_25519_scalar_addcarryx_u32(&x493, &x494, 0x0, x456, x484);
  fiat_25519_scalar_addcarryx_u32(&x495, &x496, x494, x458, x486);
  fiat_25519_scalar_addcarryx_u32(&x497, &x498, x496, x460, x488);
  fiat_25519_scalar_addcarryx_u32(&x499, &x500, x498, x462, x490);
  fiat_25519_scalar_addcarryx_u32(&x501, &x502, x500, x464, x492);
  fiat_25519_scalar_addcarryx_u32(&x503, &x504, x502, x466, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x505, &x506, x504, x468, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x507, &x508, x506, x470, x476);
  fiat_25519_scalar_addcarryx_u32(&x509, &x510, x508, x472, x477);
  x511 = ((uint32_t)x510 + x473);
  fiat_25519_scalar_mulx_u32(&x512, &x513, x6, (arg1[7]));
  fiat_25519_scalar_mulx_u32(&x514, &x515, x6, (arg1[6]));
  fiat_25519_scalar_mulx_u32(&x516, &x517, x6, (arg1[5]));
  fiat_25519_scalar_mulx_u32(&x518, &x519, x6, (arg1[4]));
  fiat_25519_scalar_mulx_u32(&x520, &x521, x6, (arg1[3]));
  fiat_25519_scalar_mulx_u32(&x522, &x523, x6, (arg1[2]));
  fiat_25519_scalar_mulx_u32(&x524, &x525, x6, (arg1[1]));
  fiat_25519_scalar_mulx_u32(&x526, &x527, x6, (arg1[0]));
  fiat_25519_scalar_addcarryx_u32(&x528, &x529, 0x0, x527, x524);
  fiat_25519_scalar_addcarryx_u32(&x530, &x531, x529, x525, x522);
  fiat_25519_scalar_addcarryx_u32(&x532, &x533, x531, x523, x520);
  fiat_25519_scalar_addcarryx_u32(&x534, &x535, x533, x521, x518);
  fiat_25519_scalar_addcarryx_u32(&x536, &x537, x535, x519, x516);
  fiat_25519_scalar_addcarryx_u32(&x538, &x539, x537, x517, x514);
  fiat_25519_scalar_addcarryx_u32(&x540, &x541, x539, x515, x512);
  x542 = (x541 + x513);
  fiat_25519_scalar_addcarryx_u32(&x543, &x544, 0x0, x495, x526);
  fiat_25519_scalar_addcarryx_u32(&x545, &x546, x544, x497, x528);
  fiat_25519_scalar_addcarryx_u32(&x547, &x548, x546, x499, x530);
  fiat_25519_scalar_addcarryx_u32(&x549, &x550, x548, x501, x532);
  fiat_25519_scalar_addcarryx_u32(&x551, &x552, x550, x503, x534);
  fiat_25519_scalar_addcarryx_u32(&x553, &x554, x552, x505, x536);
  fiat_25519_scalar_addcarryx_u32(&x555, &x556, x554, x507, x538);
  fiat_25519_scalar_addcarryx_u32(&x557, &x558, x556, x509, x540);
  fiat_25519_scalar_addcarryx_u32(&x559, &x560, x558, x511, x542);
  fiat_25519_scalar_mulx_u32(&x561, &x562, x543, UINT32_C(0x12547e1b));
  fiat_25519_scalar_mulx_u32(&x563, &x564, x561, UINT32_C(0x10000000));
  fiat_25519_scalar_mulx_u32(&x565, &x566, x561, UINT32_C(0x14def9de));
  fiat_25519_scalar_mulx_u32(&x567, &x568, x561, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_mulx_u32(&x569, &x570, x561, UINT32_C(0x5812631a));
  fiat_25519_scalar_mulx_u32(&x571, &x572, x561, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_addcarryx_u32(&x573, &x574, 0x0, x572, x569);
  fiat_25519_scalar_addcarryx_u32(&x575, &x576, x574, x570, x567);
  fiat_25519_scalar_addcarryx_u32(&x577, &x578, x576, x568, x565);
  x579 = (x578 + x566);
  fiat_25519_scalar_addcarryx_u32(&x580, &x581, 0x0, x543, x571);
  fiat_25519_scalar_addcarryx_u32(&x582, &x583, x581, x545, x573);
  fiat_25519_scalar_addcarryx_u32(&x584, &x585, x583, x547, x575);
  fiat_25519_scalar_addcarryx_u32(&x586, &x587, x585, x549, x577);
  fiat_25519_scalar_addcarryx_u32(&x588, &x589, x587, x551, x579);
  fiat_25519_scalar_addcarryx_u32(&x590, &x591, x589, x553, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x592, &x593, x591, x555, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x594, &x595, x593, x557, x563);
  fiat_25519_scalar_addcarryx_u32(&x596, &x597, x595, x559, x564);
  x598 = ((uint32_t)x597 + x560);
  fiat_25519_scalar_mulx_u32(&x599, &x600, x7, (arg1[7]));
  fiat_25519_scalar_mulx_u32(&x601, &x602, x7, (arg1[6]));
  fiat_25519_scalar_mulx_u32(&x603, &x604, x7, (arg1[5]));
  fiat_25519_scalar_mulx_u32(&x605, &x606, x7, (arg1[4]));
  fiat_25519_scalar_mulx_u32(&x607, &x608, x7, (arg1[3]));
  fiat_25519_scalar_mulx_u32(&x609, &x610, x7, (arg1[2]));
  fiat_25519_scalar_mulx_u32(&x611, &x612, x7, (arg1[1]));
  fiat_25519_scalar_mulx_u32(&x613, &x614, x7, (arg1[0]));
  fiat_25519_scalar_addcarryx_u32(&x615, &x616, 0x0, x614, x611);
  fiat_25519_scalar_addcarryx_u32(&x617, &x618, x616, x612, x609);
  fiat_25519_scalar_addcarryx_u32(&x619, &x620, x618, x610, x607);
  fiat_25519_scalar_addcarryx_u32(&x621, &x622, x620, x608, x605);
  fiat_25519_scalar_addcarryx_u32(&x623, &x624, x622, x606, x603);
  fiat_25519_scalar_addcarryx_u32(&x625, &x626, x624, x604, x601);
  fiat_25519_scalar_addcarryx_u32(&x627, &x628, x626, x602, x599);
  x629 = (x628 + x600);
  fiat_25519_scalar_addcarryx_u32(&x630, &x631, 0x0, x582, x613);
  fiat_25519_scalar_addcarryx_u32(&x632, &x633, x631, x584, x615);
  fiat_25519_scalar_addcarryx_u32(&x634, &x635, x633, x586, x617);
  fiat_25519_scalar_addcarryx_u32(&x636, &x637, x635, x588, x619);
  fiat_25519_scalar_addcarryx_u32(&x638, &x639, x637, x590, x621);
  fiat_25519_scalar_addcarryx_u32(&x640, &x641, x639, x592, x623);
  fiat_25519_scalar_addcarryx_u32(&x642, &x643, x641, x594, x625);
  fiat_25519_scalar_addcarryx_u32(&x644, &x645, x643, x596, x627);
  fiat_25519_scalar_addcarryx_u32(&x646, &x647, x645, x598, x629);
  fiat_25519_scalar_mulx_u32(&x648, &x649, x630, UINT32_C(0x12547e1b));
  fiat_25519_scalar_mulx_u32(&x650, &x651, x648, UINT32_C(0x10000000));
  fiat_25519_scalar_mulx_u32(&x652, &x653, x648, UINT32_C(0x14def9de));
  fiat_25519_scalar_mulx_u32(&x654, &x655, x648, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_mulx_u32(&x656, &x657, x648, UINT32_C(0x5812631a));
  fiat_25519_scalar_mulx_u32(&x658, &x659, x648, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_addcarryx_u32(&x660, &x661, 0x0, x659, x656);
  fiat_25519_scalar_addcarryx_u32(&x662, &x663, x661, x657, x654);
  fiat_25519_scalar_addcarryx_u32(&x664, &x665, x663, x655, x652);
  x666 = (x665 + x653);
  fiat_25519_scalar_addcarryx_u32(&x667, &x668, 0x0, x630, x658);
  fiat_25519_scalar_addcarryx_u32(&x669, &x670, x668, x632, x660);
  fiat_25519_scalar_addcarryx_u32(&x671, &x672, x670, x634, x662);
  fiat_25519_scalar_addcarryx_u32(&x673, &x674, x672, x636, x664);
  fiat_25519_scalar_addcarryx_u32(&x675, &x676, x674, x638, x666);
  fiat_25519_scalar_addcarryx_u32(&x677, &x678, x676, x640, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x679, &x680, x678, x642, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x681, &x682, x680, x644, x650);
  fiat_25519_scalar_addcarryx_u32(&x683, &x684, x682, x646, x651);
  x685 = ((uint32_t)x684 + x647);
  fiat_25519_scalar_subborrowx_u32(&x686, &x687, 0x0, x669, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_subborrowx_u32(&x688, &x689, x687, x671, UINT32_C(0x5812631a));
  fiat_25519_scalar_subborrowx_u32(&x690, &x691, x689, x673, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_subborrowx_u32(&x692, &x693, x691, x675, UINT32_C(0x14def9de));
  fiat_25519_scalar_subborrowx_u32(&x694, &x695, x693, x677, 0x0);
  fiat_25519_scalar_subborrowx_u32(&x696, &x697, x695, x679, 0x0);
  fiat_25519_scalar_subborrowx_u32(&x698, &x699, x697, x681, 0x0);
  fiat_25519_scalar_subborrowx_u32(&x700, &x701, x699, x683, UINT32_C(0x10000000));
  fiat_25519_scalar_subborrowx_u32(&x702, &x703, x701, x685, 0x0);
  fiat_25519_scalar_cmovznz_u32(&x704, x703, x686, x669);
  fiat_25519_scalar_cmovznz_u32(&x705, x703, x688, x671);
  fiat_25519_scalar_cmovznz_u32(&x706, x703, x690, x673);
  fiat_25519_scalar_cmovznz_u32(&x707, x703, x692, x675);
  fiat_25519_scalar_cmovznz_u32(&x708, x703, x694, x677);
  fiat_25519_scalar_cmovznz_u32(&x709, x703, x696, x679);
  fiat_25519_scalar_cmovznz_u32(&x710, x703, x698, x681);
  fiat_25519_scalar_cmovznz_u32(&x711, x703, x700, x683);
  out1[0] = x704;
  out1[1] = x705;
  out1[2] = x706;
  out1[3] = x707;
  out1[4] = x708;
  out1[5] = x709;
  out1[6] = x710;
  out1[7] = x711;
}

/*
 * The function fiat_25519_scalar_add adds two field elements in the Montgomery domain.
 *
 * Preconditions:
 *   0 ≤ eval arg1 < m
 *   0 ≤ eval arg2 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) + eval (from_montgomery arg2)) mod m
 *   0 ≤ eval out1 < m
 *
 */
static FIAT_25519_SCALAR_FIAT_INLINE void fiat_25519_scalar_add(fiat_25519_scalar_montgomery_domain_field_element out1, const fiat_25519_scalar_montgomery_domain_field_element arg1, const fiat_25519_scalar_montgomery_domain_field_element arg2) {
  uint32_t x1;
  fiat_25519_scalar_uint1 x2;
  uint32_t x3;
  fiat_25519_scalar_uint1 x4;
  uint32_t x5;
  fiat_25519_scalar_uint1 x6;
  uint32_t x7;
  fiat_25519_scalar_uint1 x8;
  uint32_t x9;
  fiat_25519_scalar_uint1 x10;
  uint32_t x11;
  fiat_25519_scalar_uint1 x12;
  uint32_t x13;
  fiat_25519_scalar_uint1 x14;
  uint32_t x15;
  fiat_25519_scalar_uint1 x16;
  uint32_t x17;
  fiat_25519_scalar_uint1 x18;
  uint32_t x19;
  fiat_25519_scalar_uint1 x20;
  uint32_t x21;
  fiat_25519_scalar_uint1 x22;
  uint32_t x23;
  fiat_25519_scalar_uint1 x24;
  uint32_t x25;
  fiat_25519_scalar_uint1 x26;
  uint32_t x27;
  fiat_25519_scalar_uint1 x28;
  uint32_t x29;
  fiat_25519_scalar_uint1 x30;
  uint32_t x31;
  fiat_25519_scalar_uint1 x32;
  uint32_t x33;
  fiat_25519_scalar_uint1 x34;
  uint32_t x35;
  uint32_t x36;
  uint32_t x37;
  uint32_t x38;
  uint32_t x39;
  uint32_t x40;
  uint32_t x41;
  uint32_t x42;
  fiat_25519_scalar_addcarryx_u32(&x1, &x2, 0x0, (arg1[0]), (arg2[0]));
  fiat_25519_scalar_addcarryx_u32(&x3, &x4, x2, (arg1[1]), (arg2[1]));
  fiat_25519_scalar_addcarryx_u32(&x5, &x6, x4, (arg1[2]), (arg2[2]));
  fiat_25519_scalar_addcarryx_u32(&x7, &x8, x6, (arg1[3]), (arg2[3]));
  fiat_25519_scalar_addcarryx_u32(&x9, &x10, x8, (arg1[4]), (arg2[4]));
  fiat_25519_scalar_addcarryx_u32(&x11, &x12, x10, (arg1[5]), (arg2[5]));
  fiat_25519_scalar_addcarryx_u32(&x13, &x14, x12, (arg1[6]), (arg2[6]));
  fiat_25519_scalar_addcarryx_u32(&x15, &x16, x14, (arg1[7]), (arg2[7]));
  fiat_25519_scalar_subborrowx_u32(&x17, &x18, 0x0, x1, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_subborrowx_u32(&x19, &x20, x18, x3, UINT32_C(0x5812631a));
  fiat_25519_scalar_subborrowx_u32(&x21, &x22, x20, x5, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_subborrowx_u32(&x23, &x24, x22, x7, UINT32_C(0x14def9de));
  fiat_25519_scalar_subborrowx_u32(&x25, &x26, x24, x9, 0x0);
  fiat_25519_scalar_subborrowx_u32(&x27, &x28, x26, x11, 0x0);
  fiat_25519_scalar_subborrowx_u32(&x29, &x30, x28, x13, 0x0);
  fiat_25519_scalar_subborrowx_u32(&x31, &x32, x30, x15, UINT32_C(0x10000000));
  fiat_25519_scalar_subborrowx_u32(&x33, &x34, x32, x16, 0x0);
  fiat_25519_scalar_cmovznz_u32(&x35, x34, x17, x1);
  fiat_25519_scalar_cmovznz_u32(&x36, x34, x19, x3);
  fiat_25519_scalar_cmovznz_u32(&x37, x34, x21, x5);
  fiat_25519_scalar_cmovznz_u32(&x38, x34, x23, x7);
  fiat_25519_scalar_cmovznz_u32(&x39, x34, x25, x9);
  fiat_25519_scalar_cmovznz_u32(&x40, x34, x27, x11);
  fiat_25519_scalar_cmovznz_u32(&x41, x34, x29, x13);
  fiat_25519_scalar_cmovznz_u32(&x42, x34, x31, x15);
  out1[0] = x35;
  out1[1] = x36;
  out1[2] = x37;
  out1[3] = x38;
  out1[4] = x39;
  out1[5] = x40;
  out1[6] = x41;
  out1[7] = x42;
}

/*
 * The function fiat_25519_scalar_sub subtracts two field elements in the Montgomery domain.
 *
 * Preconditions:
 *   0 ≤ eval arg1 < m
 *   0 ≤ eval arg2 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) - eval (from_montgomery arg2)) mod m
 *   0 ≤ eval out1 < m
 *
 */
static FIAT_25519_SCALAR_FIAT_INLINE void fiat_25519_scalar_sub(fiat_25519_scalar_montgomery_domain_field_element out1, const fiat_25519_scalar_montgomery_domain_field_element arg1, const fiat_25519_scalar_montgomery_domain_field_element arg2) {
  uint32_t x1;
  fiat_25519_scalar_uint1 x2;
  uint32_t x3;
  fiat_25519_scalar_uint1 x4;
  uint32_t x5;
  fiat_25519_scalar_uint1 x6;
  uint32_t x7;
  fiat_25519_scalar_uint1 x8;
  uint32_t x9;
  fiat_25519_scalar_uint1 x10;
  uint32_t x11;
  fiat_25519_scalar_uint1 x12;
  uint32_t x13;
  fiat_25519_scalar_uint1 x14;
  uint32_t x15;
  fiat_25519_scalar_uint1 x16;
  uint32_t x17;
  uint32_t x18;
  fiat_25519_scalar_uint1 x19;
  uint32_t x20;
  fiat_25519_scalar_uint1 x21;
  uint32_t x22;
  fiat_25519_scalar_uint1 x23;
  uint32_t x24;
  fiat_25519_scalar_uint1 x25;
  uint32_t x26;
  fiat_25519_scalar_uint1 x27;
  uint32_t x28;
  fiat_25519_scalar_uint1 x29;
  uint32_t x30;
  fiat_25519_scalar_uint1 x31;
  uint32_t x32;
  fiat_25519_scalar_uint1 x33;
  fiat_25519_scalar_subborrowx_u32(&x1, &x2, 0x0, (arg1[0]), (arg2[0]));
  fiat_25519_scalar_subborrowx_u32(&x3, &x4, x2, (arg1[1]), (arg2[1]));
  fiat_25519_scalar_subborrowx_u32(&x5, &x6, x4, (arg1[2]), (arg2[2]));
  fiat_25519_scalar_subborrowx_u32(&x7, &x8, x6, (arg1[3]), (arg2[3]));
  fiat_25519_scalar_subborrowx_u32(&x9, &x10, x8, (arg1[4]), (arg2[4]));
  fiat_25519_scalar_subborrowx_u32(&x11, &x12, x10, (arg1[5]), (arg2[5]));
  fiat_25519_scalar_subborrowx_u32(&x13, &x14, x12, (arg1[6]), (arg2[6]));
  fiat_25519_scalar_subborrowx_u32(&x15, &x16, x14, (arg1[7]), (arg2[7]));
  fiat_25519_scalar_cmovznz_u32(&x17, x16, 0x0, UINT32_C(0xffffffff));
  fiat_25519_scalar_addcarryx_u32(&x18, &x19, 0x0, x1, (x17 & UINT32_C(0x5cf5d3ed)));
  fiat_25519_scalar_addcarryx_u32(&x20, &x21, x19, x3, (x17 & UINT32_C(0x5812631a)));
  fiat_25519_scalar_addcarryx_u32(&x22, &x23, x21, x5, (x17 & UINT32_C(0xa2f79cd6)));
  fiat_25519_scalar_addcarryx_u32(&x24, &x25, x23, x7, (x17 & UINT32_C(0x14def9de)));
  fiat_25519_scalar_addcarryx_u32(&x26, &x27, x25, x9, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x28, &x29, x27, x11, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x30, &x31, x29, x13, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x32, &x33, x31, x15, (x17 & UINT32_C(0x10000000)));
  out1[0] = x18;
  out1[1] = x20;
  out1[2] = x22;
  out1[3] = x24;
  out1[4] = x26;
  out1[5] = x28;
  out1[6] = x30;
  out1[7] = x32;
}

/*
 * The function fiat_25519_scalar_opp negates a field element in the Montgomery domain.
 *
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = -eval (from_montgomery arg1) mod m
 *   0 ≤ eval out1 < m
 *
 */
static FIAT_25519_SCALAR_FIAT_INLINE void fiat_25519_scalar_opp(fiat_25519_scalar_montgomery_domain_field_element out1, const fiat_25519_scalar_montgomery_domain_field_element arg1) {
  uint32_t x1;
  fiat_25519_scalar_uint1 x2;
  uint32_t x3;
  fiat_25519_scalar_uint1 x4;
  uint32_t x5;
  fiat_25519_scalar_uint1 x6;
  uint32_t x7;
  fiat_25519_scalar_uint1 x8;
  uint32_t x9;
  fiat_25519_scalar_uint1 x10;
  uint32_t x11;
  fiat_25519_scalar_uint1 x12;
  uint32_t x13;
  fiat_25519_scalar_uint1 x14;
  uint32_t x15;
  fiat_25519_scalar_uint1 x16;
  uint32_t x17;
  uint32_t x18;
  fiat_25519_scalar_uint1 x19;
  uint32_t x20;
  fiat_25519_scalar_uint1 x21;
  uint32_t x22;
  fiat_25519_scalar_uint1 x23;
  uint32_t x24;
  fiat_25519_scalar_uint1 x25;
  uint32_t x26;
  fiat_25519_scalar_uint1 x27;
  uint32_t x28;
  fiat_25519_scalar_uint1 x29;
  uint32_t x30;
  fiat_25519_scalar_uint1 x31;
  uint32_t x32;
  fiat_25519_scalar_uint1 x33;
  fiat_25519_scalar_subborrowx_u32(&x1, &x2, 0x0, 0x0, (arg1[0]));
  fiat_25519_scalar_subborrowx_u32(&x3, &x4, x2, 0x0, (arg1[1]));
  fiat_25519_scalar_subborrowx_u32(&x5, &x6, x4, 0x0, (arg1[2]));
  fiat_25519_scalar_subborrowx_u32(&x7, &x8, x6, 0x0, (arg1[3]));
  fiat_25519_scalar_subborrowx_u32(&x9, &x10, x8, 0x0, (arg1[4]));
  fiat_25519_scalar_subborrowx_u32(&x11, &x12, x10, 0x0, (arg1[5]));
  fiat_25519_scalar_subborrowx_u32(&x13, &x14, x12, 0x0, (arg1[6]));
  fiat_25519_scalar_subborrowx_u32(&x15, &x16, x14, 0x0, (arg1[7]));
  fiat_25519_scalar_cmovznz_u32(&x17, x16, 0x0, UINT32_C(0xffffffff));
  fiat_25519_scalar_addcarryx_u32(&x18, &x19, 0x0, x1, (x17 & UINT32_C(0x5cf5d3ed)));
  fiat_25519_scalar_addcarryx_u32(&x20, &x21, x19, x3, (x17 & UINT32_C(0x5812631a)));
  fiat_25519_scalar_addcarryx_u32(&x22, &x23, x21, x5, (x17 & UINT32_C(0xa2f79cd6)));
  fiat_25519_scalar_addcarryx_u32(&x24, &x25, x23, x7, (x17 & UINT32_C(0x14def9de)));
  fiat_25519_scalar_addcarryx_u32(&x26, &x27, x25, x9, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x28, &x29, x27, x11, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x30, &x31, x29, x13, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x32, &x33, x31, x15, (x17 & UINT32_C(0x10000000)));
  out1[0] = x18;
  out1[1] = x20;
  out1[2] = x22;
  out1[3] = x24;
  out1[4] = x26;
  out1[5] = x28;
  out1[6] = x30;
  out1[7] = x32;
}

/*
 * The function fiat_25519_scalar_from_montgomery translates a field element out of the Montgomery domain.
 *
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   eval out1 mod m = (eval arg1 * ((2^32)⁻¹ mod m)^8) mod m
 *   0 ≤ eval out1 < m
 *
 */
static FIAT_25519_SCALAR_FIAT_INLINE void fiat_25519_scalar_from_montgomery(fiat_25519_scalar_non_montgomery_domain_field_element out1, const fiat_25519_scalar_montgomery_domain_field_element arg1) {
  uint32_t x1;
  uint32_t x2;
  uint32_t x3;
  uint32_t x4;
  uint32_t x5;
  uint32_t x6;
  uint32_t x7;
  uint32_t x8;
  uint32_t x9;
  uint32_t x10;
  uint32_t x11;
  uint32_t x12;
  uint32_t x13;
  uint32_t x14;
  fiat_25519_scalar_uint1 x15;
  uint32_t x16;
  fiat_25519_scalar_uint1 x17;
  uint32_t x18;
  fiat_25519_scalar_uint1 x19;
  uint32_t x20;
  fiat_25519_scalar_uint1 x21;
  uint32_t x22;
  fiat_25519_scalar_uint1 x23;
  uint32_t x24;
  fiat_25519_scalar_uint1 x25;
  uint32_t x26;
  fiat_25519_scalar_uint1 x27;
  uint32_t x28;
  fiat_25519_scalar_uint1 x29;
  uint32_t x30;
  fiat_25519_scalar_uint1 x31;
  uint32_t x32;
  fiat_25519_scalar_uint1 x33;
  uint32_t x34;
  uint32_t x35;
  uint32_t x36;
  uint32_t x37;
  uint32_t x38;
  uint32_t x39;
  uint32_t x40;
  uint32_t x41;
  uint32_t x42;
  uint32_t x43;
  uint32_t x44;
  uint32_t x45;
  uint32_t x46;
  fiat_25519_scalar_uint1 x47;
  uint32_t x48;
  fiat_25519_scalar_uint1 x49;
  uint32_t x50;
  fiat_25519_scalar_uint1 x51;
  uint32_t x52;
  fiat_25519_scalar_uint1 x53;
  uint32_t x54;
  fiat_25519_scalar_uint1 x55;
  uint32_t x56;
  fiat_25519_scalar_uint1 x57;
  uint32_t x58;
  fiat_25519_scalar_uint1 x59;
  uint32_t x60;
  fiat_25519_scalar_uint1 x61;
  uint32_t x62;
  fiat_25519_scalar_uint1 x63;
  uint32_t x64;
  fiat_25519_scalar_uint1 x65;
  uint32_t x66;
  fiat_25519_scalar_uint1 x67;
  uint32_t x68;
  uint32_t x69;
  uint32_t x70;
  uint32_t x71;
  uint32_t x72;
  uint32_t x73;
  uint32_t x74;
  uint32_t x75;
  uint32_t x76;
  uint32_t x77;
  uint32_t x78;
  uint32_t x79;
  uint32_t x80;
  fiat_25519_scalar_uint1 x81;
  uint32_t x82;
  fiat_25519_scalar_uint1 x83;
  uint32_t x84;
  fiat_25519_scalar_uint1 x85;
  uint32_t x86;
  fiat_25519_scalar_uint1 x87;
  uint32_t x88;
  fiat_25519_scalar_uint1 x89;
  uint32_t x90;
  fiat_25519_scalar_uint1 x91;
  uint32_t x92;
  fiat_25519_scalar_uint1 x93;
  uint32_t x94;
  fiat_25519_scalar_uint1 x95;
  uint32_t x96;
  fiat_25519_scalar_uint1 x97;
  uint32_t x98;
  fiat_25519_scalar_uint1 x99;
  uint32_t x100;
  fiat_25519_scalar_uint1 x101;
  uint32_t x102;
  uint32_t x103;
  uint32_t x104;
  uint32_t x105;
  uint32_t x106;
  uint32_t x107;
  uint32_t x108;
  uint32_t x109;
  uint32_t x110;
  uint32_t x111;
  uint32_t x112;
  uint32_t x113;
  uint32_t x114;
  fiat_25519_scalar_uint1 x115;
  uint32_t x116;
  fiat_25519_scalar_uint1 x117;
  uint32_t x118;
  fiat_25519_scalar_uint1 x119;
  uint32_t x120;
  fiat_25519_scalar_uint1 x121;
  uint32_t x122;
  fiat_25519_scalar_uint1 x123;
  uint32_t x124;
  fiat_25519_scalar_uint1 x125;
  uint32_t x126;
  fiat_25519_scalar_uint1 x127;
  uint32_t x128;
  fiat_25519_scalar_uint1 x129;
  uint32_t x130;
  fiat_25519_scalar_uint1 x131;
  uint32_t x132;
  fiat_25519_scalar_uint1 x133;
  uint32_t x134;
  fiat_25519_scalar_uint1 x135;
  uint32_t x136;
  fiat_25519_scalar_uint1 x137;
  uint32_t x138;
  fiat_25519_scalar_uint1 x139;
  uint32_t x140;
  fiat_25519_scalar_uint1 x141;
  uint32_t x142;
  fiat_25519_scalar_uint1 x143;
  uint32_t x144;
  fiat_25519_scalar_uint1 x145;
  uint32_t x146;
  fiat_25519_scalar_uint1 x147;
  uint32_t x148;
  fiat_25519_scalar_uint1 x149;
  uint32_t x150;
  uint32_t x151;
  uint32_t x152;
  uint32_t x153;
  uint32_t x154;
  uint32_t x155;
  uint32_t x156;
  uint32_t x157;
  uint32_t x158;
  uint32_t x159;
  uint32_t x160;
  uint32_t x161;
  uint32_t x162;
  fiat_25519_scalar_uint1 x163;
  uint32_t x164;
  fiat_25519_scalar_uint1 x165;
  uint32_t x166;
  fiat_25519_scalar_uint1 x167;
  uint32_t x168;
  fiat_25519_scalar_uint1 x169;
  uint32_t x170;
  fiat_25519_scalar_uint1 x171;
  uint32_t x172;
  fiat_25519_scalar_uint1 x173;
  uint32_t x174;
  fiat_25519_scalar_uint1 x175;
  uint32_t x176;
  fiat_25519_scalar_uint1 x177;
  uint32_t x178;
  fiat_25519_scalar_uint1 x179;
  uint32_t x180;
  fiat_25519_scalar_uint1 x181;
  uint32_t x182;
  fiat_25519_scalar_uint1 x183;
  uint32_t x184;
  fiat_25519_scalar_uint1 x185;
  uint32_t x186;
  fiat_25519_scalar_uint1 x187;
  uint32_t x188;
  fiat_25519_scalar_uint1 x189;
  uint32_t x190;
  fiat_25519_scalar_uint1 x191;
  uint32_t x192;
  fiat_25519_scalar_uint1 x193;
  uint32_t x194;
  fiat_25519_scalar_uint1 x195;
  uint32_t x196;
  fiat_25519_scalar_uint1 x197;
  uint32_t x198;
  uint32_t x199;
  uint32_t x200;
  uint32_t x201;
  uint32_t x202;
  uint32_t x203;
  uint32_t x204;
  uint32_t x205;
  uint32_t x206;
  uint32_t x207;
  uint32_t x208;
  uint32_t x209;
  uint32_t x210;
  fiat_25519_scalar_uint1 x211;
  uint32_t x212;
  fiat_25519_scalar_uint1 x213;
  uint32_t x214;
  fiat_25519_scalar_uint1 x215;
  uint32_t x216;
  fiat_25519_scalar_uint1 x217;
  uint32_t x218;
  fiat_25519_scalar_uint1 x219;
  uint32_t x220;
  fiat_25519_scalar_uint1 x221;
  uint32_t x222;
  fiat_25519_scalar_uint1 x223;
  uint32_t x224;
  fiat_25519_scalar_uint1 x225;
  uint32_t x226;
  fiat_25519_scalar_uint1 x227;
  uint32_t x228;
  fiat_25519_scalar_uint1 x229;
  uint32_t x230;
  fiat_25519_scalar_uint1 x231;
  uint32_t x232;
  fiat_25519_scalar_uint1 x233;
  uint32_t x234;
  fiat_25519_scalar_uint1 x235;
  uint32_t x236;
  fiat_25519_scalar_uint1 x237;
  uint32_t x238;
  fiat_25519_scalar_uint1 x239;
  uint32_t x240;
  fiat_25519_scalar_uint1 x241;
  uint32_t x242;
  fiat_25519_scalar_uint1 x243;
  uint32_t x244;
  fiat_25519_scalar_uint1 x245;
  uint32_t x246;
  uint32_t x247;
  uint32_t x248;
  uint32_t x249;
  uint32_t x250;
  uint32_t x251;
  uint32_t x252;
  uint32_t x253;
  uint32_t x254;
  uint32_t x255;
  uint32_t x256;
  uint32_t x257;
  uint32_t x258;
  fiat_25519_scalar_uint1 x259;
  uint32_t x260;
  fiat_25519_scalar_uint1 x261;
  uint32_t x262;
  fiat_25519_scalar_uint1 x263;
  uint32_t x264;
  fiat_25519_scalar_uint1 x265;
  uint32_t x266;
  fiat_25519_scalar_uint1 x267;
  uint32_t x268;
  fiat_25519_scalar_uint1 x269;
  uint32_t x270;
  fiat_25519_scalar_uint1 x271;
  uint32_t x272;
  fiat_25519_scalar_uint1 x273;
  uint32_t x274;
  fiat_25519_scalar_uint1 x275;
  uint32_t x276;
  fiat_25519_scalar_uint1 x277;
  uint32_t x278;
  fiat_25519_scalar_uint1 x279;
  uint32_t x280;
  fiat_25519_scalar_uint1 x281;
  uint32_t x282;
  fiat_25519_scalar_uint1 x283;
  uint32_t x284;
  fiat_25519_scalar_uint1 x285;
  uint32_t x286;
  fiat_25519_scalar_uint1 x287;
  uint32_t x288;
  fiat_25519_scalar_uint1 x289;
  uint32_t x290;
  fiat_25519_scalar_uint1 x291;
  uint32_t x292;
  fiat_25519_scalar_uint1 x293;
  uint32_t x294;
  uint32_t x295;
  uint32_t x296;
  uint32_t x297;
  uint32_t x298;
  uint32_t x299;
  uint32_t x300;
  uint32_t x301;
  uint32_t x302;
  uint32_t x303;
  uint32_t x304;
  uint32_t x305;
  uint32_t x306;
  fiat_25519_scalar_uint1 x307;
  uint32_t x308;
  fiat_25519_scalar_uint1 x309;
  uint32_t x310;
  fiat_25519_scalar_uint1 x311;
  uint32_t x312;
  fiat_25519_scalar_uint1 x313;
  uint32_t x314;
  fiat_25519_scalar_uint1 x315;
  uint32_t x316;
  fiat_25519_scalar_uint1 x317;
  uint32_t x318;
  fiat_25519_scalar_uint1 x319;
  uint32_t x320;
  fiat_25519_scalar_uint1 x321;
  uint32_t x322;
  fiat_25519_scalar_uint1 x323;
  uint32_t x324;
  fiat_25519_scalar_uint1 x325;
  uint32_t x326;
  fiat_25519_scalar_uint1 x327;
  uint32_t x328;
  uint32_t x329;
  fiat_25519_scalar_uint1 x330;
  uint32_t x331;
  fiat_25519_scalar_uint1 x332;
  uint32_t x333;
  fiat_25519_scalar_uint1 x334;
  uint32_t x335;
  fiat_25519_scalar_uint1 x336;
  uint32_t x337;
  fiat_25519_scalar_uint1 x338;
  uint32_t x339;
  fiat_25519_scalar_uint1 x340;
  uint32_t x341;
  fiat_25519_scalar_uint1 x342;
  uint32_t x343;
  fiat_25519_scalar_uint1 x344;
  uint32_t x345;
  fiat_25519_scalar_uint1 x346;
  uint32_t x347;
  uint32_t x348;
  uint32_t x349;
  uint32_t x350;
  uint32_t x351;
  uint32_t x352;
  uint32_t x353;
  uint32_t x354;
  x1 = (arg1[0]);
  fiat_25519_scalar_mulx_u32(&x2, &x3, x1, UINT32_C(0x12547e1b));
  fiat_25519_scalar_mulx_u32(&x4, &x5, x2, UINT32_C(0x10000000));
  fiat_25519_scalar_mulx_u32(&x6, &x7, x2, UINT32_C(0x14def9de));
  fiat_25519_scalar_mulx_u32(&x8, &x9, x2, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_mulx_u32(&x10, &x11, x2, UINT32_C(0x5812631a));
  fiat_25519_scalar_mulx_u32(&x12, &x13, x2, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_addcarryx_u32(&x14, &x15, 0x0, x13, x10);
  fiat_25519_scalar_addcarryx_u32(&x16, &x17, x15, x11, x8);
  fiat_25519_scalar_addcarryx_u32(&x18, &x19, x17, x9, x6);
  fiat_25519_scalar_addcarryx_u32(&x20, &x21, 0x0, x1, x12);
  fiat_25519_scalar_addcarryx_u32(&x22, &x23, x21, 0x0, x14);
  fiat_25519_scalar_addcarryx_u32(&x24, &x25, x23, 0x0, x16);
  fiat_25519_scalar_addcarryx_u32(&x26, &x27, x25, 0x0, x18);
  fiat_25519_scalar_addcarryx_u32(&x28, &x29, 0x0, x22, (arg1[1]));
  fiat_25519_scalar_addcarryx_u32(&x30, &x31, x29, x24, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x32, &x33, x31, x26, 0x0);
  fiat_25519_scalar_mulx_u32(&x34, &x35, x28, UINT32_C(0x12547e1b));
  fiat_25519_scalar_mulx_u32(&x36, &x37, x34, UINT32_C(0x10000000));
  fiat_25519_scalar_mulx_u32(&x38, &x39, x34, UINT32_C(0x14def9de));
  fiat_25519_scalar_mulx_u32(&x40, &x41, x34, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_mulx_u32(&x42, &x43, x34, UINT32_C(0x5812631a));
  fiat_25519_scalar_mulx_u32(&x44, &x45, x34, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_addcarryx_u32(&x46, &x47, 0x0, x45, x42);
  fiat_25519_scalar_addcarryx_u32(&x48, &x49, x47, x43, x40);
  fiat_25519_scalar_addcarryx_u32(&x50, &x51, x49, x41, x38);
  fiat_25519_scalar_addcarryx_u32(&x52, &x53, 0x0, x28, x44);
  fiat_25519_scalar_addcarryx_u32(&x54, &x55, x53, x30, x46);
  fiat_25519_scalar_addcarryx_u32(&x56, &x57, x55, x32, x48);
  fiat_25519_scalar_addcarryx_u32(&x58, &x59, x57, (x33 + (x27 + (x19 + x7))), x50);
  fiat_25519_scalar_addcarryx_u32(&x60, &x61, 0x0, x5, x36);
  fiat_25519_scalar_addcarryx_u32(&x62, &x63, 0x0, x54, (arg1[2]));
  fiat_25519_scalar_addcarryx_u32(&x64, &x65, x63, x56, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x66, &x67, x65, x58, 0x0);
  fiat_25519_scalar_mulx_u32(&x68, &x69, x62, UINT32_C(0x12547e1b));
  fiat_25519_scalar_mulx_u32(&x70, &x71, x68, UINT32_C(0x10000000));
  fiat_25519_scalar_mulx_u32(&x72, &x73, x68, UINT32_C(0x14def9de));
  fiat_25519_scalar_mulx_u32(&x74, &x75, x68, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_mulx_u32(&x76, &x77, x68, UINT32_C(0x5812631a));
  fiat_25519_scalar_mulx_u32(&x78, &x79, x68, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_addcarryx_u32(&x80, &x81, 0x0, x79, x76);
  fiat_25519_scalar_addcarryx_u32(&x82, &x83, x81, x77, x74);
  fiat_25519_scalar_addcarryx_u32(&x84, &x85, x83, x75, x72);
  fiat_25519_scalar_addcarryx_u32(&x86, &x87, 0x0, x62, x78);
  fiat_25519_scalar_addcarryx_u32(&x88, &x89, x87, x64, x80);
  fiat_25519_scalar_addcarryx_u32(&x90, &x91, x89, x66, x82);
  fiat_25519_scalar_addcarryx_u32(&x92, &x93, x91, (x67 + (x59 + (x51 + x39))), x84);
  fiat_25519_scalar_addcarryx_u32(&x94, &x95, 0x0, (x61 + x37), x70);
  fiat_25519_scalar_addcarryx_u32(&x96, &x97, 0x0, x88, (arg1[3]));
  fiat_25519_scalar_addcarryx_u32(&x98, &x99, x97, x90, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x100, &x101, x99, x92, 0x0);
  fiat_25519_scalar_mulx_u32(&x102, &x103, x96, UINT32_C(0x12547e1b));
  fiat_25519_scalar_mulx_u32(&x104, &x105, x102, UINT32_C(0x10000000));
  fiat_25519_scalar_mulx_u32(&x106, &x107, x102, UINT32_C(0x14def9de));
  fiat_25519_scalar_mulx_u32(&x108, &x109, x102, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_mulx_u32(&x110, &x111, x102, UINT32_C(0x5812631a));
  fiat_25519_scalar_mulx_u32(&x112, &x113, x102, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_addcarryx_u32(&x114, &x115, 0x0, x113, x110);
  fiat_25519_scalar_addcarryx_u32(&x116, &x117, x115, x111, x108);
  fiat_25519_scalar_addcarryx_u32(&x118, &x119, x117, x109, x106);
  fiat_25519_scalar_addcarryx_u32(&x120, &x121, 0x0, x96, x112);
  fiat_25519_scalar_addcarryx_u32(&x122, &x123, x121, x98, x114);
  fiat_25519_scalar_addcarryx_u32(&x124, &x125, x123, x100, x116);
  fiat_25519_scalar_addcarryx_u32(&x126, &x127, x125, (x101 + (x93 + (x85 + x73))), x118);
  fiat_25519_scalar_addcarryx_u32(&x128, &x129, x127, x4, (x119 + x107));
  fiat_25519_scalar_addcarryx_u32(&x130, &x131, x129, x60, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x132, &x133, x131, x94, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x134, &x135, x133, (x95 + x71), x104);
  fiat_25519_scalar_addcarryx_u32(&x136, &x137, 0x0, x122, (arg1[4]));
  fiat_25519_scalar_addcarryx_u32(&x138, &x139, x137, x124, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x140, &x141, x139, x126, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x142, &x143, x141, x128, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x144, &x145, x143, x130, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x146, &x147, x145, x132, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x148, &x149, x147, x134, 0x0);
  fiat_25519_scalar_mulx_u32(&x150, &x151, x136, UINT32_C(0x12547e1b));
  fiat_25519_scalar_mulx_u32(&x152, &x153, x150, UINT32_C(0x10000000));
  fiat_25519_scalar_mulx_u32(&x154, &x155, x150, UINT32_C(0x14def9de));
  fiat_25519_scalar_mulx_u32(&x156, &x157, x150, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_mulx_u32(&x158, &x159, x150, UINT32_C(0x5812631a));
  fiat_25519_scalar_mulx_u32(&x160, &x161, x150, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_addcarryx_u32(&x162, &x163, 0x0, x161, x158);
  fiat_25519_scalar_addcarryx_u32(&x164, &x165, x163, x159, x156);
  fiat_25519_scalar_addcarryx_u32(&x166, &x167, x165, x157, x154);
  fiat_25519_scalar_addcarryx_u32(&x168, &x169, 0x0, x136, x160);
  fiat_25519_scalar_addcarryx_u32(&x170, &x171, x169, x138, x162);
  fiat_25519_scalar_addcarryx_u32(&x172, &x173, x171, x140, x164);
  fiat_25519_scalar_addcarryx_u32(&x174, &x175, x173, x142, x166);
  fiat_25519_scalar_addcarryx_u32(&x176, &x177, x175, x144, (x167 + x155));
  fiat_25519_scalar_addcarryx_u32(&x178, &x179, x177, x146, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x180, &x181, x179, x148, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x182, &x183, x181, (x149 + (x135 + x105)), x152);
  fiat_25519_scalar_addcarryx_u32(&x184, &x185, 0x0, x170, (arg1[5]));
  fiat_25519_scalar_addcarryx_u32(&x186, &x187, x185, x172, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x188, &x189, x187, x174, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x190, &x191, x189, x176, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x192, &x193, x191, x178, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x194, &x195, x193, x180, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x196, &x197, x195, x182, 0x0);
  fiat_25519_scalar_mulx_u32(&x198, &x199, x184, UINT32_C(0x12547e1b));
  fiat_25519_scalar_mulx_u32(&x200, &x201, x198, UINT32_C(0x10000000));
  fiat_25519_scalar_mulx_u32(&x202, &x203, x198, UINT32_C(0x14def9de));
  fiat_25519_scalar_mulx_u32(&x204, &x205, x198, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_mulx_u32(&x206, &x207, x198, UINT32_C(0x5812631a));
  fiat_25519_scalar_mulx_u32(&x208, &x209, x198, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_addcarryx_u32(&x210, &x211, 0x0, x209, x206);
  fiat_25519_scalar_addcarryx_u32(&x212, &x213, x211, x207, x204);
  fiat_25519_scalar_addcarryx_u32(&x214, &x215, x213, x205, x202);
  fiat_25519_scalar_addcarryx_u32(&x216, &x217, 0x0, x184, x208);
  fiat_25519_scalar_addcarryx_u32(&x218, &x219, x217, x186, x210);
  fiat_25519_scalar_addcarryx_u32(&x220, &x221, x219, x188, x212);
  fiat_25519_scalar_addcarryx_u32(&x222, &x223, x221, x190, x214);
  fiat_25519_scalar_addcarryx_u32(&x224, &x225, x223, x192, (x215 + x203));
  fiat_25519_scalar_addcarryx_u32(&x226, &x227, x225, x194, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x228, &x229, x227, x196, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x230, &x231, x229, (x197 + (x183 + x153)), x200);
  fiat_25519_scalar_addcarryx_u32(&x232, &x233, 0x0, x218, (arg1[6]));
  fiat_25519_scalar_addcarryx_u32(&x234, &x235, x233, x220, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x236, &x237, x235, x222, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x238, &x239, x237, x224, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x240, &x241, x239, x226, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x242, &x243, x241, x228, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x244, &x245, x243, x230, 0x0);
  fiat_25519_scalar_mulx_u32(&x246, &x247, x232, UINT32_C(0x12547e1b));
  fiat_25519_scalar_mulx_u32(&x248, &x249, x246, UINT32_C(0x10000000));
  fiat_25519_scalar_mulx_u32(&x250, &x251, x246, UINT32_C(0x14def9de));
  fiat_25519_scalar_mulx_u32(&x252, &x253, x246, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_mulx_u32(&x254, &x255, x246, UINT32_C(0x5812631a));
  fiat_25519_scalar_mulx_u32(&x256, &x257, x246, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_addcarryx_u32(&x258, &x259, 0x0, x257, x254);
  fiat_25519_scalar_addcarryx_u32(&x260, &x261, x259, x255, x252);
  fiat_25519_scalar_addcarryx_u32(&x262, &x263, x261, x253, x250);
  fiat_25519_scalar_addcarryx_u32(&x264, &x265, 0x0, x232, x256);
  fiat_25519_scalar_addcarryx_u32(&x266, &x267, x265, x234, x258);
  fiat_25519_scalar_addcarryx_u32(&x268, &x269, x267, x236, x260);
  fiat_25519_scalar_addcarryx_u32(&x270, &x271, x269, x238, x262);
  fiat_25519_scalar_addcarryx_u32(&x272, &x273, x271, x240, (x263 + x251));
  fiat_25519_scalar_addcarryx_u32(&x274, &x275, x273, x242, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x276, &x277, x275, x244, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x278, &x279, x277, (x245 + (x231 + x201)), x248);
  fiat_25519_scalar_addcarryx_u32(&x280, &x281, 0x0, x266, (arg1[7]));
  fiat_25519_scalar_addcarryx_u32(&x282, &x283, x281, x268, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x284, &x285, x283, x270, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x286, &x287, x285, x272, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x288, &x289, x287, x274, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x290, &x291, x289, x276, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x292, &x293, x291, x278, 0x0);
  fiat_25519_scalar_mulx_u32(&x294, &x295, x280, UINT32_C(0x12547e1b));
  fiat_25519_scalar_mulx_u32(&x296, &x297, x294, UINT32_C(0x10000000));
  fiat_25519_scalar_mulx_u32(&x298, &x299, x294, UINT32_C(0x14def9de));
  fiat_25519_scalar_mulx_u32(&x300, &x301, x294, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_mulx_u32(&x302, &x303, x294, UINT32_C(0x5812631a));
  fiat_25519_scalar_mulx_u32(&x304, &x305, x294, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_addcarryx_u32(&x306, &x307, 0x0, x305, x302);
  fiat_25519_scalar_addcarryx_u32(&x308, &x309, x307, x303, x300);
  fiat_25519_scalar_addcarryx_u32(&x310, &x311, x309, x301, x298);
  fiat_25519_scalar_addcarryx_u32(&x312, &x313, 0x0, x280, x304);
  fiat_25519_scalar_addcarryx_u32(&x314, &x315, x313, x282, x306);
  fiat_25519_scalar_addcarryx_u32(&x316, &x317, x315, x284, x308);
  fiat_25519_scalar_addcarryx_u32(&x318, &x319, x317, x286, x310);
  fiat_25519_scalar_addcarryx_u32(&x320, &x321, x319, x288, (x311 + x299));
  fiat_25519_scalar_addcarryx_u32(&x322, &x323, x321, x290, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x324, &x325, x323, x292, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x326, &x327, x325, (x293 + (x279 + x249)), x296);
  x328 = (x327 + x297);
  fiat_25519_scalar_subborrowx_u32(&x329, &x330, 0x0, x314, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_subborrowx_u32(&x331, &x332, x330, x316, UINT32_C(0x5812631a));
  fiat_25519_scalar_subborrowx_u32(&x333, &x334, x332, x318, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_subborrowx_u32(&x335, &x336, x334, x320, UINT32_C(0x14def9de));
  fiat_25519_scalar_subborrowx_u32(&x337, &x338, x336, x322, 0x0);
  fiat_25519_scalar_subborrowx_u32(&x339, &x340, x338, x324, 0x0);
  fiat_25519_scalar_subborrowx_u32(&x341, &x342, x340, x326, 0x0);
  fiat_25519_scalar_subborrowx_u32(&x343, &x344, x342, x328, UINT32_C(0x10000000));
  fiat_25519_scalar_subborrowx_u32(&x345, &x346, x344, 0x0, 0x0);
  fiat_25519_scalar_cmovznz_u32(&x347, x346, x329, x314);
  fiat_25519_scalar_cmovznz_u32(&x348, x346, x331, x316);
  fiat_25519_scalar_cmovznz_u32(&x349, x346, x333, x318);
  fiat_25519_scalar_cmovznz_u32(&x350, x346, x335, x320);
  fiat_25519_scalar_cmovznz_u32(&x351, x346, x337, x322);
  fiat_25519_scalar_cmovznz_u32(&x352, x346, x339, x324);
  fiat_25519_scalar_cmovznz_u32(&x353, x346, x341, x326);
  fiat_25519_scalar_cmovznz_u32(&x354, x346, x343, x328);
  out1[0] = x347;
  out1[1] = x348;
  out1[2] = x349;
  out1[3] = x350;
  out1[4] = x351;
  out1[5] = x352;
  out1[6] = x353;
  out1[7] = x354;
}

/*
 * The function fiat_25519_scalar_to_montgomery translates a field element into the Montgomery domain.
 *
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = eval arg1 mod m
 *   0 ≤ eval out1 < m
 *
 */
static FIAT_25519_SCALAR_FIAT_INLINE void fiat_25519_scalar_to_montgomery(fiat_25519_scalar_montgomery_domain_field_element out1, const fiat_25519_scalar_non_montgomery_domain_field_element arg1) {
  uint32_t x1;
  uint32_t x2;
  uint32_t x3;
  uint32_t x4;
  uint32_t x5;
  uint32_t x6;
  uint32_t x7;
  uint32_t x8;
  uint32_t x9;
  uint32_t x10;
  uint32_t x11;
  uint32_t x12;
  uint32_t x13;
  uint32_t x14;
  uint32_t x15;
  uint32_t x16;
  uint32_t x17;
  uint32_t x18;
  uint32_t x19;
  uint32_t x20;
  uint32_t x21;
  uint32_t x22;
  uint32_t x23;
  uint32_t x24;
  uint32_t x25;
  fiat_25519_scalar_uint1 x26;
  uint32_t x27;
  fiat_25519_scalar_uint1 x28;
  uint32_t x29;
  fiat_25519_scalar_uint1 x30;
  uint32_t x31;
  fiat_25519_scalar_uint1 x32;
  uint32_t x33;
  fiat_25519_scalar_uint1 x34;
  uint32_t x35;
  fiat_25519_scalar_uint1 x36;
  uint32_t x37;
  fiat_25519_scalar_uint1 x38;
  uint32_t x39;
  uint32_t x40;
  uint32_t x41;
  uint32_t x42;
  uint32_t x43;
  uint32_t x44;
  uint32_t x45;
  uint32_t x46;
  uint32_t x47;
  uint32_t x48;
  uint32_t x49;
  uint32_t x50;
  uint32_t x51;
  fiat_25519_scalar_uint1 x52;
  uint32_t x53;
  fiat_25519_scalar_uint1 x54;
  uint32_t x55;
  fiat_25519_scalar_uint1 x56;
  uint32_t x57;
  fiat_25519_scalar_uint1 x58;
  uint32_t x59;
  fiat_25519_scalar_uint1 x60;
  uint32_t x61;
  fiat_25519_scalar_uint1 x62;
  uint32_t x63;
  fiat_25519_scalar_uint1 x64;
  uint32_t x65;
  fiat_25519_scalar_uint1 x66;
  uint32_t x67;
  fiat_25519_scalar_uint1 x68;
  uint32_t x69;
  fiat_25519_scalar_uint1 x70;
  uint32_t x71;
  fiat_25519_scalar_uint1 x72;
  uint32_t x73;
  uint32_t x74;
  uint32_t x75;
  uint32_t x76;
  uint32_t x77;
  uint32_t x78;
  uint32_t x79;
  uint32_t x80;
  uint32_t x81;
  uint32_t x82;
  uint32_t x83;
  uint32_t x84;
  uint32_t x85;
  uint32_t x86;
  uint32_t x87;
  uint32_t x88;
  uint32_t x89;
  fiat_25519_scalar_uint1 x90;
  uint32_t x91;
  fiat_25519_scalar_uint1 x92;
  uint32_t x93;
  fiat_25519_scalar_uint1 x94;
  uint32_t x95;
  fiat_25519_scalar_uint1 x96;
  uint32_t x97;
  fiat_25519_scalar_uint1 x98;
  uint32_t x99;
  fiat_25519_scalar_uint1 x100;
  uint32_t x101;
  fiat_25519_scalar_uint1 x102;
  uint32_t x103;
  fiat_25519_scalar_uint1 x104;
  uint32_t x105;
  fiat_25519_scalar_uint1 x106;
  uint32_t x107;
  fiat_25519_scalar_uint1 x108;
  uint32_t x109;
  fiat_25519_scalar_uint1 x110;
  uint32_t x111;
  fiat_25519_scalar_uint1 x112;
  uint32_t x113;
  fiat_25519_scalar_uint1 x114;
  uint32_t x115;
  fiat_25519_scalar_uint1 x116;
  uint32_t x117;
  fiat_25519_scalar_uint1 x118;
  uint32_t x119;
  uint32_t x120;
  uint32_t x121;
  uint32_t x122;
  uint32_t x123;
  uint32_t x124;
  uint32_t x125;
  uint32_t x126;
  uint32_t x127;
  uint32_t x128;
  uint32_t x129;
  uint32_t x130;
  uint32_t x131;
  fiat_25519_scalar_uint1 x132;
  uint32_t x133;
  fiat_25519_scalar_uint1 x134;
  uint32_t x135;
  fiat_25519_scalar_uint1 x136;
  uint32_t x137;
  fiat_25519_scalar_uint1 x138;
  uint32_t x139;
  fiat_25519_scalar_uint1 x140;
  uint32_t x141;
  fiat_25519_scalar_uint1 x142;
  uint32_t x143;
  fiat_25519_scalar_uint1 x144;
  uint32_t x145;
  fiat_25519_scalar_uint1 x146;
  uint32_t x147;
  fiat_25519_scalar_uint1 x148;
  uint32_t x149;
  fiat_25519_scalar_uint1 x150;
  uint32_t x151;
  fiat_25519_scalar_uint1 x152;
  uint32_t x153;
  uint32_t x154;
  uint32_t x155;
  uint32_t x156;
  uint32_t x157;
  uint32_t x158;
  uint32_t x159;
  uint32_t x160;
  uint32_t x161;
  uint32_t x162;
  uint32_t x163;
  uint32_t x164;
  uint32_t x165;
  uint32_t x166;
  uint32_t x167;
  uint32_t x168;
  uint32_t x169;
  fiat_25519_scalar_uint1 x170;
  uint32_t x171;
  fiat_25519_scalar_uint1 x172;
  uint32_t x173;
  fiat_25519_scalar_uint1 x174;
  uint32_t x175;
  fiat_25519_scalar_uint1 x176;
  uint32_t x177;
  fiat_25519_scalar_uint1 x178;
  uint32_t x179;
  fiat_25519_scalar_uint1 x180;
  uint32_t x181;
  fiat_25519_scalar_uint1 x182;
  uint32_t x183;
  fiat_25519_scalar_uint1 x184;
  uint32_t x185;
  fiat_25519_scalar_uint1 x186;
  uint32_t x187;
  fiat_25519_scalar_uint1 x188;
  uint32_t x189;
  fiat_25519_scalar_uint1 x190;
  uint32_t x191;
  fiat_25519_scalar_uint1 x192;
  uint32_t x193;
  fiat_25519_scalar_uint1 x194;
  uint32_t x195;
  fiat_25519_scalar_uint1 x196;
  uint32_t x197;
  fiat_25519_scalar_uint1 x198;
  uint32_t x199;
  uint32_t x200;
  uint32_t x201;
  uint32_t x202;
  uint32_t x203;
  uint32_t x204;
  uint32_t x205;
  uint32_t x206;
  uint32_t x207;
  uint32_t x208;
  uint32_t x209;
  uint32_t x210;
  uint32_t x211;
  fiat_25519_scalar_uint1 x212;
  uint32_t x213;
  fiat_25519_scalar_uint1 x214;
  uint32_t x215;
  fiat_25519_scalar_uint1 x216;
  uint32_t x217;
  fiat_25519_scalar_uint1 x218;
  uint32_t x219;
  fiat_25519_scalar_uint1 x220;
  uint32_t x221;
  fiat_25519_scalar_uint1 x222;
  uint32_t x223;
  fiat_25519_scalar_uint1 x224;
  uint32_t x225;
  fiat_25519_scalar_uint1 x226;
  uint32_t x227;
  fiat_25519_scalar_uint1 x228;
  uint32_t x229;
  fiat_25519_scalar_uint1 x230;
  uint32_t x231;
  fiat_25519_scalar_uint1 x232;
  uint32_t x233;
  uint32_t x234;
  uint32_t x235;
  uint32_t x236;
  uint32_t x237;
  uint32_t x238;
  uint32_t x239;
  uint32_t x240;
  uint32_t x241;
  uint32_t x242;
  uint32_t x243;
  uint32_t x244;
  uint32_t x245;
  uint32_t x246;
  uint32_t x247;
  uint32_t x248;
  uint32_t x249;
  fiat_25519_scalar_uint1 x250;
  uint32_t x251;
  fiat_25519_scalar_uint1 x252;
  uint32_t x253;
  fiat_25519_scalar_uint1 x254;
  uint32_t x255;
  fiat_25519_scalar_uint1 x256;
  uint32_t x257;
  fiat_25519_scalar_uint1 x258;
  uint32_t x259;
  fiat_25519_scalar_uint1 x260;
  uint32_t x261;
  fiat_25519_scalar_uint1 x262;
  uint32_t x263;
  fiat_25519_scalar_uint1 x264;
  uint32_t x265;
  fiat_25519_scalar_uint1 x266;
  uint32_t x267;
  fiat_25519_scalar_uint1 x268;
  uint32_t x269;
  fiat_25519_scalar_uint1 x270;
  uint32_t x271;
  fiat_25519_scalar_uint1 x272;
  uint32_t x273;
  fiat_25519_scalar_uint1 x274;
  uint32_t x275;
  fiat_25519_scalar_uint1 x276;
  uint32_t x277;
  fiat_25519_scalar_uint1 x278;
  uint32_t x279;
  uint32_t x280;
  uint32_t x281;
  uint32_t x282;
  uint32_t x283;
  uint32_t x284;
  uint32_t x285;
  uint32_t x286;
  uint32_t x287;
  uint32_t x288;
  uint32_t x289;
  uint32_t x290;
  uint32_t x291;
  fiat_25519_scalar_uint1 x292;
  uint32_t x293;
  fiat_25519_scalar_uint1 x294;
  uint32_t x295;
  fiat_25519_scalar_uint1 x296;
  uint32_t x297;
  fiat_25519_scalar_uint1 x298;
  uint32_t x299;
  fiat_25519_scalar_uint1 x300;
  uint32_t x301;
  fiat_25519_scalar_uint1 x302;
  uint32_t x303;
  fiat_25519_scalar_uint1 x304;
  uint32_t x305;
  fiat_25519_scalar_uint1 x306;
  uint32_t x307;
  fiat_25519_scalar_uint1 x308;
  uint32_t x309;
  fiat_25519_scalar_uint1 x310;
  uint32_t x311;
  fiat_25519_scalar_uint1 x312;
  uint32_t x313;
  uint32_t x314;
  uint32_t x315;
  uint32_t x316;
  uint32_t x317;
  uint32_t x318;
  uint32_t x319;
  uint32_t x320;
  uint32_t x321;
  uint32_t x322;
  uint32_t x323;
  uint32_t x324;
  uint32_t x325;
  uint32_t x326;
  uint32_t x327;
  uint32_t x328;
  uint32_t x329;
  fiat_25519_scalar_uint1 x330;
  uint32_t x331;
  fiat_25519_scalar_uint1 x332;
  uint32_t x333;
  fiat_25519_scalar_uint1 x334;
  uint32_t x335;
  fiat_25519_scalar_uint1 x336;
  uint32_t x337;
  fiat_25519_scalar_uint1 x338;
  uint32_t x339;
  fiat_25519_scalar_uint1 x340;
  uint32_t x341;
  fiat_25519_scalar_uint1 x342;
  uint32_t x343;
  fiat_25519_scalar_uint1 x344;
  uint32_t x345;
  fiat_25519_scalar_uint1 x346;
  uint32_t x347;
  fiat_25519_scalar_uint1 x348;
  uint32_t x349;
  fiat_25519_scalar_uint1 x350;
  uint32_t x351;
  fiat_25519_scalar_uint1 x352;
  uint32_t x353;
  fiat_25519_scalar_uint1 x354;
  uint32_t x355;
  fiat_25519_scalar_uint1 x356;
  uint32_t x357;
  fiat_25519_scalar_uint1 x358;
  uint32_t x359;
  uint32_t x360;
  uint32_t x361;
  uint32_t x362;
  uint32_t x363;
  uint32_t x364;
  uint32_t x365;
  uint32_t x366;
  uint32_t x367;
  uint32_t x368;
  uint32_t x369;
  uint32_t x370;
  uint32_t x371;
  fiat_25519_scalar_uint1 x372;
  uint32_t x373;
  fiat_25519_scalar_uint1 x374;
  uint32_t x375;
  fiat_25519_scalar_uint1 x376;
  uint32_t x377;
  fiat_25519_scalar_uint1 x378;
  uint32_t x379;
  fiat_25519_scalar_uint1 x380;
  uint32_t x381;
  fiat_25519_scalar_uint1 x382;
  uint32_t x383;
  fiat_25519_scalar_uint1 x384;
  uint32_t x385;
  fiat_25519_scalar_uint1 x386;
  uint32_t x387;
  fiat_25519_scalar_uint1 x388;
  uint32_t x389;
  fiat_25519_scalar_uint1 x390;
  uint32_t x391;
  fiat_25519_scalar_uint1 x392;
  uint32_t x393;
  uint32_t x394;
  uint32_t x395;
  uint32_t x396;
  uint32_t x397;
  uint32_t x398;
  uint32_t x399;
  uint32_t x400;
  uint32_t x401;
  uint32_t x402;
  uint32_t x403;
  uint32_t x404;
  uint32_t x405;
  uint32_t x406;
  uint32_t x407;
  uint32_t x408;
  uint32_t x409;
  fiat_25519_scalar_uint1 x410;
  uint32_t x411;
  fiat_25519_scalar_uint1 x412;
  uint32_t x413;
  fiat_25519_scalar_uint1 x414;
  uint32_t x415;
  fiat_25519_scalar_uint1 x416;
  uint32_t x417;
  fiat_25519_scalar_uint1 x418;
  uint32_t x419;
  fiat_25519_scalar_uint1 x420;
  uint32_t x421;
  fiat_25519_scalar_uint1 x422;
  uint32_t x423;
  fiat_25519_scalar_uint1 x424;
  uint32_t x425;
  fiat_25519_scalar_uint1 x426;
  uint32_t x427;
  fiat_25519_scalar_uint1 x428;
  uint32_t x429;
  fiat_25519_scalar_uint1 x430;
  uint32_t x431;
  fiat_25519_scalar_uint1 x432;
  uint32_t x433;
  fiat_25519_scalar_uint1 x434;
  uint32_t x435;
  fiat_25519_scalar_uint1 x436;
  uint32_t x437;
  fiat_25519_scalar_uint1 x438;
  uint32_t x439;
  uint32_t x440;
  uint32_t x441;
  uint32_t x442;
  uint32_t x443;
  uint32_t x444;
  uint32_t x445;
  uint32_t x446;
  uint32_t x447;
  uint32_t x448;
  uint32_t x449;
  uint32_t x450;
  uint32_t x451;
  fiat_25519_scalar_uint1 x452;
  uint32_t x453;
  fiat_25519_scalar_uint1 x454;
  uint32_t x455;
  fiat_25519_scalar_uint1 x456;
  uint32_t x457;
  fiat_25519_scalar_uint1 x458;
  uint32_t x459;
  fiat_25519_scalar_uint1 x460;
  uint32_t x461;
  fiat_25519_scalar_uint1 x462;
  uint32_t x463;
  fiat_25519_scalar_uint1 x464;
  uint32_t x465;
  fiat_25519_scalar_uint1 x466;
  uint32_t x467;
  fiat_25519_scalar_uint1 x468;
  uint32_t x469;
  fiat_25519_scalar_uint1 x470;
  uint32_t x471;
  fiat_25519_scalar_uint1 x472;
  uint32_t x473;
  uint32_t x474;
  uint32_t x475;
  uint32_t x476;
  uint32_t x477;
  uint32_t x478;
  uint32_t x479;
  uint32_t x480;
  uint32_t x481;
  uint32_t x482;
  uint32_t x483;
  uint32_t x484;
  uint32_t x485;
  uint32_t x486;
  uint32_t x487;
  uint32_t x488;
  uint32_t x489;
  fiat_25519_scalar_uint1 x490;
  uint32_t x491;
  fiat_25519_scalar_uint1 x492;
  uint32_t x493;
  fiat_25519_scalar_uint1 x494;
  uint32_t x495;
  fiat_25519_scalar_uint1 x496;
  uint32_t x497;
  fiat_25519_scalar_uint1 x498;
  uint32_t x499;
  fiat_25519_scalar_uint1 x500;
  uint32_t x501;
  fiat_25519_scalar_uint1 x502;
  uint32_t x503;
  fiat_25519_scalar_uint1 x504;
  uint32_t x505;
  fiat_25519_scalar_uint1 x506;
  uint32_t x507;
  fiat_25519_scalar_uint1 x508;
  uint32_t x509;
  fiat_25519_scalar_uint1 x510;
  uint32_t x511;
  fiat_25519_scalar_uint1 x512;
  uint32_t x513;
  fiat_25519_scalar_uint1 x514;
  uint32_t x515;
  fiat_25519_scalar_uint1 x516;
  uint32_t x517;
  fiat_25519_scalar_uint1 x518;
  uint32_t x519;
  uint32_t x520;
  uint32_t x521;
  uint32_t x522;
  uint32_t x523;
  uint32_t x524;
  uint32_t x525;
  uint32_t x526;
  uint32_t x527;
  uint32_t x528;
  uint32_t x529;
  uint32_t x530;
  uint32_t x531;
  fiat_25519_scalar_uint1 x532;
  uint32_t x533;
  fiat_25519_scalar_uint1 x534;
  uint32_t x535;
  fiat_25519_scalar_uint1 x536;
  uint32_t x537;
  fiat_25519_scalar_uint1 x538;
  uint32_t x539;
  fiat_25519_scalar_uint1 x540;
  uint32_t x541;
  fiat_25519_scalar_uint1 x542;
  uint32_t x543;
  fiat_25519_scalar_uint1 x544;
  uint32_t x545;
  fiat_25519_scalar_uint1 x546;
  uint32_t x547;
  fiat_25519_scalar_uint1 x548;
  uint32_t x549;
  fiat_25519_scalar_uint1 x550;
  uint32_t x551;
  fiat_25519_scalar_uint1 x552;
  uint32_t x553;
  uint32_t x554;
  uint32_t x555;
  uint32_t x556;
  uint32_t x557;
  uint32_t x558;
  uint32_t x559;
  uint32_t x560;
  uint32_t x561;
  uint32_t x562;
  uint32_t x563;
  uint32_t x564;
  uint32_t x565;
  uint32_t x566;
  uint32_t x567;
  uint32_t x568;
  uint32_t x569;
  fiat_25519_scalar_uint1 x570;
  uint32_t x571;
  fiat_25519_scalar_uint1 x572;
  uint32_t x573;
  fiat_25519_scalar_uint1 x574;
  uint32_t x575;
  fiat_25519_scalar_uint1 x576;
  uint32_t x577;
  fiat_25519_scalar_uint1 x578;
  uint32_t x579;
  fiat_25519_scalar_uint1 x580;
  uint32_t x581;
  fiat_25519_scalar_uint1 x582;
  uint32_t x583;
  fiat_25519_scalar_uint1 x584;
  uint32_t x585;
  fiat_25519_scalar_uint1 x586;
  uint32_t x587;
  fiat_25519_scalar_uint1 x588;
  uint32_t x589;
  fiat_25519_scalar_uint1 x590;
  uint32_t x591;
  fiat_25519_scalar_uint1 x592;
  uint32_t x593;
  fiat_25519_scalar_uint1 x594;
  uint32_t x595;
  fiat_25519_scalar_uint1 x596;
  uint32_t x597;
  fiat_25519_scalar_uint1 x598;
  uint32_t x599;
  uint32_t x600;
  uint32_t x601;
  uint32_t x602;
  uint32_t x603;
  uint32_t x604;
  uint32_t x605;
  uint32_t x606;
  uint32_t x607;
  uint32_t x608;
  uint32_t x609;
  uint32_t x610;
  uint32_t x611;
  fiat_25519_scalar_uint1 x612;
  uint32_t x613;
  fiat_25519_scalar_uint1 x614;
  uint32_t x615;
  fiat_25519_scalar_uint1 x616;
  uint32_t x617;
  fiat_25519_scalar_uint1 x618;
  uint32_t x619;
  fiat_25519_scalar_uint1 x620;
  uint32_t x621;
  fiat_25519_scalar_uint1 x622;
  uint32_t x623;
  fiat_25519_scalar_uint1 x624;
  uint32_t x625;
  fiat_25519_scalar_uint1 x626;
  uint32_t x627;
  fiat_25519_scalar_uint1 x628;
  uint32_t x629;
  fiat_25519_scalar_uint1 x630;
  uint32_t x631;
  fiat_25519_scalar_uint1 x632;
  uint32_t x633;
  uint32_t x634;
  fiat_25519_scalar_uint1 x635;
  uint32_t x636;
  fiat_25519_scalar_uint1 x637;
  uint32_t x638;
  fiat_25519_scalar_uint1 x639;
  uint32_t x640;
  fiat_25519_scalar_uint1 x641;
  uint32_t x642;
  fiat_25519_scalar_uint1 x643;
  uint32_t x644;
  fiat_25519_scalar_uint1 x645;
  uint32_t x646;
  fiat_25519_scalar_uint1 x647;
  uint32_t x648;
  fiat_25519_scalar_uint1 x649;
  uint32_t x650;
  fiat_25519_scalar_uint1 x651;
  uint32_t x652;
  uint32_t x653;
  uint32_t x654;
  uint32_t x655;
  uint32_t x656;
  uint32_t x657;
  uint32_t x658;
  uint32_t x659;
  x1 = (arg1[1]);
  x2 = (arg1[2]);
  x3 = (arg1[3]);
  x4 = (arg1[4]);
  x5 = (arg1[5]);
  x6 = (arg1[6]);
  x7 = (arg1[7]);
  x8 = (arg1[0]);
  fiat_25519_scalar_mulx_u32(&x9, &x10, x8, UINT32_C(0x399411b));
  fiat_25519_scalar_mulx_u32(&x11, &x12, x8, UINT32_C(0x7c309a3d));
  fiat_25519_scalar_mulx_u32(&x13, &x14, x8, UINT32_C(0xceec73d2));
  fiat_25519_scalar_mulx_u32(&x15, &x16, x8, UINT32_C(0x17f5be65));
  fiat_25519_scalar_mulx_u32(&x17, &x18, x8, UINT32_C(0xd00e1ba7));
  fiat_25519_scalar_mulx_u32(&x19, &x20, x8, UINT32_C(0x68859347));
  fiat_25519_scalar_mulx_u32(&x21, &x22, x8, UINT32_C(0xa40611e3));
  fiat_25519_scalar_mulx_u32(&x23, &x24, x8, UINT32_C(0x449c0f01));
  fiat_25519_scalar_addcarryx_u32(&x25, &x26, 0x0, x24, x21);
  fiat_25519_scalar_addcarryx_u32(&x27, &x28, x26, x22, x19);
  fiat_25519_scalar_addcarryx_u32(&x29, &x30, x28, x20, x17);
  fiat_25519_scalar_addcarryx_u32(&x31, &x32, x30, x18, x15);
  fiat_25519_scalar_addcarryx_u32(&x33, &x34, x32, x16, x13);
  fiat_25519_scalar_addcarryx_u32(&x35, &x36, x34, x14, x11);
  fiat_25519_scalar_addcarryx_u32(&x37, &x38, x36, x12, x9);
  fiat_25519_scalar_mulx_u32(&x39, &x40, x23, UINT32_C(0x12547e1b));
  fiat_25519_scalar_mulx_u32(&x41, &x42, x39, UINT32_C(0x10000000));
  fiat_25519_scalar_mulx_u32(&x43, &x44, x39, UINT32_C(0x14def9de));
  fiat_25519_scalar_mulx_u32(&x45, &x46, x39, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_mulx_u32(&x47, &x48, x39, UINT32_C(0x5812631a));
  fiat_25519_scalar_mulx_u32(&x49, &x50, x39, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_addcarryx_u32(&x51, &x52, 0x0, x50, x47);
  fiat_25519_scalar_addcarryx_u32(&x53, &x54, x52, x48, x45);
  fiat_25519_scalar_addcarryx_u32(&x55, &x56, x54, x46, x43);
  fiat_25519_scalar_addcarryx_u32(&x57, &x58, 0x0, x23, x49);
  fiat_25519_scalar_addcarryx_u32(&x59, &x60, x58, x25, x51);
  fiat_25519_scalar_addcarryx_u32(&x61, &x62, x60, x27, x53);
  fiat_25519_scalar_addcarryx_u32(&x63, &x64, x62, x29, x55);
  fiat_25519_scalar_addcarryx_u32(&x65, &x66, x64, x31, (x56 + x44));
  fiat_25519_scalar_addcarryx_u32(&x67, &x68, x66, x33, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x69, &x70, x68, x35, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x71, &x72, x70, x37, x41);
  fiat_25519_scalar_mulx_u32(&x73, &x74, x1, UINT32_C(0x399411b));
  fiat_25519_scalar_mulx_u32(&x75, &x76, x1, UINT32_C(0x7c309a3d));
  fiat_25519_scalar_mulx_u32(&x77, &x78, x1, UINT32_C(0xceec73d2));
  fiat_25519_scalar_mulx_u32(&x79, &x80, x1, UINT32_C(0x17f5be65));
  fiat_25519_scalar_mulx_u32(&x81, &x82, x1, UINT32_C(0xd00e1ba7));
  fiat_25519_scalar_mulx_u32(&x83, &x84, x1, UINT32_C(0x68859347));
  fiat_25519_scalar_mulx_u32(&x85, &x86, x1, UINT32_C(0xa40611e3));
  fiat_25519_scalar_mulx_u32(&x87, &x88, x1, UINT32_C(0x449c0f01));
  fiat_25519_scalar_addcarryx_u32(&x89, &x90, 0x0, x88, x85);
  fiat_25519_scalar_addcarryx_u32(&x91, &x92, x90, x86, x83);
  fiat_25519_scalar_addcarryx_u32(&x93, &x94, x92, x84, x81);
  fiat_25519_scalar_addcarryx_u32(&x95, &x96, x94, x82, x79);
  fiat_25519_scalar_addcarryx_u32(&x97, &x98, x96, x80, x77);
  fiat_25519_scalar_addcarryx_u32(&x99, &x100, x98, x78, x75);
  fiat_25519_scalar_addcarryx_u32(&x101, &x102, x100, x76, x73);
  fiat_25519_scalar_addcarryx_u32(&x103, &x104, 0x0, x59, x87);
  fiat_25519_scalar_addcarryx_u32(&x105, &x106, x104, x61, x89);
  fiat_25519_scalar_addcarryx_u32(&x107, &x108, x106, x63, x91);
  fiat_25519_scalar_addcarryx_u32(&x109, &x110, x108, x65, x93);
  fiat_25519_scalar_addcarryx_u32(&x111, &x112, x110, x67, x95);
  fiat_25519_scalar_addcarryx_u32(&x113, &x114, x112, x69, x97);
  fiat_25519_scalar_addcarryx_u32(&x115, &x116, x114, x71, x99);
  fiat_25519_scalar_addcarryx_u32(&x117, &x118, x116, ((x72 + (x38 + x10)) + x42), x101);
  fiat_25519_scalar_mulx_u32(&x119, &x120, x103, UINT32_C(0x12547e1b));
  fiat_25519_scalar_mulx_u32(&x121, &x122, x119, UINT32_C(0x10000000));
  fiat_25519_scalar_mulx_u32(&x123, &x124, x119, UINT32_C(0x14def9de));
  fiat_25519_scalar_mulx_u32(&x125, &x126, x119, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_mulx_u32(&x127, &x128, x119, UINT32_C(0x5812631a));
  fiat_25519_scalar_mulx_u32(&x129, &x130, x119, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_addcarryx_u32(&x131, &x132, 0x0, x130, x127);
  fiat_25519_scalar_addcarryx_u32(&x133, &x134, x132, x128, x125);
  fiat_25519_scalar_addcarryx_u32(&x135, &x136, x134, x126, x123);
  fiat_25519_scalar_addcarryx_u32(&x137, &x138, 0x0, x103, x129);
  fiat_25519_scalar_addcarryx_u32(&x139, &x140, x138, x105, x131);
  fiat_25519_scalar_addcarryx_u32(&x141, &x142, x140, x107, x133);
  fiat_25519_scalar_addcarryx_u32(&x143, &x144, x142, x109, x135);
  fiat_25519_scalar_addcarryx_u32(&x145, &x146, x144, x111, (x136 + x124));
  fiat_25519_scalar_addcarryx_u32(&x147, &x148, x146, x113, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x149, &x150, x148, x115, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x151, &x152, x150, x117, x121);
  fiat_25519_scalar_mulx_u32(&x153, &x154, x2, UINT32_C(0x399411b));
  fiat_25519_scalar_mulx_u32(&x155, &x156, x2, UINT32_C(0x7c309a3d));
  fiat_25519_scalar_mulx_u32(&x157, &x158, x2, UINT32_C(0xceec73d2));
  fiat_25519_scalar_mulx_u32(&x159, &x160, x2, UINT32_C(0x17f5be65));
  fiat_25519_scalar_mulx_u32(&x161, &x162, x2, UINT32_C(0xd00e1ba7));
  fiat_25519_scalar_mulx_u32(&x163, &x164, x2, UINT32_C(0x68859347));
  fiat_25519_scalar_mulx_u32(&x165, &x166, x2, UINT32_C(0xa40611e3));
  fiat_25519_scalar_mulx_u32(&x167, &x168, x2, UINT32_C(0x449c0f01));
  fiat_25519_scalar_addcarryx_u32(&x169, &x170, 0x0, x168, x165);
  fiat_25519_scalar_addcarryx_u32(&x171, &x172, x170, x166, x163);
  fiat_25519_scalar_addcarryx_u32(&x173, &x174, x172, x164, x161);
  fiat_25519_scalar_addcarryx_u32(&x175, &x176, x174, x162, x159);
  fiat_25519_scalar_addcarryx_u32(&x177, &x178, x176, x160, x157);
  fiat_25519_scalar_addcarryx_u32(&x179, &x180, x178, x158, x155);
  fiat_25519_scalar_addcarryx_u32(&x181, &x182, x180, x156, x153);
  fiat_25519_scalar_addcarryx_u32(&x183, &x184, 0x0, x139, x167);
  fiat_25519_scalar_addcarryx_u32(&x185, &x186, x184, x141, x169);
  fiat_25519_scalar_addcarryx_u32(&x187, &x188, x186, x143, x171);
  fiat_25519_scalar_addcarryx_u32(&x189, &x190, x188, x145, x173);
  fiat_25519_scalar_addcarryx_u32(&x191, &x192, x190, x147, x175);
  fiat_25519_scalar_addcarryx_u32(&x193, &x194, x192, x149, x177);
  fiat_25519_scalar_addcarryx_u32(&x195, &x196, x194, x151, x179);
  fiat_25519_scalar_addcarryx_u32(&x197, &x198, x196, ((x152 + (x118 + (x102 + x74))) + x122), x181);
  fiat_25519_scalar_mulx_u32(&x199, &x200, x183, UINT32_C(0x12547e1b));
  fiat_25519_scalar_mulx_u32(&x201, &x202, x199, UINT32_C(0x10000000));
  fiat_25519_scalar_mulx_u32(&x203, &x204, x199, UINT32_C(0x14def9de));
  fiat_25519_scalar_mulx_u32(&x205, &x206, x199, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_mulx_u32(&x207, &x208, x199, UINT32_C(0x5812631a));
  fiat_25519_scalar_mulx_u32(&x209, &x210, x199, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_addcarryx_u32(&x211, &x212, 0x0, x210, x207);
  fiat_25519_scalar_addcarryx_u32(&x213, &x214, x212, x208, x205);
  fiat_25519_scalar_addcarryx_u32(&x215, &x216, x214, x206, x203);
  fiat_25519_scalar_addcarryx_u32(&x217, &x218, 0x0, x183, x209);
  fiat_25519_scalar_addcarryx_u32(&x219, &x220, x218, x185, x211);
  fiat_25519_scalar_addcarryx_u32(&x221, &x222, x220, x187, x213);
  fiat_25519_scalar_addcarryx_u32(&x223, &x224, x222, x189, x215);
  fiat_25519_scalar_addcarryx_u32(&x225, &x226, x224, x191, (x216 + x204));
  fiat_25519_scalar_addcarryx_u32(&x227, &x228, x226, x193, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x229, &x230, x228, x195, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x231, &x232, x230, x197, x201);
  fiat_25519_scalar_mulx_u32(&x233, &x234, x3, UINT32_C(0x399411b));
  fiat_25519_scalar_mulx_u32(&x235, &x236, x3, UINT32_C(0x7c309a3d));
  fiat_25519_scalar_mulx_u32(&x237, &x238, x3, UINT32_C(0xceec73d2));
  fiat_25519_scalar_mulx_u32(&x239, &x240, x3, UINT32_C(0x17f5be65));
  fiat_25519_scalar_mulx_u32(&x241, &x242, x3, UINT32_C(0xd00e1ba7));
  fiat_25519_scalar_mulx_u32(&x243, &x244, x3, UINT32_C(0x68859347));
  fiat_25519_scalar_mulx_u32(&x245, &x246, x3, UINT32_C(0xa40611e3));
  fiat_25519_scalar_mulx_u32(&x247, &x248, x3, UINT32_C(0x449c0f01));
  fiat_25519_scalar_addcarryx_u32(&x249, &x250, 0x0, x248, x245);
  fiat_25519_scalar_addcarryx_u32(&x251, &x252, x250, x246, x243);
  fiat_25519_scalar_addcarryx_u32(&x253, &x254, x252, x244, x241);
  fiat_25519_scalar_addcarryx_u32(&x255, &x256, x254, x242, x239);
  fiat_25519_scalar_addcarryx_u32(&x257, &x258, x256, x240, x237);
  fiat_25519_scalar_addcarryx_u32(&x259, &x260, x258, x238, x235);
  fiat_25519_scalar_addcarryx_u32(&x261, &x262, x260, x236, x233);
  fiat_25519_scalar_addcarryx_u32(&x263, &x264, 0x0, x219, x247);
  fiat_25519_scalar_addcarryx_u32(&x265, &x266, x264, x221, x249);
  fiat_25519_scalar_addcarryx_u32(&x267, &x268, x266, x223, x251);
  fiat_25519_scalar_addcarryx_u32(&x269, &x270, x268, x225, x253);
  fiat_25519_scalar_addcarryx_u32(&x271, &x272, x270, x227, x255);
  fiat_25519_scalar_addcarryx_u32(&x273, &x274, x272, x229, x257);
  fiat_25519_scalar_addcarryx_u32(&x275, &x276, x274, x231, x259);
  fiat_25519_scalar_addcarryx_u32(&x277, &x278, x276, ((x232 + (x198 + (x182 + x154))) + x202), x261);
  fiat_25519_scalar_mulx_u32(&x279, &x280, x263, UINT32_C(0x12547e1b));
  fiat_25519_scalar_mulx_u32(&x281, &x282, x279, UINT32_C(0x10000000));
  fiat_25519_scalar_mulx_u32(&x283, &x284, x279, UINT32_C(0x14def9de));
  fiat_25519_scalar_mulx_u32(&x285, &x286, x279, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_mulx_u32(&x287, &x288, x279, UINT32_C(0x5812631a));
  fiat_25519_scalar_mulx_u32(&x289, &x290, x279, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_addcarryx_u32(&x291, &x292, 0x0, x290, x287);
  fiat_25519_scalar_addcarryx_u32(&x293, &x294, x292, x288, x285);
  fiat_25519_scalar_addcarryx_u32(&x295, &x296, x294, x286, x283);
  fiat_25519_scalar_addcarryx_u32(&x297, &x298, 0x0, x263, x289);
  fiat_25519_scalar_addcarryx_u32(&x299, &x300, x298, x265, x291);
  fiat_25519_scalar_addcarryx_u32(&x301, &x302, x300, x267, x293);
  fiat_25519_scalar_addcarryx_u32(&x303, &x304, x302, x269, x295);
  fiat_25519_scalar_addcarryx_u32(&x305, &x306, x304, x271, (x296 + x284));
  fiat_25519_scalar_addcarryx_u32(&x307, &x308, x306, x273, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x309, &x310, x308, x275, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x311, &x312, x310, x277, x281);
  fiat_25519_scalar_mulx_u32(&x313, &x314, x4, UINT32_C(0x399411b));
  fiat_25519_scalar_mulx_u32(&x315, &x316, x4, UINT32_C(0x7c309a3d));
  fiat_25519_scalar_mulx_u32(&x317, &x318, x4, UINT32_C(0xceec73d2));
  fiat_25519_scalar_mulx_u32(&x319, &x320, x4, UINT32_C(0x17f5be65));
  fiat_25519_scalar_mulx_u32(&x321, &x322, x4, UINT32_C(0xd00e1ba7));
  fiat_25519_scalar_mulx_u32(&x323, &x324, x4, UINT32_C(0x68859347));
  fiat_25519_scalar_mulx_u32(&x325, &x326, x4, UINT32_C(0xa40611e3));
  fiat_25519_scalar_mulx_u32(&x327, &x328, x4, UINT32_C(0x449c0f01));
  fiat_25519_scalar_addcarryx_u32(&x329, &x330, 0x0, x328, x325);
  fiat_25519_scalar_addcarryx_u32(&x331, &x332, x330, x326, x323);
  fiat_25519_scalar_addcarryx_u32(&x333, &x334, x332, x324, x321);
  fiat_25519_scalar_addcarryx_u32(&x335, &x336, x334, x322, x319);
  fiat_25519_scalar_addcarryx_u32(&x337, &x338, x336, x320, x317);
  fiat_25519_scalar_addcarryx_u32(&x339, &x340, x338, x318, x315);
  fiat_25519_scalar_addcarryx_u32(&x341, &x342, x340, x316, x313);
  fiat_25519_scalar_addcarryx_u32(&x343, &x344, 0x0, x299, x327);
  fiat_25519_scalar_addcarryx_u32(&x345, &x346, x344, x301, x329);
  fiat_25519_scalar_addcarryx_u32(&x347, &x348, x346, x303, x331);
  fiat_25519_scalar_addcarryx_u32(&x349, &x350, x348, x305, x333);
  fiat_25519_scalar_addcarryx_u32(&x351, &x352, x350, x307, x335);
  fiat_25519_scalar_addcarryx_u32(&x353, &x354, x352, x309, x337);
  fiat_25519_scalar_addcarryx_u32(&x355, &x356, x354, x311, x339);
  fiat_25519_scalar_addcarryx_u32(&x357, &x358, x356, ((x312 + (x278 + (x262 + x234))) + x282), x341);
  fiat_25519_scalar_mulx_u32(&x359, &x360, x343, UINT32_C(0x12547e1b));
  fiat_25519_scalar_mulx_u32(&x361, &x362, x359, UINT32_C(0x10000000));
  fiat_25519_scalar_mulx_u32(&x363, &x364, x359, UINT32_C(0x14def9de));
  fiat_25519_scalar_mulx_u32(&x365, &x366, x359, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_mulx_u32(&x367, &x368, x359, UINT32_C(0x5812631a));
  fiat_25519_scalar_mulx_u32(&x369, &x370, x359, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_addcarryx_u32(&x371, &x372, 0x0, x370, x367);
  fiat_25519_scalar_addcarryx_u32(&x373, &x374, x372, x368, x365);
  fiat_25519_scalar_addcarryx_u32(&x375, &x376, x374, x366, x363);
  fiat_25519_scalar_addcarryx_u32(&x377, &x378, 0x0, x343, x369);
  fiat_25519_scalar_addcarryx_u32(&x379, &x380, x378, x345, x371);
  fiat_25519_scalar_addcarryx_u32(&x381, &x382, x380, x347, x373);
  fiat_25519_scalar_addcarryx_u32(&x383, &x384, x382, x349, x375);
  fiat_25519_scalar_addcarryx_u32(&x385, &x386, x384, x351, (x376 + x364));
  fiat_25519_scalar_addcarryx_u32(&x387, &x388, x386, x353, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x389, &x390, x388, x355, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x391, &x392, x390, x357, x361);
  fiat_25519_scalar_mulx_u32(&x393, &x394, x5, UINT32_C(0x399411b));
  fiat_25519_scalar_mulx_u32(&x395, &x396, x5, UINT32_C(0x7c309a3d));
  fiat_25519_scalar_mulx_u32(&x397, &x398, x5, UINT32_C(0xceec73d2));
  fiat_25519_scalar_mulx_u32(&x399, &x400, x5, UINT32_C(0x17f5be65));
  fiat_25519_scalar_mulx_u32(&x401, &x402, x5, UINT32_C(0xd00e1ba7));
  fiat_25519_scalar_mulx_u32(&x403, &x404, x5, UINT32_C(0x68859347));
  fiat_25519_scalar_mulx_u32(&x405, &x406, x5, UINT32_C(0xa40611e3));
  fiat_25519_scalar_mulx_u32(&x407, &x408, x5, UINT32_C(0x449c0f01));
  fiat_25519_scalar_addcarryx_u32(&x409, &x410, 0x0, x408, x405);
  fiat_25519_scalar_addcarryx_u32(&x411, &x412, x410, x406, x403);
  fiat_25519_scalar_addcarryx_u32(&x413, &x414, x412, x404, x401);
  fiat_25519_scalar_addcarryx_u32(&x415, &x416, x414, x402, x399);
  fiat_25519_scalar_addcarryx_u32(&x417, &x418, x416, x400, x397);
  fiat_25519_scalar_addcarryx_u32(&x419, &x420, x418, x398, x395);
  fiat_25519_scalar_addcarryx_u32(&x421, &x422, x420, x396, x393);
  fiat_25519_scalar_addcarryx_u32(&x423, &x424, 0x0, x379, x407);
  fiat_25519_scalar_addcarryx_u32(&x425, &x426, x424, x381, x409);
  fiat_25519_scalar_addcarryx_u32(&x427, &x428, x426, x383, x411);
  fiat_25519_scalar_addcarryx_u32(&x429, &x430, x428, x385, x413);
  fiat_25519_scalar_addcarryx_u32(&x431, &x432, x430, x387, x415);
  fiat_25519_scalar_addcarryx_u32(&x433, &x434, x432, x389, x417);
  fiat_25519_scalar_addcarryx_u32(&x435, &x436, x434, x391, x419);
  fiat_25519_scalar_addcarryx_u32(&x437, &x438, x436, ((x392 + (x358 + (x342 + x314))) + x362), x421);
  fiat_25519_scalar_mulx_u32(&x439, &x440, x423, UINT32_C(0x12547e1b));
  fiat_25519_scalar_mulx_u32(&x441, &x442, x439, UINT32_C(0x10000000));
  fiat_25519_scalar_mulx_u32(&x443, &x444, x439, UINT32_C(0x14def9de));
  fiat_25519_scalar_mulx_u32(&x445, &x446, x439, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_mulx_u32(&x447, &x448, x439, UINT32_C(0x5812631a));
  fiat_25519_scalar_mulx_u32(&x449, &x450, x439, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_addcarryx_u32(&x451, &x452, 0x0, x450, x447);
  fiat_25519_scalar_addcarryx_u32(&x453, &x454, x452, x448, x445);
  fiat_25519_scalar_addcarryx_u32(&x455, &x456, x454, x446, x443);
  fiat_25519_scalar_addcarryx_u32(&x457, &x458, 0x0, x423, x449);
  fiat_25519_scalar_addcarryx_u32(&x459, &x460, x458, x425, x451);
  fiat_25519_scalar_addcarryx_u32(&x461, &x462, x460, x427, x453);
  fiat_25519_scalar_addcarryx_u32(&x463, &x464, x462, x429, x455);
  fiat_25519_scalar_addcarryx_u32(&x465, &x466, x464, x431, (x456 + x444));
  fiat_25519_scalar_addcarryx_u32(&x467, &x468, x466, x433, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x469, &x470, x468, x435, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x471, &x472, x470, x437, x441);
  fiat_25519_scalar_mulx_u32(&x473, &x474, x6, UINT32_C(0x399411b));
  fiat_25519_scalar_mulx_u32(&x475, &x476, x6, UINT32_C(0x7c309a3d));
  fiat_25519_scalar_mulx_u32(&x477, &x478, x6, UINT32_C(0xceec73d2));
  fiat_25519_scalar_mulx_u32(&x479, &x480, x6, UINT32_C(0x17f5be65));
  fiat_25519_scalar_mulx_u32(&x481, &x482, x6, UINT32_C(0xd00e1ba7));
  fiat_25519_scalar_mulx_u32(&x483, &x484, x6, UINT32_C(0x68859347));
  fiat_25519_scalar_mulx_u32(&x485, &x486, x6, UINT32_C(0xa40611e3));
  fiat_25519_scalar_mulx_u32(&x487, &x488, x6, UINT32_C(0x449c0f01));
  fiat_25519_scalar_addcarryx_u32(&x489, &x490, 0x0, x488, x485);
  fiat_25519_scalar_addcarryx_u32(&x491, &x492, x490, x486, x483);
  fiat_25519_scalar_addcarryx_u32(&x493, &x494, x492, x484, x481);
  fiat_25519_scalar_addcarryx_u32(&x495, &x496, x494, x482, x479);
  fiat_25519_scalar_addcarryx_u32(&x497, &x498, x496, x480, x477);
  fiat_25519_scalar_addcarryx_u32(&x499, &x500, x498, x478, x475);
  fiat_25519_scalar_addcarryx_u32(&x501, &x502, x500, x476, x473);
  fiat_25519_scalar_addcarryx_u32(&x503, &x504, 0x0, x459, x487);
  fiat_25519_scalar_addcarryx_u32(&x505, &x506, x504, x461, x489);
  fiat_25519_scalar_addcarryx_u32(&x507, &x508, x506, x463, x491);
  fiat_25519_scalar_addcarryx_u32(&x509, &x510, x508, x465, x493);
  fiat_25519_scalar_addcarryx_u32(&x511, &x512, x510, x467, x495);
  fiat_25519_scalar_addcarryx_u32(&x513, &x514, x512, x469, x497);
  fiat_25519_scalar_addcarryx_u32(&x515, &x516, x514, x471, x499);
  fiat_25519_scalar_addcarryx_u32(&x517, &x518, x516, ((x472 + (x438 + (x422 + x394))) + x442), x501);
  fiat_25519_scalar_mulx_u32(&x519, &x520, x503, UINT32_C(0x12547e1b));
  fiat_25519_scalar_mulx_u32(&x521, &x522, x519, UINT32_C(0x10000000));
  fiat_25519_scalar_mulx_u32(&x523, &x524, x519, UINT32_C(0x14def9de));
  fiat_25519_scalar_mulx_u32(&x525, &x526, x519, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_mulx_u32(&x527, &x528, x519, UINT32_C(0x5812631a));
  fiat_25519_scalar_mulx_u32(&x529, &x530, x519, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_addcarryx_u32(&x531, &x532, 0x0, x530, x527);
  fiat_25519_scalar_addcarryx_u32(&x533, &x534, x532, x528, x525);
  fiat_25519_scalar_addcarryx_u32(&x535, &x536, x534, x526, x523);
  fiat_25519_scalar_addcarryx_u32(&x537, &x538, 0x0, x503, x529);
  fiat_25519_scalar_addcarryx_u32(&x539, &x540, x538, x505, x531);
  fiat_25519_scalar_addcarryx_u32(&x541, &x542, x540, x507, x533);
  fiat_25519_scalar_addcarryx_u32(&x543, &x544, x542, x509, x535);
  fiat_25519_scalar_addcarryx_u32(&x545, &x546, x544, x511, (x536 + x524));
  fiat_25519_scalar_addcarryx_u32(&x547, &x548, x546, x513, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x549, &x550, x548, x515, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x551, &x552, x550, x517, x521);
  fiat_25519_scalar_mulx_u32(&x553, &x554, x7, UINT32_C(0x399411b));
  fiat_25519_scalar_mulx_u32(&x555, &x556, x7, UINT32_C(0x7c309a3d));
  fiat_25519_scalar_mulx_u32(&x557, &x558, x7, UINT32_C(0xceec73d2));
  fiat_25519_scalar_mulx_u32(&x559, &x560, x7, UINT32_C(0x17f5be65));
  fiat_25519_scalar_mulx_u32(&x561, &x562, x7, UINT32_C(0xd00e1ba7));
  fiat_25519_scalar_mulx_u32(&x563, &x564, x7, UINT32_C(0x68859347));
  fiat_25519_scalar_mulx_u32(&x565, &x566, x7, UINT32_C(0xa40611e3));
  fiat_25519_scalar_mulx_u32(&x567, &x568, x7, UINT32_C(0x449c0f01));
  fiat_25519_scalar_addcarryx_u32(&x569, &x570, 0x0, x568, x565);
  fiat_25519_scalar_addcarryx_u32(&x571, &x572, x570, x566, x563);
  fiat_25519_scalar_addcarryx_u32(&x573, &x574, x572, x564, x561);
  fiat_25519_scalar_addcarryx_u32(&x575, &x576, x574, x562, x559);
  fiat_25519_scalar_addcarryx_u32(&x577, &x578, x576, x560, x557);
  fiat_25519_scalar_addcarryx_u32(&x579, &x580, x578, x558, x555);
  fiat_25519_scalar_addcarryx_u32(&x581, &x582, x580, x556, x553);
  fiat_25519_scalar_addcarryx_u32(&x583, &x584, 0x0, x539, x567);
  fiat_25519_scalar_addcarryx_u32(&x585, &x586, x584, x541, x569);
  fiat_25519_scalar_addcarryx_u32(&x587, &x588, x586, x543, x571);
  fiat_25519_scalar_addcarryx_u32(&x589, &x590, x588, x545, x573);
  fiat_25519_scalar_addcarryx_u32(&x591, &x592, x590, x547, x575);
  fiat_25519_scalar_addcarryx_u32(&x593, &x594, x592, x549, x577);
  fiat_25519_scalar_addcarryx_u32(&x595, &x596, x594, x551, x579);
  fiat_25519_scalar_addcarryx_u32(&x597, &x598, x596, ((x552 + (x518 + (x502 + x474))) + x522), x581);
  fiat_25519_scalar_mulx_u32(&x599, &x600, x583, UINT32_C(0x12547e1b));
  fiat_25519_scalar_mulx_u32(&x601, &x602, x599, UINT32_C(0x10000000));
  fiat_25519_scalar_mulx_u32(&x603, &x604, x599, UINT32_C(0x14def9de));
  fiat_25519_scalar_mulx_u32(&x605, &x606, x599, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_mulx_u32(&x607, &x608, x599, UINT32_C(0x5812631a));
  fiat_25519_scalar_mulx_u32(&x609, &x610, x599, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_addcarryx_u32(&x611, &x612, 0x0, x610, x607);
  fiat_25519_scalar_addcarryx_u32(&x613, &x614, x612, x608, x605);
  fiat_25519_scalar_addcarryx_u32(&x615, &x616, x614, x606, x603);
  fiat_25519_scalar_addcarryx_u32(&x617, &x618, 0x0, x583, x609);
  fiat_25519_scalar_addcarryx_u32(&x619, &x620, x618, x585, x611);
  fiat_25519_scalar_addcarryx_u32(&x621, &x622, x620, x587, x613);
  fiat_25519_scalar_addcarryx_u32(&x623, &x624, x622, x589, x615);
  fiat_25519_scalar_addcarryx_u32(&x625, &x626, x624, x591, (x616 + x604));
  fiat_25519_scalar_addcarryx_u32(&x627, &x628, x626, x593, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x629, &x630, x628, x595, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x631, &x632, x630, x597, x601);
  x633 = ((x632 + (x598 + (x582 + x554))) + x602);
  fiat_25519_scalar_subborrowx_u32(&x634, &x635, 0x0, x619, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_subborrowx_u32(&x636, &x637, x635, x621, UINT32_C(0x5812631a));
  fiat_25519_scalar_subborrowx_u32(&x638, &x639, x637, x623, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_subborrowx_u32(&x640, &x641, x639, x625, UINT32_C(0x14def9de));
  fiat_25519_scalar_subborrowx_u32(&x642, &x643, x641, x627, 0x0);
  fiat_25519_scalar_subborrowx_u32(&x644, &x645, x643, x629, 0x0);
  fiat_25519_scalar_subborrowx_u32(&x646, &x647, x645, x631, 0x0);
  fiat_25519_scalar_subborrowx_u32(&x648, &x649, x647, x633, UINT32_C(0x10000000));
  fiat_25519_scalar_subborrowx_u32(&x650, &x651, x649, 0x0, 0x0);
  fiat_25519_scalar_cmovznz_u32(&x652, x651, x634, x619);
  fiat_25519_scalar_cmovznz_u32(&x653, x651, x636, x621);
  fiat_25519_scalar_cmovznz_u32(&x654, x651, x638, x623);
  fiat_25519_scalar_cmovznz_u32(&x655, x651, x640, x625);
  fiat_25519_scalar_cmovznz_u32(&x656, x651, x642, x627);
  fiat_25519_scalar_cmovznz_u32(&x657, x651, x644, x629);
  fiat_25519_scalar_cmovznz_u32(&x658, x651, x646, x631);
  fiat_25519_scalar_cmovznz_u32(&x659, x651, x648, x633);
  out1[0] = x652;
  out1[1] = x653;
  out1[2] = x654;
  out1[3] = x655;
  out1[4] = x656;
  out1[5] = x657;
  out1[6] = x658;
  out1[7] = x659;
}

/*
 * The function fiat_25519_scalar_nonzero outputs a single non-zero word if the input is non-zero and zero otherwise.
 *
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   out1 = 0 ↔ eval (from_montgomery arg1) mod m = 0
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffff]
 */
static FIAT_25519_SCALAR_FIAT_INLINE void fiat_25519_scalar_nonzero(uint32_t* out1, const uint32_t arg1[8]) {
  uint32_t x1;
  x1 = ((arg1[0]) | ((arg1[1]) | ((arg1[2]) | ((arg1[3]) | ((arg1[4]) | ((arg1[5]) | ((arg1[6]) | (arg1[7]))))))));
  *out1 = x1;
}

/*
 * The function fiat_25519_scalar_selectznz is a multi-limb conditional select.
 *
 * Postconditions:
 *   out1 = (if arg1 = 0 then arg2 else arg3)
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 *   arg3: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 */
static FIAT_25519_SCALAR_FIAT_INLINE void fiat_25519_scalar_selectznz(uint32_t out1[8], fiat_25519_scalar_uint1 arg1, const uint32_t arg2[8], const uint32_t arg3[8]) {
  uint32_t x1;
  uint32_t x2;
  uint32_t x3;
  uint32_t x4;
  uint32_t x5;
  uint32_t x6;
  uint32_t x7;
  uint32_t x8;
  fiat_25519_scalar_cmovznz_u32(&x1, arg1, (arg2[0]), (arg3[0]));
  fiat_25519_scalar_cmovznz_u32(&x2, arg1, (arg2[1]), (arg3[1]));
  fiat_25519_scalar_cmovznz_u32(&x3, arg1, (arg2[2]), (arg3[2]));
  fiat_25519_scalar_cmovznz_u32(&x4, arg1, (arg2[3]), (arg3[3]));
  fiat_25519_scalar_cmovznz_u32(&x5, arg1, (arg2[4]), (arg3[4]));
  fiat_25519_scalar_cmovznz_u32(&x6, arg1, (arg2[5]), (arg3[5]));
  fiat_25519_scalar_cmovznz_u32(&x7, arg1, (arg2[6]), (arg3[6]));
  fiat_25519_scalar_cmovznz_u32(&x8, arg1, (arg2[7]), (arg3[7]));
  out1[0] = x1;
  out1[1] = x2;
  out1[2] = x3;
  out1[3] = x4;
  out1[4] = x5;
  out1[5] = x6;
  out1[6] = x7;
  out1[7] = x8;
}

/*
 * The function fiat_25519_scalar_to_bytes serializes a field element NOT in the Montgomery domain to bytes in little-endian order.
 *
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   out1 = map (λ x, ⌊((eval arg1 mod m) mod 2^(8 * (x + 1))) / 2^(8 * x)⌋) [0..31]
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0x1fffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0x1f]]
 */
static FIAT_25519_SCALAR_FIAT_INLINE void fiat_25519_scalar_to_bytes(uint8_t out1[32], const uint32_t arg1[8]) {
  uint32_t x1;
  uint32_t x2;
  uint32_t x3;
  uint32_t x4;
  uint32_t x5;
  uint32_t x6;
  uint32_t x7;
  uint32_t x8;
  uint8_t x9;
  uint32_t x10;
  uint8_t x11;
  uint32_t x12;
  uint8_t x13;
  uint8_t x14;
  uint8_t x15;
  uint32_t x16;
  uint8_t x17;
  uint32_t x18;
  uint8_t x19;
  uint8_t x20;
  uint8_t x21;
  uint32_t x22;
  uint8_t x23;
  uint32_t x24;
  uint8_t x25;
  uint8_t x26;
  uint8_t x27;
  uint32_t x28;
  uint8_t x29;
  uint32_t x30;
  uint8_t x31;
  uint8_t x32;
  uint8_t x33;
  uint32_t x34;
  uint8_t x35;
  uint32_t x36;
  uint8_t x37;
  uint8_t x38;
  uint8_t x39;
  uint32_t x40;
  uint8_t x41;
  uint32_t x42;
  uint8_t x43;
  uint8_t x44;
  uint8_t x45;
  uint32_t x46;
  uint8_t x47;
  uint32_t x48;
  uint8_t x49;
  uint8_t x50;
  uint8_t x51;
  uint32_t x52;
  uint8_t x53;
  uint32_t x54;
  uint8_t x55;
  uint8_t x56;
  x1 = (arg1[7]);
  x2 = (arg1[6]);
  x3 = (arg1[5]);
  x4 = (arg1[4]);
  x5 = (arg1[3]);
  x6 = (arg1[2]);
  x7 = (arg1[1]);
  x8 = (arg1[0]);
  x9 = (uint8_t)(x8 & UINT8_C(0xff));
  x10 = (x8 >> 8);
  x11 = (uint8_t)(x10 & UINT8_C(0xff));
  x12 = (x10 >> 8);
  x13 = (uint8_t)(x12 & UINT8_C(0xff));
  x14 = (uint8_t)(x12 >> 8);
  x15 = (uint8_t)(x7 & UINT8_C(0xff));
  x16 = (x7 >> 8);
  x17 = (uint8_t)(x16 & UINT8_C(0xff));
  x18 = (x16 >> 8);
  x19 = (uint8_t)(x18 & UINT8_C(0xff));
  x20 = (uint8_t)(x18 >> 8);
  x21 = (uint8_t)(x6 & UINT8_C(0xff));
  x22 = (x6 >> 8);
  x23 = (uint8_t)(x22 & UINT8_C(0xff));
  x24 = (x22 >> 8);
  x25 = (uint8_t)(x24 & UINT8_C(0xff));
  x26 = (uint8_t)(x24 >> 8);
  x27 = (uint8_t)(x5 & UINT8_C(0xff));
  x28 = (x5 >> 8);
  x29 = (uint8_t)(x28 & UINT8_C(0xff));
  x30 = (x28 >> 8);
  x31 = (uint8_t)(x30 & UINT8_C(0xff));
  x32 = (uint8_t)(x30 >> 8);
  x33 = (uint8_t)(x4 & UINT8_C(0xff));
  x34 = (x4 >> 8);
  x35 = (uint8_t)(x34 & UINT8_C(0xff));
  x36 = (x34 >> 8);
  x37 = (uint8_t)(x36 & UINT8_C(0xff));
  x38 = (uint8_t)(x36 >> 8);
  x39 = (uint8_t)(x3 & UINT8_C(0xff));
  x40 = (x3 >> 8);
  x41 = (uint8_t)(x40 & UINT8_C(0xff));
  x42 = (x40 >> 8);
  x43 = (uint8_t)(x42 & UINT8_C(0xff));
  x44 = (uint8_t)(x42 >> 8);
  x45 = (uint8_t)(x2 & UINT8_C(0xff));
  x46 = (x2 >> 8);
  x47 = (uint8_t)(x46 & UINT8_C(0xff));
  x48 = (x46 >> 8);
  x49 = (uint8_t)(x48 & UINT8_C(0xff));
  x50 = (uint8_t)(x48 >> 8);
  x51 = (uint8_t)(x1 & UINT8_C(0xff));
  x52 = (x1 >> 8);
  x53 = (uint8_t)(x52 & UINT8_C(0xff));
  x54 = (x52 >> 8);
  x55 = (uint8_t)(x54 & UINT8_C(0xff));
  x56 = (uint8_t)(x54 >> 8);
  out1[0] = x9;
  out1[1] = x11;
  out1[2] = x13;
  out1[3] = x14;
  out1[4] = x15;
  out1[5] = x17;
  out1[6] = x19;
  out1[7] = x20;
  out1[8] = x21;
  out1[9] = x23;
  out1[10] = x25;
  out1[11] = x26;
  out1[12] = x27;
  out1[13] = x29;
  out1[14] = x31;
  out1[15] = x32;
  out1[16] = x33;
  out1[17] = x35;
  out1[18] = x37;
  out1[19] = x38;
  out1[20] = x39;
  out1[21] = x41;
  out1[22] = x43;
  out1[23] = x44;
  out1[24] = x45;
  out1[25] = x47;
  out1[26] = x49;
  out1[27] = x50;
  out1[28] = x51;
  out1[29] = x53;
  out1[30] = x55;
  out1[31] = x56;
}

/*
 * The function fiat_25519_scalar_from_bytes deserializes a field element NOT in the Montgomery domain from bytes in little-endian order.
 *
 * Preconditions:
 *   0 ≤ bytes_eval arg1 < m
 * Postconditions:
 *   eval out1 mod m = bytes_eval arg1 mod m
 *   0 ≤ eval out1 < m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0x1f]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0x1fffffff]]
 */
static FIAT_25519_SCALAR_FIAT_INLINE void fiat_25519_scalar_from_bytes(uint32_t out1[8], const uint8_t arg1[32]) {
  uint32_t x1;
  uint32_t x2;
  uint32_t x3;
  uint8_t x4;
  uint32_t x5;
  uint32_t x6;
  uint32_t x7;
  uint8_t x8;
  uint32_t x9;
  uint32_t x10;
  uint32_t x11;
  uint8_t x12;
  uint32_t x13;
  uint32_t x14;
  uint32_t x15;
  uint8_t x16;
  uint32_t x17;
  uint32_t x18;
  uint32_t x19;
  uint8_t x20;
  uint32_t x21;
  uint32_t x22;
  uint32_t x23;
  uint8_t x24;
  uint32_t x25;
  uint32_t x26;
  uint32_t x27;
  uint8_t x28;
  uint32_t x29;
  uint32_t x30;
  uint32_t x31;
  uint8_t x32;
  uint32_t x33;
  uint32_t x34;
  uint32_t x35;
  uint32_t x36;
  uint32_t x37;
  uint32_t x38;
  uint32_t x39;
  uint32_t x40;
  uint32_t x41;
  uint32_t x42;
  uint32_t x43;
  uint32_t x44;
  uint32_t x45;
  uint32_t x46;
  uint32_t x47;
  uint32_t x48;
  uint32_t x49;
  uint32_t x50;
  uint32_t x51;
  uint32_t x52;
  uint32_t x53;
  uint32_t x54;
  uint32_t x55;
  uint32_t x56;
  x1 = ((uint32_t)(arg1[31]) << 24);
  x2 = ((uint32_t)(arg1[30]) << 16);
  x3 = ((uint32_t)(arg1[29]) << 8);
  x4 = (arg1[28]);
  x5 = ((uint32_t)(arg1[27]) << 24);
  x6 = ((uint32_t)(arg1[26]) << 16);
  x7 = ((uint32_t)(arg1[25]) << 8);
  x8 = (arg1[24]);
  x9 = ((uint32_t)(arg1[23]) << 24);
  x10 = ((uint32_t)(arg1[22]) << 16);
  x11 = ((uint32_t)(arg1[21]) << 8);
  x12 = (arg1[20]);
  x13 = ((uint32_t)(arg1[19]) << 24);
  x14 = ((uint32_t)(arg1[18]) << 16);
  x15 = ((uint32_t)(arg1[17]) << 8);
  x16 = (arg1[16]);
  x17 = ((uint32_t)(arg1[15]) << 24);
  x18 = ((uint32_t)(arg1[14]) << 16);
  x19 = ((uint32_t)(arg1[13]) << 8);
  x20 = (arg1[12]);
  x21 = ((uint32_t)(arg1[11]) << 24);
  x22 = ((uint32_t)(arg1[10]) << 16);
  x23 = ((uint32_t)(arg1[9]) << 8);
  x24 = (arg1[8]);
  x25 = ((uint32_t)(arg1[7]) << 24);
  x26 = ((uint32_t)(arg1[6]) << 16);
  x27 = ((uint32_t)(arg1[5]) << 8);
  x28 = (arg1[4]);
  x29 = ((uint32_t)(arg1[3]) << 24);
  x30 = ((uint32_t)(arg1[2]) << 16);
  x31 = ((uint32_t)(arg1[1]) << 8);
  x32 = (arg1[0]);
  x33 = (x31 + (uint32_t)x32);
  x34 = (x30 + x33);
  x35 = (x29 + x34);
  x36 = (x27 + (uint32_t)x28);
  x37 = (x26 + x36);
  x38 = (x25 + x37);
  x39 = (x23 + (uint32_t)x24);
  x40 = (x22 + x39);
  x41 = (x21 + x40);
  x42 = (x19 + (uint32_t)x20);
  x43 = (x18 + x42);
  x44 = (x17 + x43);
  x45 = (x15 + (uint32_t)x16);
  x46 = (x14 + x45);
  x47 = (x13 + x46);
  x48 = (x11 + (uint32_t)x12);
  x49 = (x10 + x48);
  x50 = (x9 + x49);
  x51 = (x7 + (uint32_t)x8);
  x52 = (x6 + x51);
  x53 = (x5 + x52);
  x54 = (x3 + (uint32_t)x4);
  x55 = (x2 + x54);
  x56 = (x1 + x55);
  out1[0] = x35;
  out1[1] = x38;
  out1[2] = x41;
  out1[3] = x44;
  out1[4] = x47;
  out1[5] = x50;
  out1[6] = x53;
  out1[7] = x56;
}

/*
 * The function fiat_25519_scalar_set_one returns the field element one in the Montgomery domain.
 *
 * Postconditions:
 *   eval (from_montgomery out1) mod m = 1 mod m
 *   0 ≤ eval out1 < m
 *
 */
static FIAT_25519_SCALAR_FIAT_INLINE void fiat_25519_scalar_set_one(fiat_25519_scalar_montgomery_domain_field_element out1) {
  out1[0] = UINT32_C(0x8d98951d);
  out1[1] = UINT32_C(0xd6ec3174);
  out1[2] = UINT32_C(0x737dcf70);
  out1[3] = UINT32_C(0xc6ef5bf4);
  out1[4] = UINT32_C(0xfffffffe);
  out1[5] = UINT32_C(0xffffffff);
  out1[6] = UINT32_C(0xffffffff);
  out1[7] = UINT32_C(0xfffffff);
}

/*
 * The function fiat_25519_scalar_msat returns the saturated representation of the prime modulus.
 *
 * Postconditions:
 *   twos_complement_eval out1 = m
 *   0 ≤ eval out1 < m
 *
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 */
static FIAT_25519_SCALAR_FIAT_INLINE void fiat_25519_scalar_msat(uint32_t out1[9]) {
  out1[0] = UINT32_C(0x5cf5d3ed);
  out1[1] = UINT32_C(0x5812631a);
  out1[2] = UINT32_C(0xa2f79cd6);
  out1[3] = UINT32_C(0x14def9de);
  out1[4] = 0x0;
  out1[5] = 0x0;
  out1[6] = 0x0;
  out1[7] = UINT32_C(0x10000000);
  out1[8] = 0x0;
}

/*
 * The function fiat_25519_scalar_divstep computes a divstep.
 *
 * Preconditions:
 *   0 ≤ eval arg4 < m
 *   0 ≤ eval arg5 < m
 * Postconditions:
 *   out1 = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then 1 - arg1 else 1 + arg1)
 *   twos_complement_eval out2 = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then twos_complement_eval arg3 else twos_complement_eval arg2)
 *   twos_complement_eval out3 = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then ⌊(twos_complement_eval arg3 - twos_complement_eval arg2) / 2⌋ else ⌊(twos_complement_eval arg3 + (twos_complement_eval arg3 mod 2) * twos_complement_eval arg2) / 2⌋)
 *   eval (from_montgomery out4) mod m = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then (2 * eval (from_montgomery arg5)) mod m else (2 * eval (from_montgomery arg4)) mod m)
 *   eval (from_montgomery out5) mod m = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then (eval (from_montgomery arg4) - eval (from_montgomery arg4)) mod m else (eval (from_montgomery arg5) + (twos_complement_eval arg3 mod 2) * eval (from_montgomery arg4)) mod m)
 *   0 ≤ eval out5 < m
 *   0 ≤ eval out5 < m
 *   0 ≤ eval out2 < m
 *   0 ≤ eval out3 < m
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0xffffffff]
 *   arg2: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 *   arg3: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 *   arg4: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 *   arg5: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffff]
 *   out2: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 *   out3: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 *   out4: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 *   out5: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 */
static FIAT_25519_SCALAR_FIAT_INLINE void fiat_25519_scalar_divstep(uint32_t* out1, uint32_t out2[9], uint32_t out3[9], uint32_t out4[8], uint32_t out5[8], uint32_t arg1, const uint32_t arg2[9], const uint32_t arg3[9], const uint32_t arg4[8], const uint32_t arg5[8]) {
  uint32_t x1;
  fiat_25519_scalar_uint1 x2;
  fiat_25519_scalar_uint1 x3;
  uint32_t x4;
  fiat_25519_scalar_uint1 x5;
  uint32_t x6;
  uint32_t x7;
  uint32_t x8;
  uint32_t x9;
  uint32_t x10;
  uint32_t x11;
  uint32_t x12;
  uint32_t x13;
  uint32_t x14;
  uint32_t x15;
  uint32_t x16;
  fiat_25519_scalar_uint1 x17;
  uint32_t x18;
  fiat_25519_scalar_uint1 x19;
  uint32_t x20;
  fiat_25519_scalar_uint1 x21;
  uint32_t x22;
  fiat_25519_scalar_uint1 x23;
  uint32_t x24;
  fiat_25519_scalar_uint1 x25;
  uint32_t x26;
  fiat_25519_scalar_uint1 x27;
  uint32_t x28;
  fiat_25519_scalar_uint1 x29;
  uint32_t x30;
  fiat_25519_scalar_uint1 x31;
  uint32_t x32;
  fiat_25519_scalar_uint1 x33;
  uint32_t x34;
  uint32_t x35;
  uint32_t x36;
  uint32_t x37;
  uint32_t x38;
  uint32_t x39;
  uint32_t x40;
  uint32_t x41;
  uint32_t x42;
  uint32_t x43;
  uint32_t x44;
  uint32_t x45;
  uint32_t x46;
  uint32_t x47;
  uint32_t x48;
  uint32_t x49;
  uint32_t x50;
  uint32_t x51;
  fiat_25519_scalar_uint1 x52;
  uint32_t x53;
  fiat_25519_scalar_uint1 x54;
  uint32_t x55;
  fiat_25519_scalar_uint1 x56;
  uint32_t x57;
  fiat_25519_scalar_uint1 x58;
  uint32_t x59;
  fiat_25519_scalar_uint1 x60;
  uint32_t x61;
  fiat_25519_scalar_uint1 x62;
  uint32_t x63;
  fiat_25519_scalar_uint1 x64;
  uint32_t x65;
  fiat_25519_scalar_uint1 x66;
  uint32_t x67;
  fiat_25519_scalar_uint1 x68;
  uint32_t x69;
  fiat_25519_scalar_uint1 x70;
  uint32_t x71;
  fiat_25519_scalar_uint1 x72;
  uint32_t x73;
  fiat_25519_scalar_uint1 x74;
  uint32_t x75;
  fiat_25519_scalar_uint1 x76;
  uint32_t x77;
  fiat_25519_scalar_uint1 x78;
  uint32_t x79;
  fiat_25519_scalar_uint1 x80;
  uint32_t x81;
  fiat_25519_scalar_uint1 x82;
  uint32_t x83;
  fiat_25519_scalar_uint1 x84;
  uint32_t x85;
  uint32_t x86;
  uint32_t x87;
  uint32_t x88;
  uint32_t x89;
  uint32_t x90;
  uint32_t x91;
  uint32_t x92;
  uint32_t x93;
  fiat_25519_scalar_uint1 x94;
  uint32_t x95;
  fiat_25519_scalar_uint1 x96;
  uint32_t x97;
  fiat_25519_scalar_uint1 x98;
  uint32_t x99;
  fiat_25519_scalar_uint1 x100;
  uint32_t x101;
  fiat_25519_scalar_uint1 x102;
  uint32_t x103;
  fiat_25519_scalar_uint1 x104;
  uint32_t x105;
  fiat_25519_scalar_uint1 x106;
  uint32_t x107;
  fiat_25519_scalar_uint1 x108;
  uint32_t x109;
  uint32_t x110;
  fiat_25519_scalar_uint1 x111;
  uint32_t x112;
  fiat_25519_scalar_uint1 x113;
  uint32_t x114;
  fiat_25519_scalar_uint1 x115;
  uint32_t x116;
  fiat_25519_scalar_uint1 x117;
  uint32_t x118;
  fiat_25519_scalar_uint1 x119;
  uint32_t x120;
  fiat_25519_scalar_uint1 x121;
  uint32_t x122;
  fiat_25519_scalar_uint1 x123;
  uint32_t x124;
  fiat_25519_scalar_uint1 x125;
  uint32_t x126;
  uint32_t x127;
  uint32_t x128;
  uint32_t x129;
  uint32_t x130;
  uint32_t x131;
  uint32_t x132;
  uint32_t x133;
  fiat_25519_scalar_uint1 x134;
  uint32_t x135;
  uint32_t x136;
  uint32_t x137;
  uint32_t x138;
  uint32_t x139;
  uint32_t x140;
  uint32_t x141;
  uint32_t x142;
  uint32_t x143;
  uint32_t x144;
  fiat_25519_scalar_uint1 x145;
  uint32_t x146;
  fiat_25519_scalar_uint1 x147;
  uint32_t x148;
  fiat_25519_scalar_uint1 x149;
  uint32_t x150;
  fiat_25519_scalar_uint1 x151;
  uint32_t x152;
  fiat_25519_scalar_uint1 x153;
  uint32_t x154;
  fiat_25519_scalar_uint1 x155;
  uint32_t x156;
  fiat_25519_scalar_uint1 x157;
  uint32_t x158;
  fiat_25519_scalar_uint1 x159;
  uint32_t x160;
  fiat_25519_scalar_uint1 x161;
  uint32_t x162;
  uint32_t x163;
  uint32_t x164;
  uint32_t x165;
  uint32_t x166;
  uint32_t x167;
  uint32_t x168;
  uint32_t x169;
  uint32_t x170;
  fiat_25519_scalar_uint1 x171;
  uint32_t x172;
  fiat_25519_scalar_uint1 x173;
  uint32_t x174;
  fiat_25519_scalar_uint1 x175;
  uint32_t x176;
  fiat_25519_scalar_uint1 x177;
  uint32_t x178;
  fiat_25519_scalar_uint1 x179;
  uint32_t x180;
  fiat_25519_scalar_uint1 x181;
  uint32_t x182;
  fiat_25519_scalar_uint1 x183;
  uint32_t x184;
  fiat_25519_scalar_uint1 x185;
  uint32_t x186;
  fiat_25519_scalar_uint1 x187;
  uint32_t x188;
  fiat_25519_scalar_uint1 x189;
  uint32_t x190;
  fiat_25519_scalar_uint1 x191;
  uint32_t x192;
  fiat_25519_scalar_uint1 x193;
  uint32_t x194;
  fiat_25519_scalar_uint1 x195;
  uint32_t x196;
  fiat_25519_scalar_uint1 x197;
  uint32_t x198;
  fiat_25519_scalar_uint1 x199;
  uint32_t x200;
  fiat_25519_scalar_uint1 x201;
  uint32_t x202;
  fiat_25519_scalar_uint1 x203;
  uint32_t x204;
  fiat_25519_scalar_uint1 x205;
  uint32_t x206;
  uint32_t x207;
  uint32_t x208;
  uint32_t x209;
  uint32_t x210;
  uint32_t x211;
  uint32_t x212;
  uint32_t x213;
  uint32_t x214;
  uint32_t x215;
  uint32_t x216;
  uint32_t x217;
  uint32_t x218;
  uint32_t x219;
  uint32_t x220;
  uint32_t x221;
  uint32_t x222;
  uint32_t x223;
  uint32_t x224;
  uint32_t x225;
  uint32_t x226;
  uint32_t x227;
  uint32_t x228;
  uint32_t x229;
  uint32_t x230;
  fiat_25519_scalar_addcarryx_u32(&x1, &x2, 0x0, (~arg1), 0x1);
  x3 = (fiat_25519_scalar_uint1)((fiat_25519_scalar_uint1)(x1 >> 31) & (fiat_25519_scalar_uint1)((arg3[0]) & 0x1));
  fiat_25519_scalar_addcarryx_u32(&x4, &x5, 0x0, (~arg1), 0x1);
  fiat_25519_scalar_cmovznz_u32(&x6, x3, arg1, x4);
  fiat_25519_scalar_cmovznz_u32(&x7, x3, (arg2[0]), (arg3[0]));
  fiat_25519_scalar_cmovznz_u32(&x8, x3, (arg2[1]), (arg3[1]));
  fiat_25519_scalar_cmovznz_u32(&x9, x3, (arg2[2]), (arg3[2]));
  fiat_25519_scalar_cmovznz_u32(&x10, x3, (arg2[3]), (arg3[3]));
  fiat_25519_scalar_cmovznz_u32(&x11, x3, (arg2[4]), (arg3[4]));
  fiat_25519_scalar_cmovznz_u32(&x12, x3, (arg2[5]), (arg3[5]));
  fiat_25519_scalar_cmovznz_u32(&x13, x3, (arg2[6]), (arg3[6]));
  fiat_25519_scalar_cmovznz_u32(&x14, x3, (arg2[7]), (arg3[7]));
  fiat_25519_scalar_cmovznz_u32(&x15, x3, (arg2[8]), (arg3[8]));
  fiat_25519_scalar_addcarryx_u32(&x16, &x17, 0x0, 0x1, (~(arg2[0])));
  fiat_25519_scalar_addcarryx_u32(&x18, &x19, x17, 0x0, (~(arg2[1])));
  fiat_25519_scalar_addcarryx_u32(&x20, &x21, x19, 0x0, (~(arg2[2])));
  fiat_25519_scalar_addcarryx_u32(&x22, &x23, x21, 0x0, (~(arg2[3])));
  fiat_25519_scalar_addcarryx_u32(&x24, &x25, x23, 0x0, (~(arg2[4])));
  fiat_25519_scalar_addcarryx_u32(&x26, &x27, x25, 0x0, (~(arg2[5])));
  fiat_25519_scalar_addcarryx_u32(&x28, &x29, x27, 0x0, (~(arg2[6])));
  fiat_25519_scalar_addcarryx_u32(&x30, &x31, x29, 0x0, (~(arg2[7])));
  fiat_25519_scalar_addcarryx_u32(&x32, &x33, x31, 0x0, (~(arg2[8])));
  fiat_25519_scalar_cmovznz_u32(&x34, x3, (arg3[0]), x16);
  fiat_25519_scalar_cmovznz_u32(&x35, x3, (arg3[1]), x18);
  fiat_25519_scalar_cmovznz_u32(&x36, x3, (arg3[2]), x20);
  fiat_25519_scalar_cmovznz_u32(&x37, x3, (arg3[3]), x22);
  fiat_25519_scalar_cmovznz_u32(&x38, x3, (arg3[4]), x24);
  fiat_25519_scalar_cmovznz_u32(&x39, x3, (arg3[5]), x26);
  fiat_25519_scalar_cmovznz_u32(&x40, x3, (arg3[6]), x28);
  fiat_25519_scalar_cmovznz_u32(&x41, x3, (arg3[7]), x30);
  fiat_25519_scalar_cmovznz_u32(&x42, x3, (arg3[8]), x32);
  fiat_25519_scalar_cmovznz_u32(&x43, x3, (arg4[0]), (arg5[0]));
  fiat_25519_scalar_cmovznz_u32(&x44, x3, (arg4[1]), (arg5[1]));
  fiat_25519_scalar_cmovznz_u32(&x45, x3, (arg4[2]), (arg5[2]));
  fiat_25519_scalar_cmovznz_u32(&x46, x3, (arg4[3]), (arg5[3]));
  fiat_25519_scalar_cmovznz_u32(&x47, x3, (arg4[4]), (arg5[4]));
  fiat_25519_scalar_cmovznz_u32(&x48, x3, (arg4[5]), (arg5[5]));
  fiat_25519_scalar_cmovznz_u32(&x49, x3, (arg4[6]), (arg5[6]));
  fiat_25519_scalar_cmovznz_u32(&x50, x3, (arg4[7]), (arg5[7]));
  fiat_25519_scalar_addcarryx_u32(&x51, &x52, 0x0, x43, x43);
  fiat_25519_scalar_addcarryx_u32(&x53, &x54, x52, x44, x44);
  fiat_25519_scalar_addcarryx_u32(&x55, &x56, x54, x45, x45);
  fiat_25519_scalar_addcarryx_u32(&x57, &x58, x56, x46, x46);
  fiat_25519_scalar_addcarryx_u32(&x59, &x60, x58, x47, x47);
  fiat_25519_scalar_addcarryx_u32(&x61, &x62, x60, x48, x48);
  fiat_25519_scalar_addcarryx_u32(&x63, &x64, x62, x49, x49);
  fiat_25519_scalar_addcarryx_u32(&x65, &x66, x64, x50, x50);
  fiat_25519_scalar_subborrowx_u32(&x67, &x68, 0x0, x51, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_subborrowx_u32(&x69, &x70, x68, x53, UINT32_C(0x5812631a));
  fiat_25519_scalar_subborrowx_u32(&x71, &x72, x70, x55, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_subborrowx_u32(&x73, &x74, x72, x57, UINT32_C(0x14def9de));
  fiat_25519_scalar_subborrowx_u32(&x75, &x76, x74, x59, 0x0);
  fiat_25519_scalar_subborrowx_u32(&x77, &x78, x76, x61, 0x0);
  fiat_25519_scalar_subborrowx_u32(&x79, &x80, x78, x63, 0x0);
  fiat_25519_scalar_subborrowx_u32(&x81, &x82, x80, x65, UINT32_C(0x10000000));
  fiat_25519_scalar_subborrowx_u32(&x83, &x84, x82, x66, 0x0);
  x85 = (arg4[7]);
  x86 = (arg4[6]);
  x87 = (arg4[5]);
  x88 = (arg4[4]);
  x89 = (arg4[3]);
  x90 = (arg4[2]);
  x91 = (arg4[1]);
  x92 = (arg4[0]);
  fiat_25519_scalar_subborrowx_u32(&x93, &x94, 0x0, 0x0, x92);
  fiat_25519_scalar_subborrowx_u32(&x95, &x96, x94, 0x0, x91);
  fiat_25519_scalar_subborrowx_u32(&x97, &x98, x96, 0x0, x90);
  fiat_25519_scalar_subborrowx_u32(&x99, &x100, x98, 0x0, x89);
  fiat_25519_scalar_subborrowx_u32(&x101, &x102, x100, 0x0, x88);
  fiat_25519_scalar_subborrowx_u32(&x103, &x104, x102, 0x0, x87);
  fiat_25519_scalar_subborrowx_u32(&x105, &x106, x104, 0x0, x86);
  fiat_25519_scalar_subborrowx_u32(&x107, &x108, x106, 0x0, x85);
  fiat_25519_scalar_cmovznz_u32(&x109, x108, 0x0, UINT32_C(0xffffffff));
  fiat_25519_scalar_addcarryx_u32(&x110, &x111, 0x0, x93, (x109 & UINT32_C(0x5cf5d3ed)));
  fiat_25519_scalar_addcarryx_u32(&x112, &x113, x111, x95, (x109 & UINT32_C(0x5812631a)));
  fiat_25519_scalar_addcarryx_u32(&x114, &x115, x113, x97, (x109 & UINT32_C(0xa2f79cd6)));
  fiat_25519_scalar_addcarryx_u32(&x116, &x117, x115, x99, (x109 & UINT32_C(0x14def9de)));
  fiat_25519_scalar_addcarryx_u32(&x118, &x119, x117, x101, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x120, &x121, x119, x103, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x122, &x123, x121, x105, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x124, &x125, x123, x107, (x109 & UINT32_C(0x10000000)));
  fiat_25519_scalar_cmovznz_u32(&x126, x3, (arg5[0]), x110);
  fiat_25519_scalar_cmovznz_u32(&x127, x3, (arg5[1]), x112);
  fiat_25519_scalar_cmovznz_u32(&x128, x3, (arg5[2]), x114);
  fiat_25519_scalar_cmovznz_u32(&x129, x3, (arg5[3]), x116);
  fiat_25519_scalar_cmovznz_u32(&x130, x3, (arg5[4]), x118);
  fiat_25519_scalar_cmovznz_u32(&x131, x3, (arg5[5]), x120);
  fiat_25519_scalar_cmovznz_u32(&x132, x3, (arg5[6]), x122);
  fiat_25519_scalar_cmovznz_u32(&x133, x3, (arg5[7]), x124);
  x134 = (fiat_25519_scalar_uint1)(x34 & 0x1);
  fiat_25519_scalar_cmovznz_u32(&x135, x134, 0x0, x7);
  fiat_25519_scalar_cmovznz_u32(&x136, x134, 0x0, x8);
  fiat_25519_scalar_cmovznz_u32(&x137, x134, 0x0, x9);
  fiat_25519_scalar_cmovznz_u32(&x138, x134, 0x0, x10);
  fiat_25519_scalar_cmovznz_u32(&x139, x134, 0x0, x11);
  fiat_25519_scalar_cmovznz_u32(&x140, x134, 0x0, x12);
  fiat_25519_scalar_cmovznz_u32(&x141, x134, 0x0, x13);
  fiat_25519_scalar_cmovznz_u32(&x142, x134, 0x0, x14);
  fiat_25519_scalar_cmovznz_u32(&x143, x134, 0x0, x15);
  fiat_25519_scalar_addcarryx_u32(&x144, &x145, 0x0, x34, x135);
  fiat_25519_scalar_addcarryx_u32(&x146, &x147, x145, x35, x136);
  fiat_25519_scalar_addcarryx_u32(&x148, &x149, x147, x36, x137);
  fiat_25519_scalar_addcarryx_u32(&x150, &x151, x149, x37, x138);
  fiat_25519_scalar_addcarryx_u32(&x152, &x153, x151, x38, x139);
  fiat_25519_scalar_addcarryx_u32(&x154, &x155, x153, x39, x140);
  fiat_25519_scalar_addcarryx_u32(&x156, &x157, x155, x40, x141);
  fiat_25519_scalar_addcarryx_u32(&x158, &x159, x157, x41, x142);
  fiat_25519_scalar_addcarryx_u32(&x160, &x161, x159, x42, x143);
  fiat_25519_scalar_cmovznz_u32(&x162, x134, 0x0, x43);
  fiat_25519_scalar_cmovznz_u32(&x163, x134, 0x0, x44);
  fiat_25519_scalar_cmovznz_u32(&x164, x134, 0x0, x45);
  fiat_25519_scalar_cmovznz_u32(&x165, x134, 0x0, x46);
  fiat_25519_scalar_cmovznz_u32(&x166, x134, 0x0, x47);
  fiat_25519_scalar_cmovznz_u32(&x167, x134, 0x0, x48);
  fiat_25519_scalar_cmovznz_u32(&x168, x134, 0x0, x49);
  fiat_25519_scalar_cmovznz_u32(&x169, x134, 0x0, x50);
  fiat_25519_scalar_addcarryx_u32(&x170, &x171, 0x0, x126, x162);
  fiat_25519_scalar_addcarryx_u32(&x172, &x173, x171, x127, x163);
  fiat_25519_scalar_addcarryx_u32(&x174, &x175, x173, x128, x164);
  fiat_25519_scalar_addcarryx_u32(&x176, &x177, x175, x129, x165);
  fiat_25519_scalar_addcarryx_u32(&x178, &x179, x177, x130, x166);
  fiat_25519_scalar_addcarryx_u32(&x180, &x181, x179, x131, x167);
  fiat_25519_scalar_addcarryx_u32(&x182, &x183, x181, x132, x168);
  fiat_25519_scalar_addcarryx_u32(&x184, &x185, x183, x133, x169);
  fiat_25519_scalar_subborrowx_u32(&x186, &x187, 0x0, x170, UINT32_C(0x5cf5d3ed));
  fiat_25519_scalar_subborrowx_u32(&x188, &x189, x187, x172, UINT32_C(0x5812631a));
  fiat_25519_scalar_subborrowx_u32(&x190, &x191, x189, x174, UINT32_C(0xa2f79cd6));
  fiat_25519_scalar_subborrowx_u32(&x192, &x193, x191, x176, UINT32_C(0x14def9de));
  fiat_25519_scalar_subborrowx_u32(&x194, &x195, x193, x178, 0x0);
  fiat_25519_scalar_subborrowx_u32(&x196, &x197, x195, x180, 0x0);
  fiat_25519_scalar_subborrowx_u32(&x198, &x199, x197, x182, 0x0);
  fiat_25519_scalar_subborrowx_u32(&x200, &x201, x199, x184, UINT32_C(0x10000000));
  fiat_25519_scalar_subborrowx_u32(&x202, &x203, x201, x185, 0x0);
  fiat_25519_scalar_addcarryx_u32(&x204, &x205, 0x0, x6, 0x1);
  x206 = ((x144 >> 1) | ((x146 << 31) & UINT32_C(0xffffffff)));
  x207 = ((x146 >> 1) | ((x148 << 31) & UINT32_C(0xffffffff)));
  x208 = ((x148 >> 1) | ((x150 << 31) & UINT32_C(0xffffffff)));
  x209 = ((x150 >> 1) | ((x152 << 31) & UINT32_C(0xffffffff)));
  x210 = ((x152 >> 1) | ((x154 << 31) & UINT32_C(0xffffffff)));
  x211 = ((x154 >> 1) | ((x156 << 31) & UINT32_C(0xffffffff)));
  x212 = ((x156 >> 1) | ((x158 << 31) & UINT32_C(0xffffffff)));
  x213 = ((x158 >> 1) | ((x160 << 31) & UINT32_C(0xffffffff)));
  x214 = ((x160 & UINT32_C(0x80000000)) | (x160 >> 1));
  fiat_25519_scalar_cmovznz_u32(&x215, x84, x67, x51);
  fiat_25519_scalar_cmovznz_u32(&x216, x84, x69, x53);
  fiat_25519_scalar_cmovznz_u32(&x217, x84, x71, x55);
  fiat_25519_scalar_cmovznz_u32(&x218, x84, x73, x57);
  fiat_25519_scalar_cmovznz_u32(&x219, x84, x75, x59);
  fiat_25519_scalar_cmovznz_u32(&x220, x84, x77, x61);
  fiat_25519_scalar_cmovznz_u32(&x221, x84, x79, x63);
  fiat_25519_scalar_cmovznz_u32(&x222, x84, x81, x65);
  fiat_25519_scalar_cmovznz_u32(&x223, x203, x186, x170);
  fiat_25519_scalar_cmovznz_u32(&x224, x203, x188, x172);
  fiat_25519_scalar_cmovznz_u32(&x225, x203, x190, x174);
  fiat_25519_scalar_cmovznz_u32(&x226, x203, x192, x176);
  fiat_25519_scalar_cmovznz_u32(&x227, x203, x194, x178);
  fiat_25519_scalar_cmovznz_u32(&x228, x203, x196, x180);
  fiat_25519_scalar_cmovznz_u32(&x229, x203, x198, x182);
  fiat_25519_scalar_cmovznz_u32(&x230, x203, x200, x184);
  *out1 = x204;
  out2[0] = x7;
  out2[1] = x8;
  out2[2] = x9;
  out2[3] = x10;
  out2[4] = x11;
  out2[5] = x12;
  out2[6] = x13;
  out2[7] = x14;
  out2[8] = x15;
  out3[0] = x206;
  out3[1] = x207;
  out3[2] = x208;
  out3[3] = x209;
  out3[4] = x210;
  out3[5] = x211;
  out3[6] = x212;
  out3[7] = x213;
  out3[8] = x214;
  out4[0] = x215;
  out4[1] = x216;
  out4[2] = x217;
  out4[3] = x218;
  out4[4] = x219;
  out4[5] = x220;
  out4[6] = x221;
  out4[7] = x222;
  out5[0] = x223;
  out5[1] = x224;
  out5[2] = x225;
  out5[3] = x226;
  out5[4] = x227;
  out5[5] = x228;
  out5[6] = x229;
  out5[7] = x230;
}

/*
 * The function fiat_25519_scalar_divstep_precomp returns the precomputed value for Bernstein-Yang-inversion (in montgomery form).
 *
 * Postconditions:
 *   eval (from_montgomery out1) = ⌊(m - 1) / 2⌋^(if ⌊log2 m⌋ + 1 < 46 then ⌊(49 * (⌊log2 m⌋ + 1) + 80) / 17⌋ else ⌊(49 * (⌊log2 m⌋ + 1) + 57) / 17⌋)
 *   0 ≤ eval out1 < m
 *
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 */
static FIAT_25519_SCALAR_FIAT_INLINE void fiat_25519_scalar_divstep_precomp(uint32_t out1[8]) {
  out1[0] = UINT32_C(0x36a7cb92);
  out1[1] = UINT32_C(0xd70af844);
  out1[2] = UINT32_C(0xb0b8b159);
  out1[3] = UINT32_C(0x5f71c978);
  out1[4] = UINT32_C(0x74947f1a);
  out1[5] = UINT32_C(0xe76d8169);
  out1[6] = UINT32_C(0xf193e4ff);
  out1[7] = UINT32_C(0x19a2d36);
}
